/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
    "project_type": "javascript",
    // "project_type" indicate the program language of your project, you can ignore this field

    "debugMode"     : 1,
    // "debugMode" possible values :
    //      0 - No message will be printed.
    //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
    //      2 - cc.error, cc.assert, cc.warn will print in console.
    //      3 - cc.error, cc.assert will print in console.
    //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
    //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
    //      6 - cc.error, cc.assert will print on canvas, available only on web.

    "showFPS"       : true,
    // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

    "frameRate"     : 60,
    // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.

    "id"            : "gameCanvas",
    // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

    "renderMode"    : 0,
    // "renderMode" sets the renderer type, only useful on web :
    //      0 - Automatically chosen by engine
    //      1 - Forced to use canvas renderer
    //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

    "engineDir"     : "frameworks/cocos2d-html5/",
    // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
    // but if you are using a single engine file, you can ignore it.

    "modules"       : ["cocos2d"],
    // "modules" defines which modules you will need in your game, it's useful only on web,
    // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
    // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

    "jsList"        : [
    ]
    // "jsList" sets the list of js files in your game.
 }
 *
 */
var isOpenAnySdk = true ;
cc.game.onStart = function(){
    AV.initialize("7oazam0c0hxuhyqhfvv7qp75oqj0050i204zmiiyl7j10dr8", "bbej1agzq8n9allxsf8r318jvht4xc3jor13d8hr8i4mgoim");

    var appKey = "BFBC5EC6-772E-FEFB-4D75-8CEB8D5C0E52";
    var appSecret = "b2e3b5672e0eb32a8bc15335dd1e7cb5";
    var privateKey = "9DDAD59B7410A32FB312BA879914CCC6";
    var oauthLoginServer = "http://oauth.anysdk.com/api/OauthLoginDemo/Login.php";

    if(isOpenAnySdk == true){
    
    if (anysdk) {
        var agent = anysdk.AgentManager.getInstance();
        agent.init(appKey,appSecret,privateKey,oauthLoginServer);
        agent.loadALLPlugin();

        var user_plugin  = agent.getUserPlugin();    //用户系统
        var iap_plugins   = agent.getIAPPlugin();    //支付系统
        var share_plugin = agent.getSharePlugin();    //分享系统
        var ads_plugin   = agent.getAdsPlugin();    //广告系统
        var social_plugin = agent.getSocialPlugin();    //社交系统
        var push_plugin  = agent.getPushPlugin();    //推送系统
        var analytics_plugin = agent.getAnalyticsPlugin(); //统计系统
        analytics_plugin.setDebugMode(false);
        analytics_plugin.setCaptureUncaughtException(true);
    	}
    }
    
    var winSize = cc.director.getWinSize();

    var m = EKCoreManager.getInstance();
    m.width = winSize.width;
    m.height = winSize.height;

    var designHeigh = 512/(winSize.width/winSize.height);

    var designWidth = 384/(winSize.height/winSize.width);
    cc.view.setDesignResolutionSize(512, designHeigh, cc.ResolutionPolicy.EXACT_FIT);
    cc.director.setContentScaleFactor(2);

    cc.loader.resPath = "res/";
    cc.loader.audioPath = "res/";

    cc.view.adjustViewPort(true);
    cc.view.resizeWithBrowserSize(true);

    if (cc.sys.isNative) {
        cc.BuilderReader.setResourcePath("res/");
    }

    cc.Loader.preload([
        "sounds/progressSounds/kaichangdonghua_ufo_1.mp3",
        "sounds/progressSounds/kaichangdonghua_ufo_2.mp3",
        "sounds/progressSounds/let's go.mp3",
        "sounds/progressSounds/im mina.mp3",
        "sounds/progressSounds/im miya.mp3",
        "sounds/progressSounds/kaichangdonghua_1.mp3",
        "sounds/progressSounds/kaichangdonghua_2.mp3"
    ], function(){}, this);

//    cc.view.setDesignResolutionSize(1136, 640, cc.ResolutionPolicy.EXACT_FIT);
//    screenRatio = "177";
//    cc.view.setDesignResolutionSize(1024, 768, cc.ResolutionPolicy.EXACT_FIT);
//    screenRatio = "133"; 
//    cc.view.setDesignResolutionSize(1100, 660, cc.ResolutionPolicy.EXACT_FIT);
//    screenRatio = "166";
//    cc.view.setDesignResolutionSize(1020, 680, cc.ResolutionPolicy.EXACT_FIT);
//    screenRatio = "150";
    
    
    EKCoreManager.getInstance().openAnimation();
    //load resources
//    cc.LoaderScene.preload(g_resources, function () {
//        cc.director.runScene(new HelloWorldScene());
//    }, this);
};
cc.game.run();