/**
 * Created by bran on 14/10/31.
 */

var EKAlertWindow = cc.Layer.extend({
    ctor: function (message, fontSize, type, target, func) {
        this._super();
        var winSize = cc.director.getWinSize();

        this.setupMask();

        this.popoutWindow = cc.BuilderReader.load("popoutWindow", this);
        this.addChild(this.popoutWindow, 1);
        this.popoutWindow.setPosition(winSize.width/2, winSize.height/2);

        if (isLangCN()) {
            if (type === 1) {
                this.confirmButton.setVisible(true);
                this.confirmButton.x = 0;
            } else if (type === 2){
                this.cancelButton.setVisible(true);
            }
        } else {
            if (type === 1) {
                this.confirmButton_eng.setVisible(true);
                this.confirmButton_eng.x = 0;
            } else if (type === 2) {
                this.cancelButton_eng.setVisible(true);
            }
        }

        this.messageLabel.removeFromParent(true);

        var messageLabel = new ccui.Text();
        //messageLabel.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        messageLabel.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        messageLabel.setFontName("FZCuYuan-M03S.ttf");
        messageLabel.setString(message);
        messageLabel.setFontSize(fontSize);
        messageLabel.setTextAreaSize(cc.size(winSize.width*2/5, winSize.height/3));
        messageLabel.ignoreContentAdaptWithSize(false);
        messageLabel.y -= 17;

        this.popoutWindow.addChild(messageLabel);

        this.target = target;
        this.func = func;

        return true;
    },

    "cancelButtonTapped:" : function () {
        this.removeFromParent(true);
    },

    "confirmButtonTapped:" : function () {
        this.func();
        this.removeFromParent(true);
    },

    setupMask : function () {
        var winSize = cc.director.getWinSize();
        this.maskLayout = new ccui.Layout();
        this.maskLayout.setContentSize(winSize.width, winSize.height);
        this.maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        this.maskLayout.setBackGroundColorOpacity(100);
        this.addChild(this.maskLayout, 0);
        this.maskLayout.setTouchEnabled(true);
    }

});