/**
 * Created by bran on 14-9-9.
 */

var EKRewardLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        this.schedule(function () {
            var m = EKCoreManager.getInstance();
            m.currentReminderTickingTime++;
            var remindTimekey = "remindTime";
            var remindTimeNum = parseInt(cc.sys.localStorage.getItem(remindTimekey));
            var remindTime;
            if (remindTimeNum == 0) {
                remindTime = 10 * 60;
            } else if (remindTimeNum == 2) {
                remindTime = 30 * 60;
            } else {
                remindTime = 20 * 60;
            }
            if (m.currentReminderTickingTime == remindTime) {
                m.showGuideWithSoundFiles();
            }
        }, 1);


        this.setupMask();
        this.setupCCB();

        return true;
    },
    setupMask : function () {
        var winSize = cc.director.getWinSize();
        this.maskLayout = new ccui.Layout();
        this.maskLayout.setContentSize(winSize.width, winSize.height);
        this.maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        this.maskLayout.setBackGroundColorOpacity(100);
        this.addChild(this.maskLayout);
        this.maskLayout.setTouchEnabled(true);
    },
    setupCCB : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var modeName;
        var m = EKCoreManager.getInstance();
        switch (m.changeSubLevelIndexToModeNameWithModeIndex(m.currentPlayingLevelIndex, m.currentPlayingSubLevelIndex)) {
            case EKCoreManagerPresentingSection_AssembleWord:
                modeName = "result_word/result_BG";
                break;
            case EKCoreManagerPresentingSection_SpeakingWord:
                modeName = "result_readaloud/result_readaloud_BG";
                break;
            case EKCoreManagerPresentingSection_WrittingLetter:
                modeName = "scrawl_Results/scrawl_result_BG";
                break;
            default :
                break;
        }
        cc.log(m.changeSubLevelIndexToModeNameWithModeIndex(m.currentPlayingLevelIndex, m.currentPlayingSubLevelIndex));
        cc.log("modeName " + modeName);
        cc.log(EKCoreManagerPresentingSection_AssembleWord);
        var reward = cc.BuilderReader.load(modeName, this);
//        reward.setPosition(winSize.width/2, winSize.height/2);
        var playButton = reward.getChildByTag(5);
        playButton.runAction(cc.sequence(
            cc.scaleTo(0.8, 1.2),
            cc.scaleTo(0.8, 1)
        ).repeatForever());

        cc.audioEngine.playEffect("sounds/effect/kids_cheer.mp3");
        this.scheduleOnce(function () {
            cc.audioEngine.playEffect("sounds/effect/kids_cheer.mp3")
        }, 10);

        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            },
            onTouchMoved: function (touch, event) {
                return true;
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(-35, -35, 70, 70);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.playButtonTapped();
                    return true;
                }
            }
        });
        cc.eventManager.addListener(listener, playButton);

        this.star2 = reward.getChildByTag(2);
        this.star3 = reward.getChildByTag(3);

        this.maskLayout.addChild(reward);
    },
    showWithStarNum : function (starNum) {
        if (starNum === 2) {
            this.star3.animationManager.runAnimationsForSequenceNamed("noAnimation");
        } else if (starNum === 1) {
            this.star2.animationManager.runAnimationsForSequenceNamed("noAnimation");
            this.star3.animationManager.runAnimationsForSequenceNamed("noAnimation");
        }
    },
    playButtonTapped : function () {
        cc.log("playButtonTapped");
        this.delegate.willGoToNextSection();
    }
});