/**
 * Created by apple on 14-8-16.
 */

var EKSectionBasicLayer = cc.Layer.extend({
    wordcards : null,
    isShowingSectionMap : false,
    sectionMap : null,
    ctor:function () {
        this._super();
        this.firstSetup();
        return true;
    },
    firstSetup : function() {
        cc.NotificationCenter.getInstance().addObserver(this, this.getCards, "cards", null);
        this.setupMapButton();
        this.setupBackButton();
        // ***********************************
//        this.setupDebugButtons();
        // ***********************************

        this.maskLayout = this.createMaskLayout(cc.color(0, 0, 0));
        this.addChild(this.maskLayout, ZOrder_UI);
        this.maskLayout.setBackGroundColorOpacity(100);
    },
    createMaskLayout : function (color) {
        var winSize = cc.director.getWinSize();
        var maskLayout = new ccui.Layout();
        maskLayout.setContentSize(winSize.width, winSize.height);
        maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        maskLayout.setBackGroundColor(color);
        maskLayout.setVisible(false);
        maskLayout.setTouchEnabled(false);
        return maskLayout;
    },
    getCards : function(obj) {
        this.wordcards = obj;
    },
    setupMapButton : function() {
        var winSize = cc.director.getWinSize();

        var manager = EKCoreManager.getInstance();
        var modeIndex = manager.changeSubLevelIndexToModeNameWithModeIndex(manager.currentPlayingLevelIndex, manager.currentPlayingSubLevelIndex);

        cc.log(" modeIndex " + modeIndex);
        if ( modeIndex==0) {
            var mapSprite = cc.Scale9Sprite.create("all_Ui/map.png");
            this.mapButton = cc.ControlButton.create(mapSprite);
            this.mapButton.setPreferredSize(mapSprite.getOriginalSize());
            this.addChild(this.mapButton, ZOrder_UI+20);
            this.mapButton.setPosition(winSize.width*0.93, winSize.height*0.9);
            this.mapButton.addTargetWithActionForControlEvents(this, this.mapButtonTapped, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
        }
    },
    setupBackButton : function() {
        var winSize = cc.director.getWinSize();

        var buttonSprite = cc.Scale9Sprite.create("all_Ui/backButton.png");
        this.backButton = cc.ControlButton.create(buttonSprite);
        this.backButton.setPreferredSize(buttonSprite.getOriginalSize());
        this.addChild(this.backButton, ZOrder_UI+20);
        this.backButton.setPosition(winSize.width*0.08, winSize.height*0.9);
        this.backButton.addTargetWithActionForControlEvents(this, this.backButtonTapped, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
    },
    setupDebugButtons : function() {
        var winSize = cc.director.getWinSize();

        var buttonSprite = cc.Scale9Sprite.create("all_Ui/backButton.png");
        this.debugButton = cc.ControlButton.create(buttonSprite);
        this.debugButton.setPreferredSize(buttonSprite.getOriginalSize());
        this.addChild(this.debugButton, ZOrder_UI);
        this.debugButton.setPosition(winSize.width*0.08, winSize.height*0.1);
        this.debugButton.addTargetWithActionForControlEvents(this, this.finishThisSection, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
    },
    mapButtonTapped : function() {
        var currentPlayingLevelIndex = EKCoreManager.getInstance().currentPlayingLevelIndex;
        var currentPlayingLetter = EKLevelsName[currentPlayingLevelIndex];
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.logEvent("open the small map", {"lesson" : currentPlayingLetter});
        }
        if(this.isShowingSectionMap){
            this.hideSectionMap();
        }else{
            this.showSectionMap();
            this.sectionMap.mapButtonShake();
            this.setupMaskLayerTouchEvent();
        }
    },
    setupMaskLayerTouchEvent : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var center = target.getParent().convertToNodeSpace(cc.p(winSize.width/2, winSize.height/2));

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.hideSectionMap();
                    cc.eventManager.removeListener(listener);
                }
                return false;
            }
        });
        cc.eventManager.addListener(listener, this.maskLayout);
    },
    backButtonTapped : function() {
        EKCoreManager.getInstance().IsAssembleWord = false;
        if (EKCoreManager.getInstance().currentPlayingSubLevelIndex == 0) {
            EKCoreManager.getInstance().gotoMap();
        } else {
            EKCoreManager.getInstance().currentPlayingSubLevelIndex = -1;
            EKCoreManager.getInstance().gotoNextSectionAuto();
        }
    },
    hideSectionMap : function() {
        var self = this;
        this.isShowingSectionMap = false;
        this.sectionMap.hideCards();
        this.sectionMap.hideMapAppearAnimation();

        this.scheduleOnce(function(){
            self.maskLayout.setVisible(false);
            this.sectionMap.removeFromParent(true);
            this.sectionMap = null;
        }, 1);
    },

    showSectionMap : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        self.maskLayout.setVisible(true);
        this.isShowingSectionMap = true;
        if (!this.sectionMap) {
            this.sectionMap = new EKSectionMap();
            this.sectionMap.setPosition(winSize.width/2, winSize.height/2);
            this.addChild(this.sectionMap, ZOrder_UI);
        }
        this.sectionMap.showCards();
        this.sectionMap.showMapAppearAnimation();
    },
    finishThisSection : function (starNum) {
        var currentSubSectionIndex = EKCoreManager.getInstance().currentPlayingSubLevelIndex;
//        var starNum = 1;
        this.finishThisSectionWithStarNum(starNum);
    },
    finishThisSectionWithStarNum : function (starNum) {
        var m = EKCoreManager.getInstance();
        var starNumKey = "starNum:" + m.currentPlayingLevelIndex + "-" + m.currentPlayingSubLevelIndex;
        var starNumChangeKey = "starNumChanged:" + m.currentPlayingLevelIndex + "-" + m.currentPlayingSubLevelIndex;
        var previousStarNum = parseInt(cc.sys.localStorage.getItem(starNumKey));
        if (previousStarNum && previousStarNum<starNum) {
            cc.sys.localStorage.setItem(starNumKey, starNum);
            cc.sys.localStorage.setItem(starNumChangeKey, true);
        }
        if ( parseInt(m.currentPlayingSubLevelIndex) === 4) {
            this.willGoToNextSection();
        } else {
            this.reward = new EKRewardLayer();
            this.reward.delegate = this;
            this.addChild(this.reward, 200);
            this.reward.showWithStarNum( starNum );
        }
    },
    willGoToNextSection : function () {
        var self = this;
        var m = EKCoreManager.getInstance();
        if ( parseInt(m.currentPlayingSubLevelIndex)===4 && m.isInNormalProcess ) {
            this.setupAndShowPurdah();

            this.scheduleOnce(function () {
                self.showSectionMap();
                self.sectionMap.setLocalZOrder(ZOrder_UI + 23);
                self.sectionMap.startCompletionAnimation();
                if (self.mapButton) {
                    self.mapButton.setLocalZOrder(ZOrder_UI + 24);
                    self.mapButton.setEnabled(false);
                }
            }, 3);
        } else if (m.currentPlayingSubLevelIndex === 4) {
//            this.reward.removeFromParent(true);
            this.setupAndShowPurdah();
            this.scheduleOnce(function () {
                self.purdahOpenAndGoesToStory();
            }, 2);
        } else {
            m.gotoNextSectionAuto();
        }
    },
    setupAndShowPurdah : function () {
        var winSize = cc.director.getWinSize();
        cc.audioEngine.playEffect("sounds/effect/water_up.mp3");
        var waterNode = cc.BuilderReader.load("change scene/lang_up&down");
        this.waterNode = new cc.Node();
        this.waterNode.addChild(waterNode);
        this.waterNode.setPosition(winSize.width/2, winSize.height*(-0.65));
        this.addChild(this.waterNode, ZOrder_UI+20);
        waterNode.animationManager.runAnimationsForSequenceNamed("up2");
        this.waterNode.runAction(cc.sequence(
            cc.moveTo(2.9, cc.p(winSize.width/2, winSize.height*0.65)).easing(cc.easeSineIn())
        ))
    },
    purdahOpenAndGoesToStory : function() {
        var self = this;
        if (this.sectionMap) {
            this.hideSectionMap();
        }

        var dur = 4;
        this.scheduleOnce(function(){
            self.startIn();
        }, 2);

        var m = EKCoreManager.getInstance();
        var latest = m.latestUnlockedLevelAndSubLevel();
        var latestLevel = latest[0];

        cc.log(latestLevel + " " + m.currentPlayingLevelIndex);

        if (latestLevel === m.currentPlayingLevelIndex) {
            var todayLessonUnlockedKey = "todayLessonUnlockedKey";
            var levelUnlocked = parseInt(cc.sys.localStorage.getItem(todayLessonUnlockedKey));
            if (!levelUnlocked) {
                levelUnlocked = 0;
                cc.sys.localStorage.setItem(todayLessonUnlockedKey, levelUnlocked);
            }
            levelUnlocked++;
            cc.sys.localStorage.setItem(todayLessonUnlockedKey, levelUnlocked);

            cc.log("AAA " + levelUnlocked + " " + m.todayMaxLessonNum() );

            if (levelUnlocked === m.todayMaxLessonNum() || m.todayMaxLessonNum() === -1) {
                var todayMaxLevelIndexReachKey = "todayMaxLevelIndexReachKey";
                cc.sys.localStorage.setItem(todayMaxLevelIndexReachKey, (m.currentPlayingLevelIndex+1) );
            }
        }
        m.currentPlayingSubLevelIndex = 0;
        m.safeCheckAndUnlockToLevelAndSubLevel(m.currentPlayingLevelIndex+1, 0);
        this.scheduleOnce(function(){
            for (var i=0; i<self.wordcards.length; i++) {
                var tmp = self.wordcards[i];
                tmp.setVisible(true);
                tmp.runAction(
                    cc.fadeOut(0.5)
                )
            }
        }, 1);

        var scene = new EKStoryMain();
        cc.director.runScene(new cc.TransitionFade(4, scene, cc.color(0, 0, 0)));

    },
    startIn : function() {
        cc.log("startIn");
        var winSize = cc.director.getWinSize();
        this.waterNode.stopAllActions();
        cc.audioEngine.playEffect("sounds/effect/water_down.mp3");
        this.waterNode.getChildren()[0].animationManager.runAnimationsForSequenceNamed("down");
        this.waterNode.runAction(
            cc.moveTo(2, cc.p(winSize.width/2, winSize.height*(-0.6))).easing(cc.easeSineIn())
        );
    }
});