/**
 * Created by apple on 14-8-16.
 */

var EKSectionMap = cc.Layer.extend({
    buttons : null,
    smallMap : null,
    ctor:function () {
        this._super();

        this.setupMap();
        this.setupMapButtons();
        this.refreshButtons();
        this.setupCards();

        var m = EKCoreManager.getInstance();
        var latest = m.latestUnlockedLevelAndSubLevel();
        if (m.currentPlayingLevelIndex < parseInt(latest[0])) {
            this.showStars();
        }
        return true;
    },
    setupMap : function() {
        this.smallMap = cc.BuilderReader.load("sectionMapLayer.ccbi");
        this.addChild(this.smallMap, ZOrder_UI+2);
    },
    setupMapButtons : function() {
        var self = this;
        this.buttons = [];
        var modeOrderDict;
        cc.loader.loadTxt("modeList.json", function(err, data){
            if(err) return console.log("load failed");
            modeOrderDict = JSON.parse(data);
            var lessonIndexString = "lesson" + EKCoreManager.getInstance().currentPlayingLevelIndex;
            var modeOrderArray = modeOrderDict[lessonIndexString];

            for(var i = 1 ; i<5 ; i++) {
                var iconName;
                var kk = parseInt(modeOrderArray[i]);
                switch (kk) {
                    case EKCoreManagerPresentingSection_AssembleWord: //2
                        iconName = "small_map/word_mapIcon.png";
                        break;
                    case EKCoreManagerPresentingSection_SpeakingWord: //3
                        iconName = "small_map/readaloud_mapIcon.png";
                        break;
                    case EKCoreManagerPresentingSection_WrittingLetter: //1
                        iconName = "small_map/writting_mapIcon.png";
                        break;
                    case EKCoreManagerPresentingSection_SentencePattern: //4
                        iconName = "small_map/sentence_mapIcon.png";
                        break;
                    default:
                        break;
                }
                var sprite = cc.Scale9Sprite.create(iconName);
                var button = cc.ControlButton.create(sprite);
                button.setPreferredSize(sprite.getOriginalSize());
                self.smallMap.addChild(button, ZOrder_UI+1);
                cc.log("length "+ self.smallMap.getChildren()[0] + " " + self.smallMap.getChildren()[1].constructor.name);
                button.setPosition(self.smallMap.getChildByTag(i).getPosition());
                button.addTargetWithActionForControlEvents(self, function(j){
                    return function() {
                        self.mapSectionButtonTapped(j);
                    };
                }(i), cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
                button.info = iconName;
                self.buttons.push(button);
                self.smallMap.getChildByTag(i).removeFromParent(true);
            }
        });

    },
    refreshButtons : function() {
        var manager = EKCoreManager.getInstance();
        for (var i=0; i<this.buttons.length; i++) {
            var button = this.buttons[i];
            if (!manager.isLevelUnlockedAndSubLevel(manager.currentPlayingLevelIndex, i+1)) {
                button.setOpacity(140);
                button.setColor(cc.color.GRAY);
            } else {
                button.setOpacity(255);
                button.setColor(cc.color.WHITE);
                if (manager.currentPlayingSubLevelIndex == 0) {
                    button.setTag(100+i);
                }
            }
        }
    },
    showMapAppearAnimation : function() {
        var winSize = cc.director.getWinSize();
        this.smallMap.setPosition(cc.p(-40, -winSize.height-30));
        cc.audioEngine.playEffect("sounds/effect/ui_small_map.mp3");
        this.smallMap.stopAllActions();
        this.smallMap.runAction(
            cc.sequence(
                cc.moveTo(0.8, cc.p(-40, -25)).easing(cc.easeElasticInOut())
            )
        );
    },
    mapSectionButtonTapped : function(index) {
        if (!this.isFinishingTheSection) {
            var manager = EKCoreManager.getInstance();
            manager.isInNormalProcess = false;
            manager.gotoCertainSection(index);

            EKCoreManager.getInstance().isFromSmallMap = true;
            if(isOpenAnySdk == true){
            var agent = anysdk.AgentManager.getInstance();
            var analytics_plugin = agent.getAnalyticsPlugin();

            switch (i) {
                case 1:
                    analytics_plugin.logEvent("enter mode: Lets play with ABC", {"from" : "small map"});
                    break;
                case 2:
                    analytics_plugin.logEvent("enter mode: ABC is running, catch it", {"from" : "small map"});
                    break;
                case 3:
                    analytics_plugin.logEvent("enter mode: Just follow me", {"from" : "small map"});
                    break;
                case 4:
                    analytics_plugin.logEvent("enter mode: Little greedy gator", {"from" : "small map"});
                    break;
                default :
                    break;
            }
            }
        }
    },
    hideMapAppearAnimation : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        cc.audioEngine.playEffect("sounds/effect/ui_small_map.mp3");
        this.smallMap.stopAllActions();
        this.smallMap.runAction(cc.sequence(
            cc.moveTo(0.6, cc.p(-40, -winSize.height-30)).easing(cc.easeBackIn())
        ));
    },
    startCompletionAnimation : function () {
        var winSize = cc.director.getWinSize();
        var self = this;
        this.isFinishingTheSection = true;
        this.showStars();

        var c1 = this.cards[0];
        var c2 = this.cards[1];
        cc.eventManager.pauseTarget(c1);
        cc.eventManager.pauseTarget(c2);

        var dur = 2;
        for (var i=0; i<this.buttons.length; i++) {
            var button = this.buttons[i];
            var ss = this.getStarsForButtonIndex(i);
            button.setEnabled(false);
            button.stopAllActions();
            button.runAction(cc.sequence(
                cc.delayTime(dur),
                cc.spawn(
                    cc.tintTo(0.2, 255, 255, 255),
                    cc.scaleTo(0.4, 1.2).easing(cc.easeBackOut()),
                    cc.scaleTo(0.2, 1)
                )
            ));
            dur += 0.7;
            for (var k=0; k<ss.length; k++) {
                var s = ss[k];
                if (s.isVisible()) {
                    s.setOpacity(0);
                    s.runAction(cc.sequence(
                        cc.delayTime(dur),
                        cc.callFunc(function () {
                            cc.audioEngine.playEffect("sounds/effect/ui_small_map_star_popup.mp3");
                        }),
                        cc.fadeIn(0.2)
                    ));
                    dur += 0.2;
                }
            }
        }
        for (var i=0; i<this.cards.length; i++) {
            var c = this.cards[i];
            c.setScale(0);
            c.setOpacity(0);
            c.setColor(cc.color.WHITE);
            c.runAction(cc.sequence(
                cc.delayTime(dur),
                cc.spawn(
                    cc.scaleTo(0.3, c.m_originalScale).easing(cc.easeBackIn()),
                    cc.fadeIn(0.2)
                )
            ));
            c.isTouchEnable = false;
            dur += 0.4;
        }
        this.currentAnimatingCardIndex = 0;
        var characterNode = new cc.Node();
        var character = cc.BuilderReader.load("after lesson finished/mina_finish");
        this.addChild(characterNode, ZOrder_UI+7);
        characterNode.addChild(character);
        characterNode.setPosition(winSize.width/2, winSize.height*(-0.8));
        characterNode.runAction(cc.sequence(
            cc.delayTime(dur),
            cc.jumpTo(0.4, cc.p(winSize.width*0.1, winSize.height*(-0.4)), winSize.height*0.3, 1),
            cc.callFunc(function(){
                character.animationManager.runAnimationsForSequenceNamed("Default Timeline");
            }),
            cc.delayTime(3),
            cc.callFunc(function(){
                self.shakeCardWithCurrentAnimatingCardIndex();
            }),
            cc.delayTime(2.5),
            cc.callFunc(function(){
                self.shakeCardWithCurrentAnimatingCardIndex();
            }),
            cc.delayTime(3),
            cc.callFunc(function(){
                cc.log("getParent");
                characterNode.runAction(cc.sequence(
                    cc.jumpTo(0.4, cc.p(winSize.width*0.3, winSize.height*(-0.8)), winSize.height*0.3, 1),
                    cc.delayTime(0.4),
                    cc.callFunc(function(){
                        cc.log(" self.getParent() " + self.getParent() );
                        self.getParent().purdahOpenAndGoesToStory();
                    })
                ))
            })
        ));
        this.scheduleOnce(function(){
            cc.audioEngine.playEffect("sounds/progressSounds/lesson_finish_before.mp3");
            this.scheduleOnce(function () {
                cc.audioEngine.playEffect("sounds/" + c1.pName + ".mp3");
                c1.runAction(cc.sequence(
                    cc.rotateTo(0.1, 15),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.2, 15),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.1, 0)
                ))
            }, 3);
            this.scheduleOnce(function () {
                cc.audioEngine.playEffect("sounds/progressSounds/lesson_finish_middle.mp3");
            }, 4.5);
            this.scheduleOnce(function () {
                cc.audioEngine.playEffect("sounds/" + c2.pName + ".mp3");
                c2.runAction(cc.sequence(
                    cc.rotateTo(0.1, 15),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.2, 15),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.1, 0)
                ))
            }, 5.5);
            this.scheduleOnce(function () {
                cc.audioEngine.playEffect("sounds/progressSounds/lesson_finish_after.mp3");
                this.isFinishingTheSection = false;
            }, 7);
        }, dur);
    },
    mapButtonShake : function () {
        var self = this;
        this.scheduleOnce(function () {
            self.buttonAnimation();
        }, 1);
        this.schedule(function () {
            self.buttonAnimation();
        }, 6.5);
    },
    buttonAnimation : function () {
        var dur = 0;
        for (var i=0; i<this.buttons.length; i++) {
            var button = this.buttons[i];
            button.stopAllActions();
            button.runAction(cc.sequence(
                cc.delayTime(dur),
                cc.spawn(
                    cc.tintTo(0.2, 255, 255, 255),
                    cc.scaleTo(0.2, 1.2).easing(cc.easeBackOut())
                ),
                cc.scaleTo(0.2, 1)
            ));
            dur += 0.7;
        }
    },
    shakeCardWithCurrentAnimatingCardIndex : function() {
        var c = this.cards[this.currentAnimatingCardIndex];
        var rotation = 0;
        c.stopAllActions();
        c.runAction(cc.sequence(
            cc.rotateTo(0.1, -rotation),
            cc.rotateTo(0.2,  rotation),
            cc.rotateTo(0.2, -rotation),
            cc.rotateTo(0.2,  rotation),
            cc.rotateTo(0.2, -rotation),
            cc.rotateTo(0.2,  rotation),
            cc.rotateTo(0.1,  0)
        ));
        this.currentAnimatingCardIndex++;
    },
    setupTouchEvent : function(){
        var self = this;
        var winSize = cc.director.getWinSize();

        this.touchingCard = false;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var center = target.getParent().convertToNodeSpace(cc.p(winSize.width/2, winSize.height/2));

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    if (!target.touchingCard) {
                        for (var i=0; i<self.cards.length; i++) {
                            cc.eventManager.pauseTarget(self.cards[i]);
                            cc.eventManager.pauseTarget(self.getParent().maskLayout);
                        }
                        target.touchingCard = true;
                        target.runAction(cc.sequence(
                            cc.spawn(
                                cc.moveTo(0.3, center),
                                cc.scaleTo(0.4, 1).easing(cc.easeBackOut())
                            ),
                            cc.delayTime(2),
                            cc.spawn(
                                cc.moveTo(0.3, target.m_originalPos).easing(cc.easeBackIn()),
                                cc.scaleTo(0.2, target.m_originalScale)
                            ),
                            cc.callFunc(function () {
                                target.touchingCard = false;
                                for (var i=0; i<self.cards.length; i++) {
                                    cc.eventManager.resumeTarget(self.cards[i]);
                                    cc.eventManager.resumeTarget(self.getParent().maskLayout);
                                }
                            })
                        ));
                        cc.audioEngine.playEffect("sounds/" + target.pName + ".mp3")
                    }
                    return true;
                }
                return false;
            }
        });
        for (var i=0; i<this.cards.length; i++) {
            cc.eventManager.addListener(listener.clone(), this.cards[i]);
        }
    },
    characterLeave : function () {

    },
    setupCards : function() {
        var winSize = cc.director.getWinSize();
        this.cards = [];
        var ws = EKCoreManager.getInstance().currentWordInfos()["words"];
        for (var i=0; i<ws.length; i++) {
            var sp = cc.Sprite.create("words_info/" + ws[i].toUpperCase() + ".png");
            sp.setScale(0.4);
            sp.m_originalScale = 0.4;
            this.addChild(sp, ZOrder_UI+6);
            if (i === 0) {
                sp.setPosition(winSize.width/2-sp.getBoundingBox().width/2-10, winSize.height*0.2);
            } else if (i === 1) {
                sp.setPosition(winSize.width/2-sp.getBoundingBox().width/2-10, -winSize.height*0.2);
            }
            this.cards.push(sp);
            sp.pName = ws[i];
            sp.info = "wordcard";
            sp.m_originalPos = sp.getPosition();
            sp.x = sp.x + 200;
            var m = EKCoreManager.getInstance();
            var latest = m.latestUnlockedLevelAndSubLevel();
            if (m.currentPlayingLevelIndex >= latest[0]) {
                sp.setColor(cc.color.GRAY);
                sp.setOpacity(150);
            }
        }
        this.setupTouchEvent();
        cc.NotificationCenter.getInstance().postNotification("cards", this.cards);
    },
    showStars : function () {
        var m = EKCoreManager.getInstance();
        this.stars = [];
        var buttonIndex = 0;
        for (var i=0; i<this.buttons.length; i++) {
            var button = this.buttons[i];
            var starNumKey = "starNum:" + m.currentPlayingLevelIndex + "-" + (buttonIndex+1);
            var num = parseInt(cc.sys.localStorage.getItem(starNumKey));
            var star1 = cc.Sprite.create("small_map/star.png");
            var star2 = cc.Sprite.create("small_map/star.png");
            var star3 = cc.Sprite.create("small_map/star.png");
            star1.setRotation(10);
            star2.setRotation(0);
            star3.setRotation(-10);
            if (num === 1) {
                star2.setVisible(false);
                star3.setVisible(false);
            } else if (num === 2) {
                star3.setVisible(false);
            }
            star1.setTag(buttonIndex);
            star2.setTag(buttonIndex);
            star3.setTag(buttonIndex);
            var di = 30;
            var centerX = 0;
            var centerY = 0;

            if (button.info === "small_map/readaloud_mapIcon.png") {
                centerX = 2.5;
            } else if (button.info === "small_map/word_mapIcon.png") {
                centerX = 12.5;
                centerY = -1;
            } else if (button.info === "small_map/writting_mapIcon.png") {
                centerX = 0;
            } else if (button.info === "small_map/sentence_mapIcon.png") {
                centerX = 0;
                centerY = -1;
            }
            star1.setPosition(button.x-di/2+centerX, button.y-button.getBoundingBox().height*0.62+centerY-10);
            star2.setPosition(button.x+    +centerX, button.y-button.getBoundingBox().height*0.65+centerY-10);
            star3.setPosition(button.x+di/2+centerX, button.y-button.getBoundingBox().height*0.62+centerY-10);

            this.smallMap.addChild(star1);
            this.smallMap.addChild(star2);
            this.smallMap.addChild(star3);
            this.stars.push(star1);
            this.stars.push(star2);
            this.stars.push(star3);
            buttonIndex++;
        }
    },
    getStarsForButtonIndex : function (index) {
        var ss = [];
        for (var i=0; i<this.stars.length; i++) {
            var star = this.stars[i];
            if (star.getTag() === index) {
                ss.push(star);
            }
        }
        return ss;
    },
    hideCards : function () {
        this.unscheduleAllCallbacks();
        for (var i=0; i<this.cards.length; i++) {
            var c = this.cards[i];
            cc.log("resetCardsPos " + c.m_originalPos.x + " " + c.m_originalPos.y);
            c.setPosition(c.m_originalPos);
            c.setScale(c.m_originalScale);
            c.stopAllActions();
            c.runAction(cc.spawn(
                cc.fadeOut(0.3),
                cc.moveTo(0.3, cc.p(c.x+200, c.y)).easing(cc.easeBackIn())
            ));
        }
    },
    showCards : function () {
        for (var i=0; i<this.cards.length; i++) {
            var c = this.cards[i];
            c.stopAllActions();
            c.runAction(cc.spawn(
                cc.fadeIn(0.3),
                cc.moveTo(0.3, c.m_originalPos).easing(cc.easeBackOut())
            ));
        }
    }
//    resetCardsPos : function () {
//        for (var i=0; i<this.cards.length; i++) {
//            var c = this.cards[i];
//            cc.log("resetCardsPos " + c.m_originalPos.x + " " + c.m_originalPos.y);
//            c.setPosition(c.m_originalPos);
//            c.setScale(c.m_originalScale);
//            c.stopAllActions();
//            c.runAction(cc.spawn(
//                cc.fadeTo(0.3, 0),
//                cc.moveTo(0.3, cc.p(c.x+200, c.y)).easing(cc.easeBackIn())
//            ));
//        }
//    }
});