/**
 * Created by apple on 14-8-16.
 */

var EKSectionTransitionLayer = cc.Layer.extend({
    ctor:function (isLevel) {
        this._super();
        var designResolutionSize = cc.view.getDesignResolutionSize();
        var winSize = cc.director.getWinSize();

        cc.log(designResolutionSize.width);
        cc.log(designResolutionSize.height);
        cc.log(winSize.width);
        cc.log(winSize.height);

        var ccbName;
        if (isLevel) {
            ccbName = "feiye/feiye_mian.ccbi";
            EKCoreManager.getInstance().isFromFeiye = true;
        } else {
            ccbName = "senlinye/senlinye_all.ccbi";
        }
        var forest = cc.BuilderReader.load(ccbName, this);
        this.addChild(forest);

        var self = this;
        this.scheduleOnce(function() {
            self.transitionFinish();
        }, 3);

        cc.audioEngine.stopMusic(true);
        cc.audioEngine.stopAllEffects();

        var currentPlayingSubLevelIndex = parseInt(EKCoreManager.getInstance().currentPlayingSubLevelIndex);
        var currentPlayingLevelIndex = parseInt(EKCoreManager.getInstance().currentPlayingLevelIndex);

        cc.log(currentPlayingSubLevelIndex + " " + currentPlayingLevelIndex + " " + EKCoreManager.getInstance().getSettingsMultiLang());

        if (currentPlayingSubLevelIndex === 0) {
            cc.audioEngine.playEffect("sounds/LESSON" + (currentPlayingLevelIndex+1) + ".mp3");
            if ( (EKCoreManager.getInstance().getSettingsMultiLang() === 1) && isLangCN() ) {
                var lessonTitle = cc.Sprite.create("lessonTitleImage/" + (currentPlayingLevelIndex+1) + ".png");
                lessonTitle.setPosition( cc.p(designResolutionSize.width/2, designResolutionSize.height/2) );
                this.addChild(lessonTitle);
            }
        } else {
            cc.loader.loadTxt("modeList.json", function(err, data){
                if(err) return console.log("load failed");
                var modeOrderDict = JSON.parse(data);
                var lessonIndexString = "lesson" + EKCoreManager.getInstance().currentPlayingLevelIndex;
                var modeOrderArray = modeOrderDict[lessonIndexString];
                cc.log("modeOrderArray: " + modeOrderArray );
                var index = parseInt(modeOrderArray[currentPlayingSubLevelIndex]);
                var modeName = EKCoreManager.getInstance().modeNameForLevelIndexAndSubLevel(currentPlayingLevelIndex, index);
                cc.audioEngine.playEffect("sounds/progressSounds/" + modeName + ".mp3");
                cc.log(modeName + " " + mode);
            });

            var mode = EKCoreManager.getInstance().changeSubLevelIndexToModeNameWithModeIndex(currentPlayingLevelIndex, currentPlayingSubLevelIndex);

            var tag1 = mode;
            var tag2 = parseInt(mode + "6");
            var tag3 = parseInt(mode + "7");
            if ( (EKCoreManager.getInstance().getSettingsMultiLang() === 1) && isLangCN() ) {
                forest.getChildByTag(tag1).setVisible(true);
                forest.getChildByTag(tag2).setVisible(true);
                forest.getChildByTag(tag3).setVisible(true);
            } else {
                forest.getChildByTag(tag1).setVisible(true);
                forest.getChildByTag(tag2).setVisible(true);
            }

        }

        return true;
    },

    transitionFinish : function() {
        EKCoreManager.getInstance().sectionTransitionDidFinish();
    }
});

var EKSectionTransitionScene = cc.Scene.extend({
    ctor:function (isLevel) {
        this._super();
        var layer = new EKSectionTransitionLayer(isLevel);
        this.addChild(layer);
    }
});