/**
 * Created by apple on 14-8-15.
 */


var kMaxSectionNum = 5;   //5个模块

var ZOrder_UI = 70;
var ZOder_GAME_FRONT_OBJ = 50;
var ZOder_GAME_MIDDLE_OBJ = 20;
var ZOder_GAME_BACKGROUND_OBJ = 0;

var TouchPrority_UI_SYSTEM = -50;
var TouchPrority_UI_POP = -30;
var TouchPrority_GAME_OBJ = 0;


var EKCoreManagerPresentingSection_Story = 0;             //故事模块
var EKCoreManagerPresentingSection_WrittingLetter = 1;   //写字母模块
var EKCoreManagerPresentingSection_AssembleWord = 2;     //拼单词模块
var EKCoreManagerPresentingSection_SpeakingWord = 3;     //大声读模块
var EKCoreManagerPresentingSection_SentencePattern = 4;   //句型模块

var Debug = false; //测试版

//课程字母
var EKLevelsName = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];

//随机颜色
var kRandomColors = [cc.color.YELLOW, cc.color.RED, cc.color.BLUE, cc.color.GREEN, cc.color.MAGENTA, cc.color.MAGENTA, cc.color.ORANGE];

var EKCoreManager = (function () {
    var instantiated;
    function init() {
        return {
            IsAssembleWord : null,
            init : (function(){

                this.width = 0;
                this.height = 0;
            })(),

            /*单词信息集合
             * {
             *    A:{
             *    title:Get Up and Have Breakfast,
             *    titleCN:起床吃早餐
             *    words:["APPLE","ANT"],
             *    sentences:[["Hello,Apple", "0-2", "sounds/lesson_1_sentence_apple.mp3"], ["Hello,ANT", "0-2","sounds/lesson_1_sentence_ant.mp3"]],
             *    eat:["yes_dage","no_sayno"]
             *    },
             *    {
             *     B:{
             *     ......
             *     }
             *    }
             * }
            */
            wordInfos : function() {
                return this.wordInfoDict;
            },
            
            //当前所学的单词信息
            currentWordInfos : function() {
                return this.wordInfoDict[EKLevelsName[parseInt(this.currentPlayingLevelIndex)]];
            },

            //开场动画
            openAnimation : function () {
                var winSize = cc.director.getWinSize();
                var homeLayer;
                if (winSize.width/winSize.height >= 1.77) {
                    homeLayer = cc.BuilderReader.load('opening/BG_iphone5.ccbi', this);
                    homeLayer.y -= 27;
                } else {
                    homeLayer = cc.BuilderReader.load('opening/BG.ccbi', this);
                }

                var scene = new cc.Scene();
                if(homeLayer != null) {
                    if (winSize.width/winSize.height < 1.77 && winSize.width/winSize.height > 1.5) {
                        homeLayer.setScaleY( (512/384)/(winSize.width/winSize.height) );
                    }
                    scene.addChild(homeLayer);
                }
                cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
                var self = this;

                homeLayer.animationManager.setCompletedAnimationCallback(this, function () {
                    cc.log("homeLayer.animationManager.setCompletedAnimationCallback");
                    self.gotoHome();
                });

                this.currentReminderTickingTime = 0;
                this.currentPlayingLevelIndex = 0;
                this.currentPlayingSubLevelIndex = 0;
            },

            //主页
            gotoHome : function() {
                var homeLayer = cc.BuilderReader.load('home.ccbi', this);
                var scene = new cc.Scene();
                if(homeLayer != null) {
                    scene.addChild(homeLayer);
                }
                cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
            },

            //去商店
            gotoShop : function () {
            	//父母锁
                var parentLock = new EKParentLock( function () {
                    var scene = new EKShopMain();
                    cc.director.runScene(scene);
                } );
                var runningScene = cc.director.getRunningScene();
                runningScene.addChild(parentLock);
//                cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
            },
            
            //刷新在线商品
            refreshOnlineProducts : function () {
                var self = this;
                var ShopItem = AV.Object.extend("ShopItem");
                var query = new AV.Query(ShopItem);
                query.addDescending("posWeight");
                query.find({
                    success: function(results) {
                        cc.log("Successfully retrieved " + results.length + " scores.");
                        // Do something with the returned AV.Object values
                        self.shopItem = results;
                    },
                    error: function(error) {
                        cc.log("Error: " + error.code + " " + error.message);
                    }
                })
            },
            
            //打折课程
            offeringSingleProducts : function() {
                var arr = [];
                if (this.shopItem) {
                    for (var i = 0, num = this.shopItem.length; i < num; i++) {
                        var obj = this.shopItem[i];
                        if (obj.get("type") === "lessons" && obj.get("isReadyForSale") === true) {
                            arr.push(obj);
                        }
                    }
                    return arr;
                }
            },
            
            //商店打折banner
            offeringShopBanners : function () {
                var arr = [];
                if (this.shopItem) {
                    for (var i= 0, num = this.shopItem.length; i<num; i++) {
                        var obj = this.shopItem[i];
                        if (obj.get('type').indexOf("banner") >= 0 && obj.get("isReadyForSale") === true) {
                            arr.push(obj);
                        }
                    }
                    return arr;
                }
            },

            //去父母的主页面（一些信息，设置相关）
            gotoParentMain : function() {
                var scene = new EKParentMain();
                cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
            },
            
            //
            getSettingsMultiLang : function () {
                var multiLangKey = "multiLang";
                var multiLangKeyIndex = parseInt(cc.sys.localStorage.getItem(multiLangKey)) || 1;
                return multiLangKeyIndex;
            },
            
            //去大地图
            gotoMap : function() {
                var mapLayer;

                var winSize = cc.director.getWinSize();

                if (winSize.width/winSize.height > 1.77) {
                    mapLayer = cc.BuilderReader.load('mapLayer_iphone5.ccbi', this);
                } else if (winSize.width/winSize.height < 1.4) {
                    mapLayer = cc.BuilderReader.load('mapLayer_iPad.ccbi', this);
                } else {
                    mapLayer = cc.BuilderReader.load('mapLayer.ccbi', this);
                }

                var scene = new cc.Scene();
                if(mapLayer != null) {
                    scene.addChild(mapLayer);
                }
                cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
            },
            
            //开始学习某一课
            gotoStoryMain : function() {
                this.currentPlayingSubLevelIndex = this.changeModeNameToSubLevelIndexWithMode(this.currentPlayingLevelIndex, EKCoreManagerPresentingSection_Story);
                this.startSectionTransition(true);
            },
            
            //modeName（枚举）对应的模块处于课程lessonIndex（有很多模块）中的位置
            changeModeNameToSubLevelIndexWithMode : function(lessonIndex, modeName) {
                var modeOrderArray = null;
                if (this.modeOrderDict) {
                    var lessonIndexString = "lesson" + lessonIndex;
                    modeOrderArray = this.modeOrderDict[lessonIndexString];
                    cc.log(this.modeOrderDict + " " + modeOrderArray);
                } else {
                    return 0;
                }
                var i=0;
                while(true){
                    if (modeOrderArray[i] == modeName) {
                        break;
                    }
                    i++;
                }
                return i;
            },
            
            //课程lessonIndex中modeIndex所对应的模块名字（枚举）
            changeSubLevelIndexToModeNameWithModeIndex : function(lessonIndex, modeIndex) {
                var modeOrderArray = null;
                if (this.modeOrderDict) {
                    var lessonIndexString = "lesson" + lessonIndex;
                    modeOrderArray = this.modeOrderDict[lessonIndexString];
                } else {
                    return 0;
                }
                return parseInt(modeOrderArray[modeIndex]);
            },
            
            //开始场景过渡，isLevel表示是否切换到新的一课
            startSectionTransition : function(isLevel) {
                var scene = new EKSectionTransitionScene(isLevel);
                var cf = cc.TransitionFade(0.4, scene);
                cc.director.runScene(cf);
            },
            
            //完成场景过渡的切换
            sectionTransitionDidFinish : function() {
                var latest = this.latestUnlockedLevelAndSubLevel();
                var level = latest[0];
                var subLevel = latest[1];
                var scene;
                switch (this.changeSubLevelIndexToModeNameWithModeIndex(this.currentPlayingLevelIndex, this.currentPlayingSubLevelIndex)) {
                    case EKCoreManagerPresentingSection_Story:
                    case "0":
                        if(subLevel>0) {
                            this.unlockToLevelAndSubLevel(level, 0);
                        }
                        scene = new EKStoryMain();                      //故事页面
                        break;
                    case EKCoreManagerPresentingSection_AssembleWord:
                    case "2":
                        scene = new EKAssembleWordMain();              //拼单词
                        break;
                    case EKCoreManagerPresentingSection_SpeakingWord:
                    case "3":
                        scene = new EKReadAloud();                     //大声读
                        break;
                    case EKCoreManagerPresentingSection_WrittingLetter:
                    case "1":
                        var l = EKLevelsName[this.currentPlayingLevelIndex];
                        var straights = "AEFHIKLMNTVWXYZ";
                        if (straights.indexOf(l) !== -1) {
                            scene = new EKWrittingLetterMain();        //写直线字母
                        } else {
                            scene = new EKWrittingLetterMode2();      //写弯曲字母
                        }
                        break;
                    case EKCoreManagerPresentingSection_SentencePattern:
                    case "4":
                        scene = new EKSentencePatternMain();            //句型
                        break;
                    default:
                        break;
                }
                
                if (scene) {
                    cc.director.runScene(new cc.TransitionFade(0.4, scene, cc.color(0, 0, 0)));
                }
            },
            
            //最后解锁的课程
            latestUnlockedLevelAndSubLevel : function() {
                var key = "level";
                var level = cc.sys.localStorage.getItem(key);
                if (!level) {
                    level = "0,0";
                    
                    //测试
                    if(Debug == true)
                    {
                    	level = "25, 0";
                    }
                    
                    //level = "25,0"; //test
                    level = cc.sys.localStorage.setItem(key, level);
                    return [0, 0];
                }

                var latestLevelIndex = parseInt(level.split(",")[0]);
                var latestSubLevelIndex = parseInt(level.split(",")[1]);
                return [latestLevelIndex, latestSubLevelIndex];
            },
            
            //解锁
            unlockToLevelAndSubLevel : function(levelIndex, subLevelIndex) {
                var key = "level";
                cc.sys.localStorage.setItem(key, levelIndex+","+subLevelIndex);
            },
            
            //去下一场景
            gotoNextSectionAuto : function() {
            	//点击返回按钮
                if ( !this.isInNormalProcess ) {
                    this.currentPlayingSubLevelIndex = 0;
                    this.isReturnFromSectionSelecting = true;
                    this.sectionTransitionDidFinish();
                    return;
                }
                
                this.currentPlayingSubLevelIndex++;
                cc.log("currentPlayingSubLevelIndex " + this.currentPlayingSubLevelIndex);
                var modeName = this.modeNameForLevelIndexAndSubLevel(this.currentPlayingLevelIndex, this.changeSubLevelIndexToModeNameWithModeIndex(this.currentPlayingLevelIndex, this.currentPlayingSubLevelIndex));

                //完成课程，回到故事模块
                if ( this.isInNormalProcess && this.currentPlayingSubLevelIndex>=kMaxSectionNum ){
                    this.currentPlayingSubLevelIndex = 0;
                    this.safeCheckAndUnlockToLevelAndSubLevel(this.currentPlayingLevelIndex+1, 0);
                    var story = new EKStoryMain();
                    cc.director.runScene(story);
                    return;
                }
                
                //
                if ( this.currentPlayingSubLevelIndex>=kMaxSectionNum ) {
                    this.currentPlayingSubLevelIndex = this.changeModeNameToSubLevelIndexWithMode(this.currentPlayingLevelIndex, 0);
                    this.safeCheckAndUnlockToLevelAndSubLevel(this.currentPlayingLevelIndex+1, 0);
                } else {
                    this.safeCheckAndUnlockToLevelAndSubLevel(this.currentPlayingLevelIndex, this.currentPlayingSubLevelIndex);
                }

                //课程的第一部分
                if ( this.currentPlayingSubLevelIndex==0 ) {
                    this.sectionTransitionDidFinish();
                    return;
                }
                
                //过渡场景
                this.startSectionTransition(false);
            },
            
            //去某一场景
            gotoCertainSection : function(subLevelIndex) {
                this.currentPlayingSubLevelIndex = subLevelIndex;
                if (this.currentPlayingSubLevelIndex >= kMaxSectionNum) {
                    this.currentPlayingSubLevelIndex = this.changeModeNameToSubLevelIndexWithMode(this.currentPlayingLevelIndex, 0);
                    this.safeCheckAndUnlockToLevelAndSubLevel(this.currentPlayingLevelIndex+1, 0);
                } else {
                    this.safeCheckAndUnlockToLevelAndSubLevel(this.currentPlayingLevelIndex, this.currentPlayingSubLevelIndex);
                }
                this.startSectionTransition(false);

                if (!this.isFromSmallMap) {
                	if(isOpenAnySdk == true){
                    var agent = anysdk.AgentManager.getInstance();
                    var analytics_plugin = agent.getAnalyticsPlugin();
                    switch (subLevelIndex) {
                        case 1:
                            analytics_plugin.logEvent("enter mode: Lets play with ABC", {"from" : "scene letter"});
                            break;
                        case 2:
                            analytics_plugin.logEvent("enter mode: ABC is running, catch it", {"from" : "scene letter"});
                            break;
                        case 3:
                            analytics_plugin.logEvent("enter mode: Just follow me", {"from" : "scene letter"});
                            break;
                        case 4:
                            analytics_plugin.logEvent("enter mode: Little greedy gator", {"from" : "scene letter"});
                            break;
                        default :
                            break;
                    }
                }
                }
            },
            safeCheckAndUnlockToLevelAndSubLevel : function(levelIndex, subLevelIndex) {
                var key = "level";
                if (!this.isLevelUnlockedAndSubLevel(levelIndex, subLevelIndex)) {
                    cc.sys.localStorage.setItem(key, levelIndex + "," + subLevelIndex);
                }
            },
            isLevelUnlockedAndSubLevel : function(levelIndex, subLevelIndex) {
                var key = "level";
                var level = cc.sys.localStorage.getItem(key);
                if (!level) {
                    level = "0,0";
                    
                    if(Debug == true)
                    {
                    	level = "25,0";
                    }
                    //level = "25,0"; //test
                }

                var latestLevelIndex = level.split(",")[0];
                var latestSubLevelIndex = level.split(",")[1];

                if (levelIndex>latestLevelIndex) {
                    return false;
                }
                if (levelIndex<latestLevelIndex) {
                    return true;
                }
                if ( levelIndex==latestLevelIndex ) {
                    return (subLevelIndex <= latestSubLevelIndex);
                }
                return false;
            },
            modeNameForLevelIndexAndSubLevel : function(levelIndex ,subLevelIndex) {
                var name;
                switch (subLevelIndex) {
                    case 1 || "1":
                        name = "game_xiezimu";
                        break;
                    case 2 || "2":
                        name = "game_pindanci";
                        break;
                    case 3 || "3":
                        name = "game_dashengdu";
                        break;
                    case 4 || "4":
                        name = "game_juxing";
                        break;
                    case 5 || "5":
                        name = "5";
                        break;
                    default:
                        name = "";
                        break;
                }
                return name;
            },
            todayMaxLessonNum : function() {
                var lessonNumKey = "dayLessonNum";
                var lessonNumKeyIndex = parseInt(cc.sys.localStorage.getItem(lessonNumKey));
                var todayLessonMax = 2;
                switch (lessonNumKeyIndex) {
                    case 0:
                        todayLessonMax = 1;
                        break;
                    case 1:
                        todayLessonMax = 2;
                        break;
                    case 2:
                        todayLessonMax = -1;
                        break;
                    default:
                        todayLessonMax = 2;
                        break;
                }

                return todayLessonMax;
            },
            isLevelPurchasedInSubLevel : function(levelIndex, subLevelIndex) {
                var key = "purchased";
                var level = cc.sys.localStorage.getItem(key);
                if (!level || level.indexOf(",") === -1) {
                	level = "2,0";  //正常流程
                	if(Debug == true)
                	{
                		level = "25,0";
                	}
                	//level = "25,0"; //test

                    cc.sys.localStorage.setItem(key, level);
                }

                var latestLevelIndex = parseInt(level.split(",")[0]);
                var latestSubLevelIndex = parseInt(level.split(",")[1]);
                if (levelIndex>latestLevelIndex) {
                    return false;
                }
                if (levelIndex<latestLevelIndex) {
                    return true;
                }
                if(levelIndex==latestLevelIndex){
                    if(subLevelIndex<=latestSubLevelIndex){
                        return true;
                    }
                    return false;
                }
                return false;
            },

            addMiCoinToUser : function (num) {
                var numOfMiCoin = parseInt(cc.sys.localStorage.getItem("MyCoin")) || 0;
                numOfMiCoin += parseInt(num);
                cc.sys.localStorage.setItem("MyCoin", numOfMiCoin);
            },

            showGuideWithSoundFiles : function () {
                cc.log("showGuideWithSoundFiles");
                var winSize = cc.director.getWinSize();
                var guide = cc.BuilderReader.load("tired/panda_tired");
                guide.stopAllActions();
                var scene = cc.director.getRunningScene();
                var layer =  new cc.LayerColor(cc.color(0,0,0,100));
                scene.addChild(layer, 2);
                layer.addChild(guide);
                var pos = cc.p(winSize.width-90, 90);
                guide.setPosition(cc.p(pos.x+150, pos.y));
                guide.runAction(cc.sequence(
                    cc.moveTo(0.7, pos),
                    cc.delayTime(0.2),
                    cc.callFunc(function () {
                        guide.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    })
                ));
                var listener1 = cc.EventListener.create({
                    event: cc.EventListener.TOUCH_ONE_BY_ONE,
                    swallowTouches: true,
                    onTouchBegan: function (touch, event) {
                        var target = event.getCurrentTarget();

                        // 获取当前触摸点相对于按钮所在的坐标
                        var locationInNode = target.convertToNodeSpace(touch.getLocation());
                        var s = target.getContentSize();
                        var rect = cc.rect(0, 0, s.width, s.height);

                        if (cc.rectContainsPoint(rect, locationInNode)) {
                            guide.runAction(cc.sequence(
                                cc.moveTo(0.6, cc.p(winSize.width+150, 90)),
                                cc.callFunc(function () {
                                    layer.removeFromParent(true);
                                })
                            ));
                            return true;
                        }
                        return false;
                    }
                });
                cc.eventManager.addListener(listener1, layer);
            }

        };
    }

    return {
        getInstance: function () {
            if (!instantiated) {
                instantiated = init();
            }
            return instantiated;
        }
    };
})();

(function(){
    cc.loader.loadTxt("res/modeList.json", function(err, data){
        if(err) return console.log("load failed");
        cc.log("data " + data);
        EKCoreManager.getInstance().modeOrderDict = JSON.parse(data);
    });
    cc.loader.loadTxt("res/wordsInfo.json", function(err, data){
        if(err) return console.log("load failed");
        cc.log(data);
        EKCoreManager.getInstance().wordInfoDict = JSON.parse(data);
    });
})();