/**
 * Created by apple on 14-9-8.
 */


var EKAssembleWordMainLayer = EKSectionBasicLayer.extend({
    ctor:function () {
        this._super();
        var self = this;
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
        }
        this.setupBackground();
        cc.audioEngine.stopMusic(true);

        this.currentState = 0;
        this.giftArray = _.shuffle(["word/word_rocket","word/word_wahle","word/word_wizard","word/word_dragon"]);

        var manager = EKCoreManager.getInstance();
        var currentWordInfos = manager.currentWordInfos();
        var wordInfos = manager.wordInfos();
        this.wordsToAssemble = currentWordInfos["words"];

        var currentLesson = parseInt(EKCoreManager.getInstance().currentPlayingLevelIndex);
        if ( currentLesson > 0) {
            var ManagerPreWords = wordInfos[EKLevelsName[currentLesson-1]]["words"];
            var preWords = [ManagerPreWords[0], ManagerPreWords[1]];
            Math.random()>0.5?preWords.pop():preWords.shift();
            this.wordsToAssemble = this.wordsToAssemble.concat(preWords);
        }
        this.currentAssembleWordIndex = -1;
        this.scheduleOnce(function(){
            self.showWordCard();
        }, 1);

        this.setupProgressBar();
        this.schedule(this.idleAnimationTick, 5);

        return true;
    },
    setupBackground : function() {
        var winSize = cc.director.getWinSize();
        var bg = cc.Sprite.create("assembleWord/bg.jpg");
        this.addChild(bg);
        bg.setPosition(winSize.width/2, winSize.height/2);

        if (winSize.width/winSize.height >= 1.77 ) {
            bg.setScaleY(0.85);
        }

        this.isCheckingComplete = false;
    },
    showWordCard : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.currentAssembleWordIndex++;
        this.refreshProgressButtonState();
        this.wordToAssemble = this.wordsToAssemble[this.currentAssembleWordIndex];

        cc.log("this.wordsToAssemble" + this.wordsToAssemble);
        cc.log("this.wordsToAssemble" + this.currentAssembleWordIndex);
        cc.log("this.wordsToAssemble" + this.wordToAssemble);

        if (this.currentAssembleWordIndex < this.wordsToAssemble.length) {
            var card = cc.Sprite.create("words_info/" + this.wordsToAssemble[this.currentAssembleWordIndex].toUpperCase() + ".png");
            this.addChild(card, ZOder_GAME_FRONT_OBJ);
            card.setPosition(winSize.width/2, winSize.height*1.5);
            card.runAction(cc.sequence(
                cc.moveTo(0.5, cc.p(winSize.width/2, winSize.height*0.5)).easing(cc.easeBackOut()),
                cc.delayTime(2),
                cc.callFunc(function(){
                    self.showCardFinish();
                }),
                cc.moveTo(0.5, cc.p(winSize.width/2, winSize.height*1.5)).easing(cc.easeOut(0.7))
            ));

            this.scheduleOnce(function(){
                cc.audioEngine.playEffect("sounds/" + this.wordToAssemble + ".mp3")
            }, 0.2)
        } else {
            this.scheduleOnce(function(){
                self.finishThisSection();
            }, 0.9)
        }
    },
    showCardFinish : function() {
        var self = this;
        this.setupScene();
        this.scheduleOnce(function() {
            self.startDismissAnimation();
        }, 0.5);
        this.currentState = 0;
        var toRemove = [];
        var children = this.getChildren();
    },
    setupScene : function() {
        var winSize = cc.director.getWinSize();
        this.wordLetters = [];
        this.underLayingwordLetters = [];
        var colors = kRandomColors;
        colors = _.shuffle(colors);
        for (var i=0, num=this.wordToAssemble.length; i<num ;i++) {
            var letter = this.wordToAssemble[i];

            {
                var underLetterNode = new cc.Node();
                underLetterNode.setContentSize(cc.size(50,50));
                underLetterNode.setAnchorPoint(0.5, 0.5);
                var label2 = cc.Sprite.create("others/" + letter + "_grey-hd.png");
                underLetterNode.addChild(label2);
                this.addChild(underLetterNode, ZOder_GAME_MIDDLE_OBJ-1);
                var underLetterNodeContentSize = underLetterNode.getContentSize();
                label2.setPosition(underLetterNodeContentSize.width/2, underLetterNodeContentSize.height/2);
                var w = 50;
                underLetterNode.setPosition(cc.p((winSize.width-this.wordToAssemble.length*w)/2+w/2+w*i, winSize.height/2));
                underLetterNode.letter = letter;
                underLetterNode.letterSprite = label2;
                this.underLayingwordLetters.push(underLetterNode);
            }

            {
                var assembleWordLetterNode = new cc.Node();
                assembleWordLetterNode.setContentSize(cc.size(50,50));
                assembleWordLetterNode.setAnchorPoint(0.5, 0.5);
                var label = cc.Sprite.create("others/" + letter + "-hd.png");
                assembleWordLetterNode.addChild(label);
                this.addChild(assembleWordLetterNode, ZOder_GAME_MIDDLE_OBJ + 1);
                var assembleWordLetterNodeContentSize = assembleWordLetterNode.getContentSize();
                label.setPosition(assembleWordLetterNodeContentSize.width/2, assembleWordLetterNodeContentSize.height/2);
                var w = 50;
                assembleWordLetterNode.setPosition(cc.p((winSize.width-this.wordToAssemble.length*w)/2+w/2+w*i, winSize.height/2));
                assembleWordLetterNode.letter = letter;
                assembleWordLetterNode.letterSprite = label;
                this.wordLetters.push(assembleWordLetterNode);
            }

            {
                var animationSp = cc.BuilderReader.load("Letter-ani/letter_" + letter);
                animationSp.setScale(0.28);
                animationSp.setVisible(false);
                assembleWordLetterNode.addChild(animationSp, 19);
                assembleWordLetterNode.animationSprite = animationSp;
                animationSp.setPosition(assembleWordLetterNodeContentSize.width/2, assembleWordLetterNodeContentSize.height/2);
                animationSp.animationManager.runAnimationsForSequenceNamed("Default Timeline");
            }
        }
    },
    startDismissAnimation : function() {
        var self = this;
        var numOfLettersToBeAway = 3;
        this.lettersToBeAway = this.wordLetters;
        for (var i=0, num=this.lettersToBeAway.length; i<num; i++) {
            var l = this.lettersToBeAway[i];
            l.m_initialPos = l.getPosition();
            var rotate = Math.random()*20-10;
            var posToBe = this.generateRandomPosInUpperScreenWithoutOverlapping(Math.random() > Math.random());
            var dis = cc.pDistance(posToBe, l.getPosition());
            var speed = 400;
            l.runAction(cc.sequence(
                cc.spawn(
                    cc.rotateTo(0.4, rotate),
                    cc.scaleTo(0.4, 1.2)
                ),
                cc.scaleTo(0.6, 1).easing(cc.easeBounceInOut()),
                cc.delayTime(2+i*0.4),
                cc.spawn(
                    cc.rotateTo(dis/speed, parseInt(dis/speed)*360+rotate*2),
                    cc.moveTo(dis/speed, posToBe)
                ),
                cc.callFunc(function(){
                    cc.audioEngine.playEffect("sounds/effect/pindanci_zimu_mass.mp3");
                })
            ));

            var l2 = this.underLayingwordLetters[i];
            l2.isPlaced = true;
            if (l2.x == l.m_initialPos.x && l2.y == l.m_initialPos.y) {
                l2.isPlaced = false;
            }
            var mina = cc.BuilderReader.load("word/mina_go");
            this.addChild(mina, ZOder_GAME_MIDDLE_OBJ);
            mina.setPosition(-50, 0);
            mina.stopAllActions();
            mina.runAction(cc.sequence(
                cc.delayTime(1.5),
                cc.callFunc(function(){
                    mina.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                }),
                cc.delayTime(2.5),
                cc.callFunc(function(){
                    self.changeStateToCanAssemble();
                })
            ))
        }
    },
    changeStateToCanAssemble : function() {
        this.currentState = 1;
        var self = this;
        for (var i=0, num=this.lettersToBeAway.length; i<num; i++) {
            var l = this.lettersToBeAway[i];
            var listener = cc.EventListener.create({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: true,
                onTouchBegan: function (touch, event) {
                    self.unschedule(self.idleAnimationTick);
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation()); // 获取当前点击点所在相对按钮的位置坐标
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width, s.height);
                    if (cc.rectContainsPoint(rect, locationInNode) && !target.isPlaced) {
                        if (!self.s) {
                            self.currentState = 2;
                            target.animationSprite.setVisible(true);
                            target.letterSprite.setVisible(false);
                            self.soundId = cc.audioEngine.playEffect("sounds/" + target.letter + "_fun.mp3", true);
                            target.setPosition(touch.getLocation().x-20, touch.getLocation().y+20);

                            target.setLocalZOrder(target.getLocalZOrder()+2);

                            return true;
                        }
                    }
                    return false;
                },
                onTouchMoved: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var delta = touch.getDelta();
                    target.x += delta.x;
                    target.y += delta.y;
                },
                onTouchEnded: function (touch, event) {

                        cc.audioEngine.stopAllEffects();

                        self.currentState = 1;
                        var isCorrect = false;
                        var hasOnLetter = false;
                        cc.audioEngine.stopEffect(self.soundId);
                        var target = event.getCurrentTarget();
                        target.stopAllActions();
                        target.letterSprite.stopAllActions();
                        target.animationSprite.setVisible(false);
                        target.letterSprite.setVisible(true);

                        target.setLocalZOrder(target.getLocalZOrder()-2);

                        var locationInNode = touch.getLocation();
                        for (var i= 0, num=self.underLayingwordLetters.length; i<num; i++) {
                            var l = self.underLayingwordLetters[i];
                            if (cc.rectContainsPoint(l.getBoundingBox(), locationInNode)) {
                                cc.log("l.isPlaced " + l.isPlaced + l.letter + target.letter);
                                if (!l.isPlaced && l.letter===target.letter) { // 放在正确的位置
                                    l.isPlaced = true;
                                    target.isPlaced = true;

                                    // 临时：self.s
                                    self.s = true;
                                    self.scheduleOnce(function () {
                                        self.s = false;
                                    }, 0.3);

                                    target.runAction(cc.sequence(
                                        cc.spawn(
                                            cc.rotateTo(0.6, 0),
                                            cc.scaleTo(0.6, 1).easing(cc.easeBackIn()),
                                            cc.moveTo(0.6, l.getPosition())
                                        ),
                                        cc.callFunc(function(){
                                            self.checkComplete();
                                            self.schedule(self.idleAnimationTick, 5);
                                        })
                                    ));
                                    isCorrect = true;
                                } else { // 放在错误的位置
                                    target.runAction(cc.sequence(
                                        cc.spawn(
                                            cc.scaleTo(0.6, 1).easing(cc.easeBackOut()),
                                            cc.moveTo(0.6, cc.p(target.getPositionX()-35, target.getPositionY()-35))
                                        ),
                                        cc.callFunc(function(){
                                            self.schedule(self.idleAnimationTick, 5);
                                        })
                                    ));
                                }
                            } else { //没有放在字母任何上
                                target.runAction(cc.sequence(
                                    cc.scaleTo(0.6, 1).easing(cc.easeBackOut()),
                                    cc.callFunc(function(){
                                        self.schedule(self.idleAnimationTick, 5);
                                    })
                                ));
                            }
                        }
                        if (isCorrect) {
                            cc.audioEngine.playEffect("sounds/effect/pindanci_correct.mp3");
                        } else {
                            cc.audioEngine.playEffect("sounds/effect/pindanci_wrong.mp3");
                        }

                    }

            });
            cc.eventManager.addListener(listener, l);
        }
    },
    stopAutoCCBActions : function(node) {
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            child.stopAllActions();
            this.stopAutoCCBActions(child);
        }
    },
    setupWord : function() {


    },
    idleAnimationTick : function() {
        if (this.currentState === 1) {
            var notPlaced = [];
            for (var i= 0, num=this.lettersToBeAway.length; i<num; i++) {
                var l = this.lettersToBeAway[i];
                if(!l.isPlaced) {
                    notPlaced.push(l);
                }
            }
            notPlaced = _.shuffle(notPlaced);
            if (notPlaced.length!==0) {
                var l = notPlaced[0];
                var rotate = Math.random()*20 - 10;
                l.runAction(cc.sequence(
                    cc.spawn(
                        cc.rotateTo(0.4, rotate),
                        cc.scaleTo(0.4, 1.2)
                    ),
                    cc.scaleTo(0.6, 1).easing(cc.easeBounceOut()),
                    cc.callFunc(function(){
                        l.animationSprite.visible = true;
                        l.letterSprite.visible = false;
                        cc.audioEngine.playEffect("sounds/" + l.letter + "_fun.mp3");
                    }),
                    cc.delayTime(1.5),
                    cc.callFunc(function(){
                        l.animationSprite.visible = false;
                        l.letterSprite.visible = true;
                    })
                ))
            }
        }
    },
    finishThisSection : function() {
        this._super();
        cc.log("game over!");
    },
    generateRandomPosInUpperScreenWithoutOverlapping : function(isUp) {
        var getted = false;
        var maxInterationNum = 100;
        var currentI = 0;
        var p;
        while (!getted && currentI<maxInterationNum) {
            p = this.generateRandomPosInUperScreen(isUp);
            getted = true;
            for (var i= 0, num=this.lettersToBeAway.length; i<num; i++) {
                var l = this.lettersToBeAway[i];
                var dis = cc.pDistance(l.getPosition(), p);
                cc.log("dis " + dis + " " + l.x + " " + l.y);
                if (dis<93){
                    getted = false;
                } else if (this.lettersAwayPosition) {
                    for (var j=0; j<this.lettersAwayPosition.length; j++) {
                        var awayPosition = this.lettersAwayPosition[j];
                        var dis1 = cc.pDistance(awayPosition, p);
                        if (dis1 < 50) {
                            getted = false;
                        }
                    }
                }
                currentI++;
            }
        }
        if (!this.lettersAwayPosition) {
            this.lettersAwayPosition = [];
        }
        this.lettersAwayPosition.push(p);
        return p;
    },
    generateRandomPosInUperScreen : function(isUp) {
        var winSize = cc.director.getWinSize();
        var xDis = 75;
        var yDis = 37.5;
        var pos = cc.p(0,0);
        pos.y =  Math.random() * (winSize.height/2 - xDis - yDis) + yDis;
        if(isUp){
            pos.y = winSize.height-pos.y;
        }
        pos.x = Math.random() * (winSize.width - xDis * 2) + xDis;
        return pos;
    },
    checkComplete : function() {
        var completed = true;
        for (var i= 0, num=this.underLayingwordLetters.length; i<num; i++) {
            var l = this.underLayingwordLetters[i];
            if(!l.isPlaced) {
                completed = false
            }
        }
        if (completed) {
            for (var i=0; i<this.lettersToBeAway.length; i++) {
                var l = this.lettersToBeAway[i];
                l.setPosition(l.m_initialPos);
            }
            this.assembleCompleted();
        }
    },
    assembleCompleted : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        for (var i= 0, num=this.underLayingwordLetters.length; i<num; i++) {
            var n = this.underLayingwordLetters[i];
            n.setVisible(false);
        }

        for (var i= 0, num=this.wordLetters.length; i<num; i++) {
            var l = this.wordLetters[i];
            l.letterSprite.setVisible(false);
            l.animationSprite.setVisible(true);
            l.setRotation(0);
            l.setZOrder(ZOder_GAME_FRONT_OBJ+i);
            var p = cc.p( (winSize.width - this.wordToAssemble.length*35)/2 + 35*i + 35/2,  winSize.height/2 - 15 );
            l.runAction(cc.sequence(
                cc.delayTime(i+1),
                cc.spawn(
                    cc.scaleTo(0.3, 0.6),
                    cc.moveTo(0.3, p)
                )
            ))
        }

        for (var i=0, num=this.wordToAssemble.length; i<num; i++) {
            var l = this.wordToAssemble[i];
            cc.log("l " + l);
            this.scheduleOnce(function() {
                return function (l) {
                    cc.log("l " + l + " " + self.wordToAssemble[i]);
                    cc.audioEngine.playEffect("sounds/" + self.wordToAssemble[parseInt(l)] + "_normal.mp3")
                }
            }(l), i+0.5);
        }

        this.scheduleOnce(function () {
            cc.audioEngine.playEffect("sounds/" + this.wordToAssemble + ".mp3");
        }, i + 1.5);
        this.scheduleOnce(function () {
            self.isCheckingComplete = false;
            self.showGiftAnimal();
        }, i+2.3);
    },
    showGiftAnimal : function () {
        var winSize = cc.director.getWinSize();
        var self = this;
        
        cc.audioEngine.playEffect("sounds/effect/pindanci_finish.mp3");
        if (this.giftAnimal) {
            this.giftAnimal.removeFromParent(true);
            this.giftAnimal = null;
        }
        this.giftAnimal = cc.BuilderReader.load(this.giftArray[0], this);
        this.giftArray.shift();
        this.addChild(this.giftAnimal, 10);
        this.giftAnimal.setPosition(winSize.width/2+15, winSize.height/2-20);
        this.scheduleOnce(function(){
            self.showMinaCheer();
        }, 0.8)
    },
    showMinaCheer : function () {
        var winSize = cc.director.getWinSize();
        var self = this;

        if (this.mina2) {
            this.mina2.removeFromParent(true);
        }
        this.mina2 = cc.BuilderReader.load("word/mina_goodjob2");
        this.addChild(this.mina2, 80);
        this.mina2.setPosition(winSize.width*1.1, -winSize.height*0.3);
        this.stopAutoCCBActions(this.mina2);
        this.mina2.setRotation(-18);
        this.mina2.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.delayTime(1.5),
                    cc.callFunc(function () {
                        self.showGiftAnimalPop();
                    }),
                    cc.scaleTo(0.15, 1)
                ),
                cc.moveTo(0.8, cc.p(winSize.width*0.9, winSize.height*0.1)).easing(cc.easeBackInOut()),
                cc.sequence(
                    cc.delayTime(0.1),
                    cc.scaleTo(0.55, 0.97, 1.25)
                ),
                cc.sequence(
                    cc.delayTime(0.3),
                    cc.scaleTo(0.15, 1, 1)
                ),
                cc.sequence(
                    cc.delayTime(0.65),
                    cc.callFunc(function () {
                        self.mina2.getChildByTag(3).animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        cc.audioEngine.playEffect("sounds/effect/mina_yeah_1.mp3");
                    })
                )
            ),
            cc.delayTime(2.5),
            cc.spawn(
                cc.moveTo(0.9, cc.p(winSize.width*1.1, -winSize.height*0.3)).easing(cc.easeBackInOut()),
                cc.scaleTo(0.4, 0.9, 1.3)
            ),
            cc.callFunc(function () {
                self.mina2.removeFromParent(true);
                self.mina2 = null;
            })
        ))
    },
    showGiftAnimalPop : function () {
        var winSize = cc.director.getWinSize();
        var self = this;

        this.currentState = 0;
        this.lettersToBeAway = [];
        for (var i= 0, num=this.underLayingwordLetters.length; i<num; i++) {
            var l = this.underLayingwordLetters[i];
            l.removeFromParent(true);
        }
        this.underLayingwordLetters = [];
        for (var i= 0, num=this.wordLetters.length; i<num; i++) {
            var l = this.wordLetters[i];
            l.runAction(cc.sequence(
                cc.moveBy(4, cc.p(winSize.width*1.5, 0) )
            ))
        }
        this.wordLetters = [];
        this.giftAnimal.runAction(cc.sequence(
            cc.moveBy(4, cc.p(winSize.width*1.4,0)),
            cc.callFunc(function () {
                self.showWordCard();
                self.giftAnimal.removeFromParent(true);
                self.giftAnimal = null;
            })
        ))
    },
    setupProgressBar : function () {
        var winSize = cc.director.getWinSize();

        this.progressButtons = [];
        var pro = new cc.Node();
        this.addChild(pro ,ZOrder_UI);

        var width = 50; // this.mapButton.getBoundingBox().width;
        pro.setPosition( width, winSize.height );

        for (var i= 0, num=this.wordsToAssemble.length; i<num; i++) {
            var star = cc.Sprite.create("assembleWord/star.png");
            star.setPosition(winSize.width*0.2+winSize.height*0.1*i, winSize.height*1.05);
            this.addChild(star, 1, 90+i);
            this.progressButtons.push(star);
        }
    },
    refreshProgressButtonState : function() {
        var winSize = cc.director.getWinSize();
        for (var i= 0, num=this.progressButtons.length; i<num; i++) {
            var button = this.progressButtons[i];
            if (i === this.currentAssembleWordIndex) {
                var kk = 0;
                switch (this.currentAssembleWordIndex) {
                    case 0:
                        kk = 0.12;
                        break;
                    case 1:
                        kk = 0.075;
                        break;
                    case 2:
                        kk = 0.165;
                        break;
                    case 3:
                        kk = 0.12;
                        break;
                    default:
                        kk = 0;
                        break;
                }
                cc.audioEngine.playEffect("sounds/effect/pindanci_star.mp3");
                button.runAction(cc.sequence(
                    cc.moveTo(0.3, cc.p(button.getPositionX(), button.getPositionY()-winSize.height*kk))
                ));
            }
        }
    },
    activeAllAnimationsForOnceInNode : function (node, isRecursive) {
//        if ( node.animationManager ) {
//            node.animationManager.runAnimationsForSequenceNamed("Default Timeline");
//        }
    },
    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});


var EKAssembleWordMain = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKAssembleWordMainLayer();
        this.addChild(layer);
    }
});