/**
 * Created by apple on 14-8-17.
 */

var EKWrittingLetterMainLayer = EKSectionBasicLayer.extend({
    ctor:function () {
        this._super();
        var self = this;
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
        }
        cc.audioEngine.stopMusic(true);

        this.userCurrentTracingStrokeIndex = 0;
        this.effectState = Math.floor(Math.random()*2);
        this.setupBackground();
        this.aniNodeArray = [];
        this.runningAnimations = [];
        this.maskArray = [];
        cc.loader.loadTxt("res/letter_delay_List.json", function(err, data){
            if(err) return console.log("load failed");
            var dic = JSON.parse(data);
            self.delayTimeArray = dic[EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex]];
        });

        var files = [];
        for (var i=1; i<10; i++) {
            files.push("letters/Ornaments_" + i + ".png");
        }
        files = _.shuffle(files);
        this.giftItemNames = files.slice(0, 3);

        this.setupSceneStrokingMode1();
        this.startFirstShowAnimations();
        this.setupGiftContainer();

        this.setupTouchEvent();

        this.isPlayingSound = false;

        return true;
    },
    setupBackground : function () {
        var winSize = cc.director.getWinSize();
        var backgroundSprite;
        if (this.effectState === 0 ) {
            backgroundSprite = cc.Sprite.create("letters/bg_flower.jpg");
        } else {
        	backgroundSprite = cc.Sprite.create("letters/bg_train.jpg");
        }
        this.addChild(backgroundSprite);
        backgroundSprite.setPosition(winSize.width/2, winSize.height/2);

        if (winSize.width/winSize.height >= 1.77) {
            backgroundSprite.setScaleY(0.85);
        }
    },
    setupSceneStrokingMode1 : function() {
        cc.log("setupSceneStrokingMode1");
        var winSize = cc.director.getWinSize();
        var word = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
        var aniNode1;
        var aniNode2;
        var fileName;
        if (this.effectState === 0) {
            aniNode1 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_flower");
            aniNode1.name = "flower";
            aniNode1.setPosition(winSize.width*0.82, aniNode1.getBoundingBox().height*0.2-winSize.height*0.6);
            this.aniNodeArray.push(aniNode1);

            aniNode2 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_flower2");
            aniNode2.name = "flower2";
            aniNode2.setPosition(winSize.width*0.95, aniNode1.getBoundingBox().height*0.25-winSize.height*0.6);
            this.stopAutoCCBActions(aniNode2);
            this.aniNodeArray.push(aniNode2);
            this.addChild(aniNode2, 50);

            fileName = "letters/letter_" + word + "_otc";
        } else {
            aniNode1 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_traffic light");
            aniNode1.setPosition(winSize.width*0.9, aniNode1.getBoundingBox().height*0.4-winSize.height*0.7);
            this.aniNodeArray.push(aniNode1);
            aniNode1.name = "light";
            aniNode1.state = "red";

            fileName = "letters/letter_" + word + "_train";
        }
        this.addChild(aniNode1, 50);
        this.stopAutoCCBActions(aniNode1);

        var letterCCBNode = cc.BuilderReader.load(fileName);
        this.addChild(letterCCBNode, ZOder_GAME_BACKGROUND_OBJ);
        this.stopAutoCCBActions(letterCCBNode);

//        if (winSize.width/winSize.height >= 1.77) {
//            letterCCBNode.x = letterCCBNode.x - 20;
//            letterCCBNode.y = letterCCBNode.y - 20;
//        }

        this.strokes = [];
        this.strokeSprites = [];
        this.strokeButtons = [];
        this.strokeStartPositions = [];

        var strokeIndex = -1;
        var children = letterCCBNode.getChildren();
        for (var i= 0, num=children.length; i<num; i++) {
            var n = children[i];
            switch (parseInt(n.getTag())) {
                case 2 :  //字母
                    this.letterLabel = n;
                    break;
                case 6 :   //笔画起点
                    strokeIndex++;  //笔画数
                    var stroke = [];
                    stroke.push(n);
                    this.strokes.push(stroke);
                    break;
                case 5 :  //笔画终点
                    if (strokeIndex >= 0) {
                        this.strokes[strokeIndex].push(n);
                    }
                    break;
                case 3 :  //小火车或是藤蔓数目（笔画数）
                    cc.log("n'tag : " + n.getTag());
                    n.setLocalZOrder(11);
                    this.strokeSprites.push(n);
                    break;
                case 9 : //笔画节点
                    var test;
                    if (this.effectState === 0) {
                        test = cc.textureCache.addImage("letters/flower_point.png");
                    } else {
                        test = cc.textureCache.addImage("letters/train_point.png");
                    }
                    var contentSize = test.getContentSize();
                    n.setTexture(test);
                    n.setTextureRect(cc.rect(0, 0, contentSize.width, contentSize.height));
                    n.retain();
                    var p = this.convertToNodeSpace(n.getPosition());
                    n.removeFromParent();
                    this.addChild(n, ZOder_GAME_FRONT_OBJ);
                    n.setPosition(p);
                    this.strokeButtons.push(n);
                    break;
                case 7 :   //for mask
                    this.maskArray.push(n);
                    break;
                default :
                    break;
            }
            // TODO : 适配屏幕
            if (winSize.width/winSize.height >= 1.77) {
                n.setPosition(cc.p(n.getPositionX(), n.getPositionY()-winSize.height*0.17));
            } else {
                n.setPosition(cc.p(n.getPositionX()+winSize.width*0.06, n.getPositionY()-winSize.height*0.07));
            }

//            for (var kk=0; kk<this.strokeSprites.length; kk++) {
//                var stroke = this.strokeSprites[kk];
//                stroke.setLocalZOrder(stroke.getLocalZOrder()-kk);
//            }
        }

        cc.assert(this.letterLabel, "没有字!");
        cc.assert(this.strokes.length === this.strokeSprites.length, "笔画数目与笔画图案数量不一致!");
        cc.assert(this.strokes.length>0, "缺少笔画!");

        this.letterLabel.setOpacity(0);

        this.clipNodes = [];
        for (var i=0; i<this.strokeSprites.length; i++) {
            var clipNode = new cc.ClippingNode();  //根据笔画数创建裁剪节点
            this.clipNodes.push(clipNode);
            this.addChild(clipNode, ZOder_GAME_FRONT_OBJ-1);
            clipNode.setAlphaThreshold(1);
        }
        for (var i=0; i<this.strokes.length; i++) {
            var strokeSprite = this.strokeSprites[i];
            var pts = this.strokes[i];
            var start = pts[0].getPosition();   //笔画的起始点
            strokeSprite.setPosition(start);
            strokeSprite.removeFromParent();
            this.clipNodes[i].addChild(strokeSprite);  //将需要裁剪的笔画加入裁剪节点
            for (var ii=0; ii<this.strokeSprites.length; ii++) {
                var n = this.strokeSprites[ii];
                if (n.getTag() === 6) {  //隐藏小火车或小花
                    n.setVisible(false);
                }
            }
        }
        for (var i=0; i<this.strokeSprites.length; i++) {
            var stencil = new cc.Node();
            var sp = this.strokeSprites[i];
            if (this.effectState === 0) {  //藤蔓
                var newSp = new cc.LayerColor(cc.color(255, 255, 255, 255));
                newSp.setContentSize(sp.getContentSize());
                newSp.setAnchorPoint(sp.getAnchorPoint());
//                newSp.setAnchorPoint(cc.p(0, 0));
                newSp.setRotation(sp.getRotation());
                newSp.setScaleX(sp.getScaleX()*1.5);
                newSp.setScaleY(sp.getScaleY());
                newSp.setPosition(this.strokes[i][0].getPosition());
                stencil.addChild(newSp);
                var clip = this.clipNodes[i];
                clip.setStencil(stencil);
                clip.setInverted(true);

                newSp.x = newSp.x - 30;

            } else {  //小火车
                var tmp = this.maskArray[i];  //遮罩
                var mask1 = cc.Sprite.create("letters/maskInApp/" + word + (i+1) + ".png");
                mask1.setAnchorPoint(tmp.getAnchorPoint());
                mask1.setPosition(tmp.getPosition());
                mask1.setScaleX(tmp.getScaleX());  //源头在这儿
                mask1.setScaleY(tmp.getScaleY());
                mask1.setRotation(tmp.getRotation());
                stencil.addChild(mask1);
                var clip = this.clipNodes[i];
                clip.setStencil(stencil);
                clip.setInverted(false);
                clip.setAlphaThreshold(0.05);
            }
        }

        var miyaCcb;
        switch (Math.floor(Math.random()*2)) {
            case 0 :
                miyaCcb = "scrawl-miya/monster-walking";
                this.stepTace = this.createStrokesCoverSpritesWithTextureFile("letters/step.png");
                break;
            case 1 :
                miyaCcb = "scrawl-miya/scrawl_duck";
                this.stepTace = this.createStrokesCoverSpritesWithTextureFile("letters/step2.png");
                break;
            default :
                break;
        }
        this.miya = new cc.Node();
        var miya = cc.BuilderReader.load(miyaCcb);
        this.miya.addChild(miya);
        this.addChild(this.miya, ZOder_GAME_FRONT_OBJ+3);
        this.addChild(this.stepTace);
    },
    createStrokesCoverSpritesWithTextureFile : function (file) {
        cc.log("createStrokesCoverSpritesWithTextureFile");
        var cover = new cc.Node();
        cover.setAnchorPoint(0,0);
        cover.setPosition(0,0);
        for (var s= 0, num=this.strokes.length; s<num; s++) {
            var arr = this.strokes[s];
            for (var i= 0, num1=arr.length; i<num1; i++) {
                if (i>0) {
                    var n1 = arr[0];
                    var n2 = arr[1];
                    var dis = cc.pDistance(n1.getPosition(), n2.getPosition());
                    var number = dis/15 + 0.5;
                    var angle = angleWithStartAndDestinationPoints(n2.getPosition(), n1.getPosition());
                    for (var n=0; n<number; n++) {
                        var p = cc.pLerp(n1.getPosition(), n2.getPosition(), n/number);
                        var sp = cc.Sprite.create(file);
                        sp.setTag(s);
                        sp.setScale(Math.floor(Math.random()*30+70)/100);
                        sp.setPosition(p);
                        cover.addChild(sp);
                        sp.setRotation(angle);
                        sp.setVisible(false);
                    }
                }
            }
        }
        return cover;
    },
    setupGiftContainer : function () {
        var winSize = cc.director.getWinSize();
        this.giftContainerArray = [];
        this.giftContainer = new cc.Node();
        this.giftContainer.setAnchorPoint(0.5, 0);
        this.giftContainer.setContentSize(cc.size(winSize.width*0.5, 75));

        this.addChild(this.giftContainer, ZOder_GAME_FRONT_OBJ+5);
        this.giftContainer.setPosition(cc.p(winSize.width*0.45, winSize.height*1.1));

        for (var i=0; i<this.giftItemNames.length; i++) {
            var name = this.giftItemNames[i];
            cc.log("name " + name);
            var gift = cc.Sprite.create(name);
            gift.setAnchorPoint(cc.p(0.5, 0.5));
            gift.setScale(1.5);
            this.giftContainer.addChild(gift);
            gift.setPosition(winSize.width*0.15 + winSize.width*0.17*(i-1), 30);
            gift.setTag(i);
            this.giftContainerArray.push(gift);
        }
    },
    showGiftContainer : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var w = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
        cc.audioEngine.playEffect("sounds/" + w + "_normal.mp3");
        this.giftContainer.runAction(cc.sequence(
            cc.moveTo(1.5, cc.p(winSize.width*0.45, 10)).easing(cc.easeBounceOut()),
            cc.delayTime(1),
            cc.callFunc(function () {
                var xiezimuValue = parseInt(cc.sys.localStorage.getItem("xiezimu_xinshou"));
                if ( !xiezimuValue || xiezimuValue<3) {
                    self.startHint();
                    if (!xiezimuValue) {
                        cc.sys.localStorage.setItem("xiezimu_xinshou", 1);
                    } else {
                        var count = parseInt(cc.sys.localStorage.getItem("xiezimu_xinshou"));
                        cc.sys.localStorage.setItem("xiezimu_xinshou", count+1);
                    }
                }
            })
        ));
    },
    startHint : function () {
        var winSize = cc.director.getWinSize();
        var pos = this.giftContainer.getChildByTag(1).getPosition();
        startHintingWithHand(pos, cc.p(winSize.width/2, winSize.height/2), this, 1);
    },
    removeStrokeButton : function() {
        for (var i=0; i<this.strokeButtons.length; i++) {
            var button = this.strokeButtons[i];
            button.runAction(cc.sequence(
                cc.scaleTo(0.7, 1).easing(cc.easeIn(0.7)),
                cc.spawn(
                    cc.scaleTo(0.2, 0.73),
                    cc.fadeOut(0.2)
                )
            ))
        }
    },
    strokeSpriteGoneAndWordAppear : function () {
        var self = this;

        for (var i=0; i<this.strokeSprites.length; i++) {
            var sp = this.strokeSprites[i];
            sp.setVisible(false);
        }
        this.letterLabel.runAction(cc.sequence(
            cc.fadeIn(0.5),
            cc.callFunc(function () {
                self.showGiftContainer();
            })
        ))
    },
    stopAutoCCBActions : function(node) {
        cc.log("stopAutoCCBActions");
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            child.stopAllActions();
            this.stopAutoCCBActions(child);
        }
    },
    startFirstShowAnimations : function () {
        cc.log("startFirstShowAnimations");
        var self = this;
        this.miyaCurrentTracingStrokeIndex = 0;
        this.miyaCurrentTracingStrokePtsIndex = 0;
        for (var i= 0, num=this.strokeButtons.length; i<num; i++) {
            var pts = this.strokeButtons[i];
            pts.setVisible(false);
        }
        var firstButton = this.strokeButtons[0];
        firstButton.setVisible(true);
        firstButton.setScale(2);
        this.miya.setPosition(firstButton.getPosition());
        this.miya.runAction(cc.scaleTo(0.7, 0.8).easing(cc.easeBounceOut()));
        firstButton.runAction(cc.sequence(
            cc.spawn(
                cc.fadeTo(0.4, 255),
                cc.scaleTo(0.7, 0.73).easing(cc.easeBounceOut())
            ),
            cc.callFunc(function(){
                self.miyaTraceToNextPos();
            })
        ));
        this.schedule(this.miyaStepping, 0.1);
    },
    miyaStepping : function () {
        cc.log("miyaStepping");
        var step = this.findNodeWithWorld(this.miya.getPosition(), this.stepTace.getChildren(), 10);
        if (step && !step.isVisible() &&  (step.getTag()==this.miyaCurrentTracingStrokeIndex) ) {
            step.setVisible(true);
            step.setOpacity(0);
            step.runAction(cc.fadeIn(0.2));
        }
    },
    miyaTraceToNextPos : function () {
        cc.log("miyaTraceToNextPos");
        if (this.miyaCurrentTracingStrokeIndex === -1) return;
        var self = this;
        var winSize = cc.director.getWinSize();
        var newStroke = false;
        this.miyaCurrentTracingStrokePtsIndex++;
        if (this.miyaCurrentTracingStrokePtsIndex >= this.strokes[this.miyaCurrentTracingStrokeIndex].length) {
            cc.log("111");
            this.miyaCurrentTracingStrokePtsIndex = 0;
            this.miyaCurrentTracingStrokeIndex++;
            newStroke = true;
            if (this.miyaCurrentTracingStrokeIndex >= this.strokes.length) {
                this.unschedule(this.miyaStepping);
                this.miya.runAction(cc.sequence(
                    cc.jumpTo(0.6, winSize.width*1.3, winSize.height*1.3, winSize.height*0.4, 1),
                    cc.callFunc(function () {
                        self.miyaTracingFinished();
                    })
                ));
                this.miyaCurrentTracingStrokeIndex = -1;
                var w = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
                cc.audioEngine.playEffect("sounds/" + w + "_normal.mp3");
                return;
            }
        }
        var posNode = this.strokes[this.miyaCurrentTracingStrokeIndex][this.miyaCurrentTracingStrokePtsIndex];
        var button;
        if (newStroke) {
            cc.log("222");
            button = this.findNodeWithWorld(posNode.getPosition(), this.strokeButtons, 15);
            if (button && button.isVisible() ) {
                cc.log("333");
                button.runAction(cc.sequence(
                    cc.delayTime(0.2),
                    cc.scaleTo(0.1, 1.3).easing(cc.easeIn(0.7)),
                    cc.scaleTo(0.7, 0.73).easing(cc.easeBounceOut())
                ));
            } else {
                cc.log("444");
                button.setVisible(false);
                button.setScale(1.3);
                button.runAction(cc.sequence(
                    cc.delayTime(0.3),
                    cc.show(),
                    cc.scaleTo(0.1, 0.73).easing(cc.easeBounceOut())
                ));
            }
            this.miya.setPosition(button.getPosition());
            this.miya.runAction(cc.sequence(
                cc.scaleTo(0.17, 0.8).easing(cc.easeOut(1)),
                cc.delayTime(0.2),
                cc.jumpBy(0.3, 0, 0, 10, 1),
                cc.callFunc(function () {
                    self.miya.getChildren()[0].animationManager.runAnimationsForSequenceNamed("run");
                }),
                cc.delayTime(0.2),
                cc.callFunc(function(){
                    self.miyaTraceToNextPos();
                })
            ))
        } else {
            cc.log("555");
            var dis = cc.pDistance(posNode.getPosition(), this.miya.getPosition());
            var dur = dis/75;
            button = this.findNodeWithWorld(posNode.getPosition(), this.strokeButtons, 15);
            button.setScale(1.3);
            button.runAction(cc.sequence(
                cc.delayTime(dur/2),
                cc.show(),
                cc.scaleTo(0.7, 0.73).easing(cc.easeBackOut())
            ));
            this.miya.runAction(cc.sequence(
                cc.moveTo(dur, posNode.getPosition()),
                cc.spawn(
                    cc.sequence(
                        cc.rotateBy(0.06, -20),
                        cc.rotateBy(0.06, 20)
                    ).repeat(6),
                    cc.sequence(
                        cc.delayTime(0.1),
                        cc.scaleTo(0.3, 0).easing(cc.easeIn(0.4))
                    )
                ),
                cc.callFunc(function(){
                    self.miyaTraceToNextPos();
                })
            ))
        }
    },
    miyaTracingFinished : function () {
        var winSize = cc.director.getWinSize();
        for (var i= 0, num= this.aniNodeArray.length; i<num; i++) {
            var node = this.aniNodeArray[i];
            if (this.effectState === 0) {
                node.runAction(cc.sequence(
                    cc.delayTime(0.3*i),
                    cc.moveTo(1, cc.p(node.getPositionX(), node.getPositionY()+winSize.height*0.6)).easing(cc.easeElasticOut())
                ));
            } else {
                node.runAction(cc.sequence(
                    cc.delayTime(0.3*i),
                    cc.moveTo(1, cc.p(node.getPositionX(), node.getPositionY()+winSize.height*0.7)).easing(cc.easeElasticOut())
                ));
            }
        }

        this.miya.removeFromParent(true);
        this.schedule(this.newHand, 5);
        this.touchState = 1;
    },
    newHand : function() {
        var self = this;
        cc.log("newHand Method");
        if (this.userCurrentTracingStrokeIndex === -1) {
            this.unschedule(this.newHand);
        }

        if (this.userCurrentTracingStrokeIndex !== -1 && this.userCurrentTracingStrokeIndex < this.strokes.length) {
            var arr = this.strokes[this.userCurrentTracingStrokeIndex];
            var startNode = arr[0];
            var endNode = arr[1];
            var sprite = this.strokeSprites[this.userCurrentTracingStrokeIndex];
            sprite.runAction(cc.sequence(
                cc.moveTo(2, cc.pLerp(startNode.getPosition(), endNode.getPosition(), 0.5)),
                cc.callFunc(function () {
                    self.animateCurrentStrokeSpriteBackStop_EndButtonEffect_AndResetTouchStateInTheEnd();
                })
            ));
            this.playSound();
        }
    },
    animateCurrentStrokeSpriteBackStop_EndButtonEffect_AndResetTouchStateInTheEnd : function () {
        cc.log("animateCurrentStrokeSpriteBackStop_EndButtonEffect Method");
        if (this.userCurrentTracingStrokeIndex < this.strokes.length) {
            var self = this;
            var arr = this.strokes[this.userCurrentTracingStrokeIndex];
            //移动铁轨或是藤蔓
            var sprite = this.strokeSprites[this.userCurrentTracingStrokeIndex];
            var dur = cc.pDistance(sprite.getPosition(),  arr[0].getPosition()) / 75;

            sprite.runAction(cc.sequence(
                cc.moveTo(Math.max(dur, 0.1), arr[0].getPosition()).easing(cc.easeBounceOut()),
                cc.callFunc(function () {
                    self.touchState = 1;
                })
            ));
            var endButton = this.findNodeWithWorld(arr[1].getPosition(), this.strokeButtons, 10);
            endButton.setScale(0.73);
            endButton.setColor(cc.color.WHITE);

            var children = this.stepTace.getChildren();
            for (var i= 0, num=children.length; i<num; i++) {
                var step = children[i];
                if ( step.getTag()===this.userCurrentTracingStrokeIndex ) {
                    step.runAction(cc.sequence(
                        cc.show(),
                        cc.fadeIn(0.2)
                    ))
                }
            }
        }
    },
    playSound : function () {
        if (this.effectState === 0) {
            cc.audioEngine.playEffect("sounds/effect/xiezimu_vine.mp3");
        } else {
            cc.audioEngine.playEffect("sounds/effect/xiezimu_track.mp3");
        }
    },
    setupTouchEvent : function () {
        var self = this;
        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) 
            {
                cc.log("mouse position: ", touch.getLocation().x, touch.getLocation().y);
                var convertNode = event.getCurrentTarget().convertToNodeSpace(touch.getLocation());
                cc.log("convert to node sapce position", convertNode.x, convertNode.y);
                if (self.touchState===1 )   //正常阶段
                {
                	self.unschedule(self.newHand);  //取消笔画提示 andy add
                	
                    var startNode = self.strokes[self.userCurrentTracingStrokeIndex][0];
                    var endNode =  self.strokes[self.userCurrentTracingStrokeIndex][1];
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var dis = cc.pDistance(locationInNode, startNode.getPosition());
                    if (dis < 30) 
                    {  
                    	//吸附，表示开始写字母
                        self.touchState = 2;
                        var sprite = self.strokeSprites[self.userCurrentTracingStrokeIndex];
                        sprite.stopAllActions();

                        var button = self.findNodeWithWorld(startNode.getPosition(), self.strokeButtons, 10);
                        button.runAction(cc.sequence(
                            cc.scaleTo(0.2, 0.73*1.2),
                            cc.scaleTo(0.2, 0.73)
                        ).repeatForever());

                        var endButton = self.findNodeWithWorld(endNode.getPosition(), self.strokeButtons, 10);
                        endButton.runAction(cc.sequence(
                            cc.scaleTo(0.2, 0.73*1.2),
                            cc.scaleTo(0.2, 0.73)
                        ).repeatForever());
                        endButton.runAction(cc.tintTo(0.1, 255, 255, 0));
                        self.great = false;
                        return true;
                    }
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                if (self.touchState === 2)   //笔画阶段
                {
                	
                    var startNode = self.strokes[self.userCurrentTracingStrokeIndex][0];
                    var endNode =  self.strokes[self.userCurrentTracingStrokeIndex][1];
                    if (!self.isPlayingSound)
                    {
                        var dur;
                        if (self.effectState === 0) {
                            dur = 2.3;
                        } else {
                            dur = 0.8;
                        }

                        self.playSound();
                        self.isPlayingSound = true;
                        self.scheduleOnce(function () {
                            self.isPlayingSound = false;
                        }, 1);
                    }
                    var target = event.getCurrentTarget();
                    var p = target.convertToNodeSpace(touch.getLocation());
                    cc.log("onTouchMoved");
                    cc.log("mouse position", p.x, p.y);
                    sp = startNode.getPosition();
                    cc.log("start  position ", sp.x, sp.y);
                    cc.log("start tag:", startNode.getTag());
                    ep = endNode.getPosition();
                    cc.log("end  position :%f, %f", ep.x, ep.y);
                    cc.log("end tag:", endNode.getTag());
                    
                    
                    var disPToL = distancePointToLine(p, startNode.getPosition(), endNode.getPosition());
                    cc.log("dis " + disPToL);
                    if ( disPToL > 30)  //不在笔画的一定范围内
                    {
                        cc.log("aaa1");
                        self.touchState = 0;
                        self.animateCurrentStrokeSpriteBackStop_EndButtonEffect_AndResetTouchStateInTheEnd(); //笔画回去

                        self.schedule(self.newHand, 5); //5秒后开始笔画提示 andy add
                    } else 
                    {
                        cc.log("aaa2");
                        var pt = getPointCastOnLine(p, startNode.getPosition(), endNode.getPosition());
                        var lineDis = cc.pDistance(startNode.getPosition(), endNode.getPosition());
                        cc.log(pt.x + " " + pt.y + " " + startNode.x + " " + startNode.y + " " + lineDis);
                        //var per = cc.pDistance( pt, cc.p(startNode.x/lineDis, startNode.y/lineDis) );
                        var per = cc.pDistance( pt, startNode.getPosition() ) / cc.pDistance(startNode.getPosition(), endNode.getPosition());
                        cc.log("per :",per);
                        var step = self.findNodeWithWorld(p, self.stepTace.getChildren(), 20);
                        if (step && step.isVisible && step.getTag() === self.userCurrentTracingStrokeIndex && step.getNumberOfRunningActions() === 0) 
                        {
                        	//隐藏脚步
                            cc.log("aaa3");
                            step.runAction(cc.sequence(
                                cc.fadeOut(0.2),
                                cc.hide()
                            ))
                        }
                        //吸附到终点
                        if (cc.pDistance(p, endNode.getPosition()) < 30) {
                            cc.log("aaa4");

                            self.unschedule(self.newHand);

                            cc.audioEngine.playEffect("sounds/effect/xiezimu_right.mp3");
                            var effect = cc.ParticleSystem.create("mode_learningpark_right_effect.plist");
                            self.addChild(effect);
                            effect.setPosition(endNode.getPosition());
                            per = 1;					
                            self.touchState = 1;
                            var endButton = self.findNodeWithWorld(endNode.getPosition(), self.strokeButtons, 10);
                            endButton.stopAllActions();
                            endButton.setScale(0.73);
                            endButton.setColor(cc.color.WHITE);

                            self.endButtonPosition = endButton.getPosition();

                            //小火车或是小藤蔓
                            var sprite = self.strokeSprites[self.userCurrentTracingStrokeIndex];

                            cc.log("sprite position " + sprite.x + " " + sprite.y);
                            sprite.setPosition( endNode.getPosition() );
                            cc.log("sprite position " + sprite.x + " " + sprite.y);
                            self.great = true;

                            var children = self.stepTace.getChildren();
                            for (var i = 0, num = children.length; i < num; i++) {
                                var step1 = children[i];
                                if (step1.isVisible && step1.getOpacity() === 255 && step1.getTag() === self.userCurrentTracingStrokeIndex) {
                                    step1.stopAllActions();
                                    step1.runAction(cc.sequence(
                                        cc.fadeOut(0.2),
                                        cc.hide()
                                    ))
                                }
                            }
                            self.userCurrentTracingStrokeIndex++;
                            cc.log("userCurrentTracingStrokeIndex" + self.userCurrentTracingStrokeIndex);
                            if (self.userCurrentTracingStrokeIndex >= self.strokes.length) { 
                                self.userCurrentTracingStrokeIndex = -1;
                            	//self.userCurrentTracingStrokeIndex = self.strokes.length - 1;
                                self.touchState = 4;
                                self.showUserFinishStrokeAnimation();
                            }

                            //sprite.setPosition( endNode.getPosition() );
                        } 
                        else   //没有吸附到终点的情况
                        {
                            cc.log("aaa5");
                            var strokeSprite = self.strokeSprites[self.userCurrentTracingStrokeIndex];
                            cc.log("sprite position " + strokeSprite.x + " " + strokeSprite.y);
                            
//                            ip = cc.pLerp(startNode.getPosition(), endNode.getPosition(), per);
//                            strokeSprite.setPosition( ip );
                            strokeSprite.setPosition( pt );
                            cc.log("sprite position " + strokeSprite.x + " " + strokeSprite.y);
                        }
                    }
                    return true;
                }
                return false;
            },
            onTouchEnded: function (touch, event) {

            	if (self.touchState === 2 ) 
                {
                    self.touchState = 1;  //正常状态
                    cc.log("touchEnded");
                    self.animateCurrentStrokeSpriteBackStop_EndButtonEffect_AndResetTouchStateInTheEnd();
                }

            	if(self.userCurrentTracingStrokeIndex != -1)
            	{
            		self.schedule(self.newHand, 5); //5秒后开始笔画提示， andy add
            	}

            	for (var i= 0,num = self.strokeButtons.length; i<num; i++) {
            		var button = self.strokeButtons[i];
            		button.stopAllActions();
                }
                if (self.great)   //完成了一笔
                {
                	//var sprite = self.strokeSprite[self.userCurrentTracingStrokeIndex];
                    var sprite = self.strokeSprites[self.userCurrentTracingStrokeIndex-1];
                    if(sprite !=undefined || sprite!=null)	
                    {
                    	//sprite.setPosition( self.endButtonPosition ); //node你妹，别写错了，在move中已经写好了
                    }
                 
                }

            }
        });

        var listener2 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {


                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) 
                {
                    //andy add
                    for (var i=0; i<self.giftContainer.getChildren().length; i++)
                    {
                    	var gift = self.giftContainer.getChildren()[i];
                    	if(gift !== target)
                    	{
                    		cc.eventManager.pauseTarget(gift);
                    		gift.runAction(cc.FadeOut(1));
                    	}
                    	
                    }
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.x += delta.x;
                target.y += delta.y;
 
            },
            onTouchEnded: function (touch, event) {
                var winSize = cc.director.getWinSize();
                var target = event.getCurrentTarget();
                var locationInNode = self.letterLabel.convertToNodeSpace(touch.getLocation());
                var letterSize = self.letterLabel.getContentSize();
                var rect = cc.rect(0, 0, letterSize.width, letterSize.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.letterLabel.setVisible(false);
                    var aniContent = new cc.Node();
                    aniContent.setPosition(cc.p(winSize.width/2, winSize.height*0.55));
                    self.addChild(aniContent);
                    aniContent.setAnchorPoint(0, 0);
                    var w = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
                    var ani = cc.Sprite.create("Letter-ani/" + w + ".png");
                    ani.setPosition(0, 0);
                    ani.setScale(0.9);
                    aniContent.addChild(ani);
                    self.letterJump2(target);
                    self.letterJump(aniContent);

                    for (var i=0; i<self.giftContainer.getChildren().length; i++) {
                        var gift = self.giftContainer.getChildren()[i];
                        cc.eventManager.pauseTarget(gift);
                    }
                }
            }
        });
        var listener3 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {


                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode) && target.name === "flower2") {
                    target.animationManager.runAnimationsForSequenceNamed(Math.floor(Math.random()*4+1)+"");
                    return true;
                }
                if (cc.rectContainsPoint(rect, locationInNode) && target.name === "flower") {
                    target.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    return true;
                }
                if (cc.rectContainsPoint(rect, locationInNode) && target.name === "light") {
                    if (target.state === "red") {
                        target.state = "green";
                        target.animationManager.runAnimationsForSequenceNamed("green");
                    } else {
                        target.state = "red";
                        target.animationManager.runAnimationsForSequenceNamed("red");
                    }
                    return true;
                }
                return false;
            }
        });
        cc.eventManager.addListener(listener1, this);
        for (var i=0; i<this.giftContainer.getChildren().length; i++) {
            var gift = this.giftContainer.getChildren()[i];
            cc.eventManager.addListener(listener2.clone(), gift);
        }
        for (var i=0; i<this.aniNodeArray.length; i++) {
            var aniNode = this.aniNodeArray[i];
            cc.eventManager.addListener(listener3.clone(), aniNode);
        }
    },
    letterJump2 : function (sprite) {
        var orin = sprite.getPosition();
        sprite.runAction(cc.sequence(
            cc.scaleTo(0.3, 2.2),
            cc.moveTo(0.5, cc.p(sprite.x, sprite.y+55)).easing(cc.easeBackInOut()),
            cc.moveTo(0.5, cc.p(orin.x, orin.y)).easing(cc.easeBackInOut())
        ).repeat(3));
    },
    letterJump : function (sprite) {
        var self = this;
        cc.audioEngine.playEffect("sounds/effect/xiezimu_decorate_alphabet.mp3");
        var orin = sprite.getPosition();
        sprite.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.scaleTo(0.3, 1.1, 0.9),
                    cc.spawn(
                        cc.moveTo(0.5, cc.p(sprite.x, sprite.y+55)).easing(cc.easeBackInOut()),
                        cc.sequence(
                            cc.delayTime(0.1),
                            cc.scaleTo(0.2, 0.9, 1.2)
                        ),
                        cc.sequence(
                            cc.delayTime(0.3),
                            cc.scaleTo(0.15, 1, 1)
                        )
                    ),
                    cc.spawn(
                        cc.moveTo(0.5, cc.p(orin.x, orin.y)).easing(cc.easeBackInOut()),
                        cc.scaleTo(0.2, 1.1, 0.9),
                        cc.sequence(
                            cc.delayTime(0.25),
                            cc.scaleTo(0.15, 1, 1)
                        )
                    )
                ).repeat(3),
                cc.delayTime(0.6),
                cc.callFunc(function () {
                    self.miyaAppearAndCheer();
                })
            )
        ))
    },
    miyaAppearAndCheer : function () {
        var self = this;
        var winSize = cc.director.getWinSize();

        var miyaCharacter = cc.BuilderReader.load("scrawl2/word_miya.ccbi");
        miyaCharacter.animationManager.runAnimationsForSequenceNamed("cheer");

        var miyaNode = new cc.Node();
        this.addChild(miyaNode, 70);
        miyaNode.addChild(miyaCharacter);
        miyaNode.setPosition(winSize.height*(-0.3), winSize.height*(-0.3));
        miyaNode.setRotation(20);
        miyaNode.setScale(0);

        var moveToP = cc.p(winSize.height*(-0.12), winSize.height*(-0.08));

        miyaNode.runAction(cc.sequence(
            cc.spawn(
                cc.moveTo(0.4, moveToP),
                cc.scaleTo(0.4, 1).easing(cc.easeBackOut())
            ),
            cc.delayTime(1.2),
            cc.spawn(
                cc.scaleTo(0.4, 0).easing(cc.easeBackIn()),
                cc.sequence(
                    cc.delayTime(0.2),
                    cc.moveTo(0.2, cc.p(winSize.height*(-0.2), winSize.height*(-0.2)))
                )
            ),
            cc.callFunc(function () {
                self.finishThisSection();
            })
        ))
    },
    finishThisSection : function () {
        this._super();
    },
    showUserFinishStrokeAnimation : function () {
        var self = this;
        var isFinish = true;
        var bulbs = [];

        var delayTime = 0;
        for (var i= 0, num = this.strokeSprites.length; i<num; i++) {
            var st = this.strokeSprites[i];
            var children = st.getChildren();
            for (var j= 0, n=children.length; j<n; j++) {
                var bulb = children[j];
                if (bulb.getTag() === 6 ) {
                    bulbs.push(bulb);
                }
            }
        }
        if (this.effectState === 0) {  //藤蔓效果
            for (var ii= 0, nn=bulbs.length; ii<nn; ii++) {
                var b =  bulbs[ii];
                var number = Math.floor(Math.random()*7);
                if (number === 0) {
                    b.setTexture("letters/flower2.png")
                } else if (number >=1 && number <=3) {
                    b.setTexture("letters/flower_white.png");
                }
                b.setVisible(true);
                b.setScale(0.1);
                b.runAction(cc.sequence(
                    cc.delayTime(ii*0.2),
                    cc.spawn(
                        cc.rotateBy(0.1, 5-Math.random()*10),
                        cc.scaleTo(0.1, 1)
                    )
                ))
            }
            delayTime = bulbs.length*0.2;
        } else {  //小火车效果
            for (var jj= 0; jj<this.strokeSprites.length; jj++) {
                var strokeSprite = this.strokeSprites[jj];
                var tmpArray = [];
                tmpArray.push(st);
                strokeSprite.getChildByTag(6).setVisible(false);

                strokeSprite.runAction(cc.sequence(
                    cc.delayTime(self.delayTimeArray[jj]),
                    cc.callFunc(function(sp){
                        cc.log("sp " + sp.getChildren().length);
                        sp.getChildByTag(6).setVisible(true);
                        sp.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        var train = sp.getChildByTag(6).getChildByTag(6);
                        train.setVisible(true);
                        train.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        train.getChildren()[2].animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    }, this, strokeSprite)
                ));


//                this.scheduleOnce(function () {
//                    self.strokeSprites[0].getChildByTag(6).setVisible(true);
//                    self.strokeSprites[0].animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                    cc.log("LLL " + this.strokeSprites[0].getChildren().length);
//                    self.strokeSprites[0].getChildByTag(6).getChildByTag(6).animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                    self.strokeSprites[0].getChildByTag(6).getChildByTag(6).getChildren()[2].animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                }, this.delayTimeArray[0]);
//                this.scheduleOnce(function () {
//                    self.strokeSprites[1].getChildByTag(6).setVisible(true);
//                    self.strokeSprites[1].animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                    self.strokeSprites[1].getChildByTag(6).getChildByTag(6).animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                }, this.delayTimeArray[1]);
//                if (self.strokeSprites[2]) {
//                    this.scheduleOnce(function () {
//                        self.strokeSprites[2].getChildByTag(6).setVisible(true);
//                        self.strokeSprites[2].animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                        self.strokeSprites[2].getChildByTag(6).getChildByTag(6).animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                    }, this.delayTimeArray[2]);
//                }
//                if (self.strokeSprites[3]) {
//                    this.scheduleOnce(function () {
//                        self.strokeSprites[3].getChildByTag(6).setVisible(true);
//                        self.strokeSprites[3].animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                        self.strokeSprites[3].getChildByTag(6).getChildByTag(6).animationManager.runAnimationsForSequenceNamed("Default Timeline");
//                    }, this.delayTimeArray[3]);
//                }
            }
            delayTime = parseInt(_.last(this.delayTimeArray)) + 3;
        }

        this.scheduleOnce(this.removeStrokeButton, delayTime);
        this.scheduleOnce(this.strokeSpriteGoneAndWordAppear, delayTime+1.5);
    },
    findNodeWithWorld : function (position, insideArray, minimumDistance) {
        //cc.log("findNodeWithWorld");
        var miniDis = 9999;
        var mn;
        for (var i= 0,num=insideArray.length; i<num; i++) {
            var n = insideArray[i];
            var dis = cc.pDistance(position, n.getParent().convertToWorldSpace(n.getPosition()) );
            if (dis<miniDis) {
                miniDis = dis;
                mn = n;
            }
        }
        if (miniDis > minimumDistance) {
            mn = null;
        }
        return mn;
    },
    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});


var EKWrittingLetterMain = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKWrittingLetterMainLayer();
        this.addChild(layer);
    }
});