/**
 * Created by apple on 14-8-17.
 */

var EKWrittingLetterMain2Layer = EKSectionBasicLayer.extend({
    ctor:function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
        }
        this.strokeIndex = 0;
        this.currentSpaceshipTracingIndex = 0;
        this.hitTestingPointsArray = [];
        this.modeState = Math.floor(Math.random()*2);
        this.aniNodeArray = [];
        this.setupBackgound();
        this.setupWord();
        this.setupCurve();

        var files = [];
        for (var i=1; i<10; i++) {
            files.push("letters/Ornaments_" + i + ".png");
        }
        files = _.shuffle(files);
        this.giftItemNames = files.slice(0, 3);
        this.setupGiftContainer();
        return true;
    },
    setupBackgound : function() {
        var winSize = cc.director.getWinSize();
        var backgroundSprite;
        switch (this.modeState) {
            case 1:
            	backgroundSprite = cc.Sprite.create("letters/bg_boo.jpg");
                this.aniNode1 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_balloon&dog");
                this.aniNode1.setPosition(winSize.width*0.85, this.aniNode1.getBoundingBox().height*0.3-winSize.height*0.7);
                this.aniNodeArray.push(this.aniNode1);
                this.aniNode1.animationManager.runAnimationsForSequenceNamed("down");
                this.aniNode1.setVisible(false);

                var spaceShip = cc.BuilderReader.load("letters/scrawl_rock");
                break;
            case 2:
            default :
            	backgroundSprite = cc.Sprite.create("letters/bg_candy.jpg");
                this.aniNode1 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_candy1");
                this.aniNode1.setPosition(winSize.width*0.85, this.aniNode1.getBoundingBox().height*(-0.12)-winSize.height*0.7);
                this.aniNodeArray.push(this.aniNode1);
                this.aniNode1.animationManager.runAnimationsForSequenceNamed("up");

                var spaceShip = cc.BuilderReader.load("scrawl/scrawl_ufo");

                this.aniNode2 = cc.BuilderReader.load("scrawl_BG&ani/scrawl_candy2");
                this.aniNode2.setPosition(winSize.width*0.95, this.aniNode2.getBoundingBox().height*(-0.12)-winSize.height*0.7);
                this.stopAutoCCBActions(this.aniNode2);
                this.aniNode2.animationManager.runAnimationsForSequenceNamed("up");
                this.aniNodeArray.push(this.aniNode2);

                this.addChild(this.aniNode2, 50);
                break;
        }
        backgroundSprite.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(backgroundSprite);
        this.addChild(this.aniNode1, 51);

        this.spaceShip = new cc.Node();
        this.spaceShip.addChild(spaceShip);
        this.spaceShip.setScale(0.3);
        this.spaceShip.setPosition(-300, 0);

        this.par = cc.BuilderReader.load("letters/smoke");
        this.par.setPositionType(cc.ParticleSystem.TYPE_FREE);
        this.par.setVisible(false);

        this.spaceshipPar = cc.ParticleSystem.create("letters/new_par.plist");

        this.spaceshipPar.setLife(999);
        this.spaceshipPar.setTotalParticles(4000);
        this.spaceshipPar.setEmissionRate(this.spaceshipPar.getEmissionRate()/3);
    },
    
    // 设置涂写字母
    setupWord : function() {
        var winSize = cc.director.getWinSize();
        this.currentWord = EKLevelsName[parseInt(EKCoreManager.getInstance().currentPlayingLevelIndex)];
        this.wordNode = cc.BuilderReader.load("letters/letter_" + this.currentWord + "_rock");
        this.addChild(this.wordNode);

        this.wordNode.addChild(this.spaceShip, ZOder_GAME_MIDDLE_OBJ, 10);   // 火箭
        this.wordNode.addChild(this.spaceshipPar, ZOder_GAME_MIDDLE_OBJ-1, 10); // 粒子
        this.wordNode.addChild(this.par, ZOder_GAME_MIDDLE_OBJ-1, 10);  // 烟

        if (winSize.width/winSize.height > 1.77) {
            this.wordNode.setPosition(0, -50);
        }

        this.strokeButtons = [];
        var children = this.wordNode.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];  // 设置节点的样式
            if (child.getTag() === 9) 
            {
                if (this.modeState === 0) {
                    child.setTexture("letters/boo_point.png");
                } else {
                    child.setTexture("letters/candy_point.png");
                }
                child.setLocalZOrder(ZOder_GAME_MIDDLE_OBJ+1);
                this.strokeButtons.push(child);
            } else if (child.getTag() === -1 || child.getTag() === 4 || child.getTag() === 5 || child.getTag() === 6 || child.getTag() === 2){
                child.setVisible(false);
            }
        }
        this.letterLabel =  this.wordNode.getChildByTag(2);
        this.letterLabel.setVisible(true);
        this.letterLabel.setOpacity(0);
    },
    stopAutoCCBActions : function(node) {
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            child.stopAllActions();
            this.stopAutoCCBActions(child);
        }
    },
    
    // 设置曲线
    setupCurve : function () {
        var winSize = cc.director.getWinSize();
        var self = this;
        this.points = [];
        this.points1 = [];
        this.points2 = [];
        var children = this.wordNode.getChildren();
        for (var i=0; i<children.length; i++) {
            var point = children[i];
            if (point.getTag() === 4) {  // 第一划,每一个point都是一个ccb文件
                this.points1.push(point);
            }
            if (point.getTag() === 5) {  // 第二划,每一个point都是一个ccb文件
                this.points2.push(point);
            }
        }
        if (this.points1.length !== 0) {
            this.points.push(this.points1);
        }
        if (this.points2.length !== 0) {
            this.points.push(this.points2);
        }

        var action = [];
        for (var j=0; j<this.points.length; j++) {  // 笔画的起始位置
            var points = this.points[j];
            var point0 = points[0];
            var point0Pos = point0.getPosition();
            action.push(cc.callFunc(function(){
                self.spaceShip.setPosition(point0Pos);
            }));
            for (var i=0; i<points.length; i++) { // 笔画里边有多少个点
                var point = points[i];
                point.stroke = j;  // 第几笔
                var prePoint;
                if (i>0) {
                    prePoint = points[i-1];
                } else {
                    prePoint = self.spaceShip.getPosition();
                }
                var p = cc.pSub(point, prePoint);
                var rotation =  - (cc.pToAngle(p)/Math.PI * 180 - 90);
                var moveTo = cc.spawn(
                    cc.moveTo(0.1, point),
                    cc.rotateTo(0.1, rotation)
                );
                action.push(moveTo);
            }
        }

        action.push(cc.callFunc(function () {
        	self.spaceShip.removeFromParent(true);
//      	self.spaceshipPar.setEmissionRate(0);
            self.par.removeFromParent(true);
            self.unscheduleAllCallbacks();
            self.coverTexture();
        }));

        this.spaceShip.runAction( cc.sequence( action ) );
        this.showStars();
    },
    showStars : function () {
    	var self = this;
    	this.stars = [];
    	this.schedule(function () {
    		self.spaceshipPar.setPosition(self.spaceShip.getPosition());

    		var star = cc.Sprite.create("letters/scrawl_space_star_1.png");
            self.wordNode.addChild(star, 30, 10);
            star.m_originalPos = star.getPosition();
            star.setPosition(self.spaceShip.x + (Math.random()-0.5)*15, self.spaceShip.y + (Math.random()-0.5)*15);
            star.runAction(cc.sequence(
            		cc.spawn(
            				cc.sequence(
            						cc.delayTime(Math.random()*0.2),
            						cc.scaleTo(0.1, 0.95),
            						cc.scaleTo(0.1, 1)
                    ),
                    cc.sequence(
                    		cc.delayTime(Math.random()*0.2),
                    		cc.fadeOut(0.5),
                    		cc.fadeIn(1)
                    )
            		)
            ).repeatForever());

            this.stars.push(star);
    	}, 0.05);
    	this.schedule(function () {
    		if (self.spaceShip) {
    			var winSize = cc.director.getWinSize();
    			self.spaceshipPar.setPosition(self.wordNode.convertToNodeSpace(self.spaceShip.getPosition()));
                self.par.setPosition(self.wordNode.convertToNodeSpace(self.spaceShip.getPosition()));

                if (winSize.height/winSize.widget > 1.77) {
                    self.spaceshipPar.y -= 50;
                    self.par.y -= 50;
                }
            }
        });
    },


    //如果触摸点在字母上，则从这个开始，连续判断lastInRow个，否则返回undefined
    findTheIndexOfCandy_BallonIfTouchPointOnTheLetter : function(touchPosition, lastInRow)
    {
    	var self = this;
        var currentCandyOrBallon = undefined;  //当前触摸点所在区域的小气球或是小糖果
        for(var i=0; i<this.candyOrBalloons.length; i++)
        {
        	var candyOrBalloon = this.candyOrBalloons[i];  //遍历每一个小糖果或是小气球
            var p = candyOrBalloon.getPosition();
            var rect = cc.rect(p.x-30, p.y-30, 60,60);
            if (cc.rectContainsPoint(rect, touchPosition) && candyOrBalloon.stroke === this.strokeIndex)  //是否在小糖果或者小气球附近，并且笔画顺序和小糖果或是小气球的笔画顺序一致
            {
            	
            	var orderIndex = this.findTheFarestCandy_BallonUnderTheTouchPoint(touchPosition, i+1, lastInRow, self.candyOrBalloons);
            	cc.log("index = " + orderIndex);
                currentCandyOrBallon = this.candyOrBalloons[orderIndex];
                
                
                break;
            }
        }

        return currentCandyOrBallon;
    },
    
    findTheFarestCandy_BallonUnderTheTouchPoint : function(touchPosition, fromIndex, lastInRow, array)
    {
    	
    	//assert(fromIndex>0, "fromIndex param in less than 0 in findTheFarestCandy_BallonUnderTheTouchPoint(), line: 265" );
    	//assert(array != null, "array in null in findTheFarestCandy_BallonUnderTheTouchPoint(), line: 265");
    	
    	var i;
    	for(i = fromIndex; i+lastInRow<array.length; i++)
    	{
        	var candyOrBalloon = array[i];  //遍历每一个小糖果或是小气球
            var p = candyOrBalloon.getPosition();
            var rect = cc.rect(p.x-30, p.y-30, 60,60);
            
            if (cc.rectContainsPoint(rect, touchPosition) && candyOrBalloon.stroke === this.strokeIndex)
            {
            	//循环调用
            	continue;
            	//迭代调用
            	//return this.findTheFarestCandy_BallonUnderTheTouchPoint(touchPosition, i+1, lastInRow, array);
            }
            else
            {

            	return i-1;
           	}
    	}

    	return i-1;
    },
    

    // 触控事件
    setupTouchEvent : function () {
        var self = this;
        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) 
            {
            	
            	
                var target = event.getCurrentTarget();
                var location = target.convertToNodeSpace(touch.getLocation());

                var strokeButton = self.strokeButtons[0];

                var button1 = self.strokeButtons[0];
                var button2 = self.strokeButtons[1];

                if (self.strokeButtons.length > 2 && self.strokeIndex === 1) {
                    strokeButton = self.strokeButtons[2];
                    button1 = self.strokeButtons[2];
                    button2 = self.strokeButtons[3];
                }

                var p = strokeButton.getPosition();
                var rect = cc.rect(p.x-25, p.y-25, 50, 50);
                if (cc.rectContainsPoint(rect, location)) 
                {
                	
//                	self.unschedule(self.newHand); //andy add 取消笔画提示
//                	self.newHandIsOn = false;     //andy add
                	
                    for (var i=0; i<self.aniNodeArray.length; i++) {
                        var aniNode = self.aniNodeArray[i];
                        cc.eventManager.pauseTarget(aniNode, true);
                    }

                    self.state = 2;
                    strokeButton.stopAllActions();
                    strokeButton.setVisible(true);
                    strokeButton.setScale(0);
                    strokeButton.runAction(cc.sequence(
                        cc.show(),
                        cc.scaleTo(0.2, 1).easing(cc.easeBackOut())
                    ));

                    button1.runAction(cc.sequence( cc.scaleTo(0.2, 1.2), cc.scaleTo(0.2, 1) ).repeatForever());
                    button2.runAction(cc.sequence( cc.scaleTo(0.2, 1.2), cc.scaleTo(0.2, 1) ).repeatForever());
                    self.touchState = 1;
                    return true;
                }
                return false;
            },

            
            onTouchMoved: function (touch, event) {
                if (self.touchState === 1)    //写笔画阶段
                {
                    var target = event.getCurrentTarget();
                    var location = target.convertToNodeSpace(touch.getLocation());// touch.getLocation();
                    self.candyOrBalloonisBeenTouching = false;
                    
                    
                    var candyOrBalloon = self.findTheIndexOfCandy_BallonIfTouchPointOnTheLetter(location, 2);
                    if(candyOrBalloon != undefined)
                    {
                    	self.candyOrBalloonisBeenTouching = true;  //显示小气球或者小糖果
                    	candyOrBalloon.stopAllActions();
                    	candyOrBalloon.setVisible(true);
                    	candyOrBalloon.setScale(0);
                    	candyOrBalloon.runAction(cc.sequence(  //执行动画
                    			cc.show(),
                    			cc.scaleTo(0.2, 1).easing(cc.easeBackOut()),
                    			cc.callFunc(function () 
                    					{
                    				if (self.modeState === 0)
                    				{
                    					cc.audioEngine.playEffect("sounds/effect/xiezimu_balloon_appear.mp3");
                    				} else 
                    				{
                    					cc.audioEngine.playEffect("sounds/effect/xiezimu_candy_appear.mp3");
                    				}
                    					})
                    	));

                    	var index = candyOrBalloon.index;
                    	for (var j=0; j<index; j++)
                    	{
                    		var preCandyOrBalloon = self.candyOrBalloons[j];
                    		if (!preCandyOrBalloon.isVisible())
                    		{
                    			preCandyOrBalloon.setVisible(true);
                    			preCandyOrBalloon.setScale(0);
                    			preCandyOrBalloon.runAction(cc.sequence(
                    					cc.show(),
                    					cc.scaleTo(0.1, 1).easing(cc.easeBackOut())
                    			));
                    		}
                    	}
                    }
                    
//                    for (var i=0; i<self.candyOrBalloons.length; i++)
//                    {
//                    	var candyOrBalloon = self.candyOrBalloons[i];  //遍历每一个小糖果或是小气球
//                        var p = candyOrBalloon.getPosition();
//                        var rect = cc.rect(p.x-30, p.y-30, 60, 60);
//                        if (cc.rectContainsPoint(rect, location) && candyOrBalloon.stroke === self.strokeIndex)  //是否在小糖果或者小气球附近，并且笔画顺序和小糖果或是小气球的笔画顺序一致
//                        {
//                        	
//                                self.candyOrBalloonisBeenTouching = true;  //显示小气球或者小糖果
//                                candyOrBalloon.stopAllActions();
//                                candyOrBalloon.setVisible(true);
//                                candyOrBalloon.setScale(0);
//                                candyOrBalloon.runAction(cc.sequence(  //执行动画
//                                    cc.show(),
//                                    cc.scaleTo(0.2, 1).easing(cc.easeBackOut()),
//                                    cc.callFunc(function () 
//                                    {
//                                        if (self.modeState === 0)
//                                        {
//                                            cc.audioEngine.playEffect("sounds/effect/xiezimu_balloon_appear.mp3");
//                                        } else 
//                                        {
//                                            cc.audioEngine.playEffect("sounds/effect/xiezimu_candy_appear.mp3");
//                                        }
//                                    })
//                                ));
//                                
//                                var index = candyOrBalloon.index;
//                                for (var j=0; j<index; j++)
//                                {
//                                    var preCandyOrBalloon = self.candyOrBalloons[j];
//                                    if (!preCandyOrBalloon.isVisible())
//                                    {
//                                        preCandyOrBalloon.setVisible(true);
//                                        preCandyOrBalloon.setScale(0);
//                                        preCandyOrBalloon.runAction(cc.sequence(
//                                            cc.show(),
//                                            cc.scaleTo(0.1, 1).easing(cc.easeBackOut())
//                                        ));
//                                    }
//                                }
//                                //return true;  //andy delete
//                               
//                            }
//                        }

                    
                    	//button
                        var button1 = self.strokeButtons[0];
                        var button2 = self.strokeButtons[1];
                        if (self.strokeButtons.length > 2 && self.strokeIndex === 1) {
                            button1 = self.strokeButtons[2];
                            button2 = self.strokeButtons[3];
                        }
//                      //andy delete 取消在move事件中判断是否结束，不然的话， O， Q直接第一个点就结束了
//                        //是否完成一笔
//                        var pp = button2.getPosition();
//                        var button2Rect = cc.rect(pp.x-30, pp.y-30, 60, 60);
//                        if (cc.rectContainsPoint(button2Rect, location)) 
//                        {
//                            self.touchState = 0;
//                            self.strokeIndex++;
//                            if (self.strokeIndex === self.points.length) 
//                            {
//                                self.state = 2;
//                                self.endAllWriting();
//                                button1.stopAllActions();
//                                button2.stopAllActions();
//                               
////                                //取消笔画提示
////                                self.unschedule(self.newHand);
////                                self.newHandIsOn = false;
//                            }
//                            
//                            return false;
//                        }
                    //end andy

                    //触控点不在范围内，隐藏气球，糖果
                        if (!self.candyOrBalloonisBeenTouching) 
                        {
                            for (var i=0; i<self.candyOrBalloons.length; i++) 
                            {
                                var candyOrBalloon = self.candyOrBalloons[i];
                                candyOrBalloon.stopAllActions();
                                if (candyOrBalloon.stroke === self.strokeIndex) 
                                {
                                    self.touchState = 0;
                                    candyOrBalloon.runAction(cc.sequence(
                                        cc.scaleTo(0.1, 0).easing(cc.easeBackOut()),
                                        cc.hide()
                                    ));
                                    button1.stopAllActions();
                                    button2.stopAllActions();
                                }
                            }
                        }
                    }

            },
            onTouchEnded: function (touch, event) {
                self.state = 1;
                self.newHandIsOn = false;
                for (var i=0; i<self.aniNodeArray.length; i++) {
                    var aniNode = self.aniNodeArray[i];
                    cc.eventManager.resumeTarget(aniNode, true);
                }

                if (self.touchState == 1) {
                    var target = event.getCurrentTarget();
                    var location = target.convertToNodeSpace(touch.getLocation());
                    var button1 = self.strokeButtons[0];
                    var button2 = self.strokeButtons[1];
                    if (self.strokeButtons.length > 2 && self.strokeIndex === 1) {
                        button1 = self.strokeButtons[2];
                        button2 = self.strokeButtons[3];
                    }

                    button1.stopAllActions();
                    button2.stopAllActions();
                    var p = button2.getPosition();
                    var rect = cc.rect(p.x-35, p.y-35, 70, 70);
                    if (cc.rectContainsPoint(rect, location)) {
                        self.strokeIndex++;
                        cc.audioEngine.playEffect("sounds/effect/xiezimu_right.mp3");
                        if (self.strokeIndex === self.points.length) {
                            self.state = 2;
                            self.endAllWriting();
                        }
                    } else {
                        for (var i=0; i<self.candyOrBalloons.length; i++) {
                            var candyOrBalloon = self.candyOrBalloons[i];
                            p = candyOrBalloon.getPosition();
                            rect = cc.rect(p.x-10, p.y-10, 20, 20);
                            candyOrBalloon.stopAllActions();
                            if (candyOrBalloon.stroke === self.strokeIndex) {
                                candyOrBalloon.runAction(cc.sequence(
                                    cc.scaleTo(0.2, 0).easing(cc.easeBackOut()),
                                    cc.hide()
                                ))
                            }
                        }
                    }
                }
            }
        });
        cc.eventManager.addListener(listener1, this.wordNode);
    },
    coverTexture : function () {
        cc.log("coverTexture");
        var self = this;
        this.candyOrBalloons = [];
        for (var i=0; i<this.points.length; i++) {
            var points = this.points[i];
            for (var j=0; j<points.length; j++) {
                var point = points[j];
                var candyOrBalloon;
                if (this.modeState === 0) {
                    candyOrBalloon = cc.BuilderReader.load("scrawl1/scrawl_balloon" + Math.floor(Math.random()*7+1));
                } else {
                    candyOrBalloon = cc.BuilderReader.load("scrawl1/scrawl_candy" + Math.floor(Math.random()*5+1));
                }
                candyOrBalloon.stroke = point.stroke;  //第几划
                this.candyOrBalloons.push(candyOrBalloon);
                this.wordNode.addChild(candyOrBalloon, ZOder_GAME_MIDDLE_OBJ, 10);
                candyOrBalloon.setPosition(point.getPosition());
                candyOrBalloon.animationManager.runAnimationsForSequenceNamed("stop");
                var prePoint;
                if (i>0) {
                    prePoint = points[i-1];
                } else {
                    prePoint = self.spaceShip.getPosition();
                }
                var p = cc.pSub(point, prePoint);
                var rotation =  - (cc.pToAngle(p)/Math.PI * 180 - 90);
                candyOrBalloon.setRotation(rotation);
                candyOrBalloon.setVisible(false);
            }
        }
        for (var i=0; i<this.candyOrBalloons.length; i++) {
            var candyOrBalloon = this.candyOrBalloons[i];
            candyOrBalloon.index = i;  //小气球或是小糖果序号,从0开始，最大值为ccb文件中的点的个数-1
        }
        this.aninodeMove();

        this.newHandIsOn = false;
        this.state = 1;
        this.schedule(function () {
            self.newHand();
            this.newHandIsOn = true;
        }, 1);
        this.setupTouchEvent();
    },
    //结束写字母
    endAllWriting : function() {
        cc.log("endAllWriting");
        var self = this;
        var button1 = self.strokeButtons[0];
        var button2 = self.strokeButtons[1];
        button1.setVisible(false);
        button2.setVisible(false);
        if (self.strokeButtons[2]) {
            var button3 = self.strokeButtons[2];
            button3.setVisible(false);
        }
        if (self.strokeButtons[3]) {
            var button4 = self.strokeButtons[3];
            button4.setVisible(false);
        }
        var length = this.candyOrBalloons.length;
        for (var i=0; i<length; i++) {
            cc.log(i);
            this.scheduleOnce(function(){
                return function(i){
                    self.candyOrBalloons[Math.floor(i*10)].animationManager.runAnimationsForSequenceNamed("explo");
                    cc.audioEngine.playEffect("sounds/effect/xiezimu_balloon_disappear.mp3");
                    if (Math.floor(i*10) === (self.candyOrBalloons.length-1) ) {

                    }
                }
            }(i), i*0.1);
        }

        var dur = length*0.1;
        this.scheduleOnce(function(){
            cc.log("strokeSpriteGoneAndWordAppear");
            self.strokeSpriteGoneAndWordAppear();
        }, dur)
    },
    newHand : function () {
        if(this.strokeIndex === this.points.length)
        {
            return ;
        }


        cc.log("newHand");
        var self = this;
        cc.log("newHandIsOn " + this.newHandIsOn + " " + this.state);
        
        
        if (!this.newHandIsOn && this.state === 1) 
        {
            var index = 0;
            if (this.strokeIndex === 1) {
                index = this.points[0].length;
            }
            for (var i=index; i<index+5; i++) {
                var node = this.candyOrBalloons[i];
                node.setScale(0);
                node.setVisible(true);
                node.runAction(cc.sequence(
                    cc.delayTime(0.1*i),
                    cc.scaleTo(0.2, 1).easing(cc.easeBackOut()),
                    cc.delayTime(2),
                    cc.scaleTo(0.2, 0).easing(cc.easeIn(0.4)),
                    cc.callFunc(function(){
                        self.newHandIsOn = false;
                    }),
                    cc.hide()
                ))
            }
        }
    },
    strokeSpriteGoneAndWordAppear : function () {
        var self = this;
        this.letterLabel.runAction(cc.sequence(
            cc.fadeIn(0.5),
            cc.callFunc(function () {
                self.showGiftContainer();
            })
        ));
        this.spaceshipPar.removeFromParent(true);
    },
    showGiftContainer : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var w = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
        cc.audioEngine.playEffect("sounds/" + w + "_normal.mp3");
        this.giftContainer.runAction(cc.sequence(
            cc.moveTo(1.5, cc.p(winSize.width*0.45, 10)).easing(cc.easeBounceOut()),
            cc.delayTime(1),
            cc.callFunc(function () {
                var xiezimuValue = parseInt(cc.sys.localStorage.getItem("xiezimu_xinshou"));
                if ( !xiezimuValue || xiezimuValue<3) {
                	self.startHint();
                	if (!xiezimuValue) {
                		cc.sys.localStorage.setItem("xiezimu_xinshou", 1);
                	} else {
                		var count = parseInt(cc.sys.localStorage.getItem("xiezimu_xinshou"));
                		cc.sys.localStorage.setItem("xiezimu_xinshou", count+1);
                	}
                }
            })
        ));
        this.setupGiftTouchEvent();
    },
    setupGiftTouchEvent : function () {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode))
                {
                    //andy add
                    for (var i=0; i<self.giftContainer.getChildren().length; i++)
                    {
                    	var gift = self.giftContainer.getChildren()[i];
                    	if(gift !== target)
                    	{
                    		cc.eventManager.pauseTarget(gift);
                    		gift.runAction(cc.FadeOut(1));
                    	}
                    	
                    }
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.x += delta.x;
                target.y += delta.y;
            },
            onTouchEnded: function (touch, event) {
                var winSize = cc.director.getWinSize();
                var target = event.getCurrentTarget();
                var locationInNode = self.letterLabel.convertToNodeSpace(touch.getLocation());
                var letterSize = self.letterLabel.getContentSize();
                var rect = cc.rect(0, 0, letterSize.width, letterSize.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.letterLabel.setVisible(false);
                    var aniContent = new cc.Node();
                    aniContent.setPosition(cc.p(winSize.width/2, winSize.height*0.55));
                    self.addChild(aniContent);
                    aniContent.setAnchorPoint(0, 0);
                    var w = EKLevelsName[EKCoreManager.getInstance().currentPlayingLevelIndex];
                    var ani = cc.Sprite.create("Letter-ani/" + w + ".png");
                    ani.setPosition(0, 0);
                    ani.setScale(0.9);
                    aniContent.addChild(ani);
                    self.letterJump2(target);
                    self.letterJump(aniContent);
                    for (var i=0; i<self.stars.length; i++) {
                        var star = self.stars[i];
                        star.removeFromParent(true);
                    }
                }
            }
        });
        for (var i=0; i<this.giftContainer.getChildren().length; i++) {
            var gift = this.giftContainer.getChildren()[i];
            cc.eventManager.addListener(listener.clone(), gift);
        }
    },
    letterJump2 : function (sprite) {
        var orin = sprite.getPosition();
        sprite.runAction(cc.sequence(
            cc.scaleTo(0.3, 2.2),
            cc.moveTo(0.5, cc.p(sprite.x, sprite.y+55)).easing(cc.easeBackInOut()),
            cc.moveTo(0.5, cc.p(orin.x, orin.y)).easing(cc.easeBackInOut())
        ).repeat(3));
    },
    letterJump : function (sprite) {
        var self = this;
        cc.audioEngine.playEffect("sounds/effect/xiezimu_decorate_alphabet.mp3");
        var orin = sprite.getPosition();
        sprite.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.scaleTo(0.3, 1.1, 0.9),
                    cc.spawn(
                        cc.moveTo(0.5, cc.p(sprite.x, sprite.y+55)).easing(cc.easeBackInOut()),
                        cc.sequence(
                            cc.delayTime(0.1),
                            cc.scaleTo(0.2, 0.9, 1.2)
                        ),
                        cc.sequence(
                            cc.delayTime(0.3),
                            cc.scaleTo(0.15, 1, 1)
                        )
                    ),
                    cc.spawn(
                        cc.moveTo(0.5, cc.p(orin.x, orin.y)).easing(cc.easeBackInOut()),
                        cc.scaleTo(0.2, 1.1, 0.9),
                        cc.sequence(
                            cc.delayTime(0.25),
                            cc.scaleTo(0.15, 1, 1)
                        )
                    )
                ).repeat(3),
                cc.delayTime(0.6),
                cc.callFunc(function () {
                    self.miyaAppearAndCheer();
                })
            )
        ))
    },
    miyaAppearAndCheer : function () {
        var self = this;
        var winSize = cc.director.getWinSize();

        var miyaCharacter = cc.BuilderReader.load("scrawl2/word_miya.ccbi");
        miyaCharacter.animationManager.runAnimationsForSequenceNamed("cheer");

        var miyaNode = new cc.Node();
        this.addChild(miyaNode, 70);
        miyaNode.addChild(miyaCharacter);
        miyaNode.setPosition(winSize.height*(-0.3), winSize.height*(-0.3));
        miyaNode.setRotation(20);
        miyaNode.setScale(0);

        miyaNode.runAction(cc.sequence(
            cc.spawn(
                cc.moveTo(0.4, cc.p(winSize.height*(-0.12), winSize.height*(-0.08))),
                cc.scaleTo(0.4, 1).easing(cc.easeBackOut())
            ),
            cc.delayTime(1.2),
            cc.spawn(
                cc.scaleTo(0.4, 0).easing(cc.easeBackIn()),
                cc.sequence(
                    cc.delayTime(0.2),
                    cc.moveTo(0.2, cc.p(winSize.height*(-0.2), winSize.height*(-0.2)))
                )
            ),
            cc.callFunc(function () {
                self.finishThisSection();
            })
        ))
    },
    finishThisSection : function () {
        this._super();
    },
    startHint : function () {
        cc.log("startHint");
        var winSize = cc.director.getWinSize();
        var pos = this.giftContainer.getChildByTag(1).getPosition();
        startHintingWithHand(pos, cc.p(winSize.width/2, winSize.height/2), this, 1);
    },
    setupGiftContainer : function () {
        var winSize = cc.director.getWinSize();
        this.giftContainerArray = [];
        this.giftContainer = new cc.Node();
        this.giftContainer.setAnchorPoint(0.5, 0);
        this.giftContainer.setContentSize(cc.size(winSize.width*0.5, 75));

        this.addChild(this.giftContainer, ZOder_GAME_FRONT_OBJ+5);
        this.giftContainer.setPosition(cc.p(winSize.width*0.45, winSize.height*1.1));

        for (var i=0; i<this.giftItemNames.length; i++) {
            var name = this.giftItemNames[i];
            cc.log("name " + name);
            var gift = cc.Sprite.create(name);
            gift.setAnchorPoint(cc.p(0.5, 0.5));
            gift.setScale(1.5);
            this.giftContainer.addChild(gift);
            gift.setPosition(winSize.width*0.15 + winSize.width*0.17*(i-1), 30);
            gift.setTag(i);
            this.giftContainerArray.push(gift);
        }
    },
    aninodeMove : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var height = winSize.height*0.7;
        for (var i=0; i<this.aniNodeArray.length; i++) {
            var node = this.aniNodeArray[i];
            node.setVisible(true);
            node.state = 0;
            node.runAction(cc.sequence(
                cc.delayTime(0.3*i),
                cc.moveTo(1, cc.p(node.x, node.y+height)).easing(cc.easeBackOut())
            ))
        }
        this.setupAniNodeTouchEvent();
    },
    setupAniNodeTouchEvent : function () {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                if (self.modeState === 0) {
                    var rect = cc.rect(0, 0, s.width, s.height*0.8);
                    if (cc.rectContainsPoint(rect, locationInNode) && target.state === 0 ) {
                        target.state = 1;
                        target.animationManager.runAnimationsForSequenceNamed("down");
                        return false;
                    } else if (target.state === 1) {
                        return true;
                    }
                    return false;
                } else {
                    var rect;
                    if (target.state === 0) {
                        rect = cc.rect(0, 0, s.width, s.height);
                        if (cc.rectContainsPoint(rect, locationInNode)) {
                            target.state = 1;
                            target.animationManager.runAnimationsForSequenceNamed("UP");
                            return false;
                        }
                    } else {
                        rect = cc.rect(0, s.height*0.4, s.width, s.height);
                        if (cc.rectContainsPoint(rect, locationInNode)) {
                            target.state = 0;
                            target.animationManager.runAnimationsForSequenceNamed("down");
                            return false;
                        }
                    }
                    return false;
                }
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                target.state = 2;
                var location = touch.getLocation();
                var position = target.getPosition();
                var p = cc.pSub(location, position);
                var angular = - (cc.pToAngle(p)/Math.PI * 180-90);
                target.setRotation(angular);
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                var angular = target.getRotation();
                target.runAction(cc.sequence(
                    cc.rotateTo(0.6, -angular*0.9),
                    cc.rotateTo(0.6,  angular*0.7),
                    cc.rotateTo(0.6, -angular*0.5),
                    cc.rotateTo(0.6,  angular*0.3),
                    cc.rotateTo(0.6, -angular*0.1),
                    cc.rotateTo(0.6,  0),
                    cc.callFunc(function () {
                        target.state = 1;
                    })
                ))
            }
        });

        for (var i=0; i<this.aniNodeArray.length; i++) {
            var aniNode = this.aniNodeArray[i];
            cc.eventManager.addListener(listener.clone(), aniNode);
        }
    },
    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});


var EKWrittingLetterMode2 = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKWrittingLetterMain2Layer();
        this.addChild(layer);
    }
});