/**
 * Created by apple on 14-8-23.
 */

var EKParentMainLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event){
                if(keyCode == cc.KEY.back) {
                    EKCoreManager.getInstance().gotoHome();
                }
            }
        }, this);

        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.logEvent("enter parent");
        }
        this.setupBackButton();

        var ccbStr;
        if (isLangCN()) {
            ccbStr = "parentContent";
        } else {
            ccbStr = "parentContent_eng";
        }

        var parentContent = cc.BuilderReader.load(ccbStr, this);
        this.addChild(parentContent);

        this.aboutUsContent = this["aboutUsContent"];
        this.settingsContent = this["settingsContent"];
        this.contactUsContent = this["contactUsContent"];

        this.lessonNumButton1 = this["lessonNumButton1"];
        this.lessonNumButton2 = this["lessonNumButton2"];
        this.lessonNumButton3 = this["lessonNumButton3"];
        this.remindTimeButton1 = this["remindTimeButton1"];
        this.remindTimeButton2 = this["remindTimeButton2"];
        this.remindTimeButton3 = this["remindTimeButton3"];

        this.emailButton = this["emailButton"];

        this.privateButton = this["privateButton"];
        this.privateButtonCN = this["privateButton_cn"];

        this.s1 = [this.lessonNumButton1, this.lessonNumButton2, this.lessonNumButton3];
        this.s2 = [this.remindTimeButton1, this.remindTimeButton2, this.remindTimeButton3];
        this.s1.key = "dayLessonNum";
        this.s2.key = "remindTime";

        // tag: 5->中文， 15->英文
        if ( isLangCN() ) {
            this.aboutUsContent.getChildByTag(5).setVisible(true);
            this.aboutUsContent.getChildByTag(15).setVisible(false);

            this.langButton1 = this["langButton1"];
            this.langButton2 = this["langButton2"];
            this.aboutScroll = this.aboutUsContent.getChildByTag(5);

            this.s3 = [this.langButton1, this.langButton2];
            this.s3.key = "multiLang";
        } else {
            this.aboutUsContent.getChildByTag(5).setVisible(false);
            this.aboutUsContent.getChildByTag(15).setVisible(true);
            this.aboutScroll = this.aboutUsContent.getChildByTag(15);
        }

        this.settingGroups = [this.s1, this.s2, this.s3];

        this.settingsContent.setVisible(false);
        this.aboutUsContent.setVisible(false);
        this.contactUsContent.setVisible(false);

        this.contents = [this.settingsContent, this.aboutUsContent, this.contactUsContent];

        this.parentSettingButton = parentContent.getChildByTag(1);
        this.parentAboutButton = parentContent.getChildByTag(2);
        this.parentContactButton = parentContent.getChildByTag(3);
        this.parentSettingButton.setLocalZOrder(1);
        this.parentAboutButton.setLocalZOrder(1);
        this.parentContactButton.setLocalZOrder(1);
        this.tabs = [this.parentSettingButton, this.parentAboutButton, this.parentContactButton];

        this.parentRecommendButton = parentContent.getChildByTag(4);
        // 临时：
        this.parentRecommendButton.setVisible(false);

        this.isInSettingPage = true;

        this.setupTouchEventManager();

        this.settingsContent.setVisible(true);
        this.tabTapped(this.parentSettingButton);
        this.refreshSettings();

        this.setupVersion();

        // 临时：
        this.langButton1.setVisible(false);
        this.langButton2.setVisible(false);

        return true;
    },

    setupVersion : function () {
        var winSize = cc.director.getWinSize();
        var version = "1.1";
        var versionString = "版本号：" + version;
        var label = new ccui.Text();
        label.setString(versionString);
        label.setColor(cc.color.BLACK);
        label.setPosition(winSize.width*0.8, winSize.height*0.15);

        this.addChild(label, 150);
    },

    setupTouchEventManager : function() {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.tabTapped(target);

                    if (target === self.parentRecommendButton) {
                        self.popToRate();
                    }
                    if (target === self.privateButton || target === self.privateButtonCN) {
                        self.goPrivateLink()
                    }

                    for (var i = 0, num = self.settingGroups.length; i < num; i++) {
                        var group = self.settingGroups[i];
                        cc.log("LLLLLLLKKKKKK " + _.contains(group, target) );
                        if ( _.contains(group, target) ) {
                            self.updateSetting(group,target);
                        }
                    }

                    self.refreshSettings();
                    return true;
                }
                return false;
            }
        });

        cc.eventManager.addListener(listener, this.parentRecommendButton);
        cc.eventManager.addListener(listener.clone(), this.privateButton);
        cc.eventManager.addListener(listener.clone(), this.privateButtonCN);

        for (var i = 0, num = this.tabs.length; i < num; i++) {
            var button = this.tabs[i];
            cc.eventManager.addListener(listener.clone(), button);
        }
        for (var i = 0, num = this.s1.length; i < num; i++) {
            var button = this.s1[i];
            cc.eventManager.addListener(listener.clone(), button);
        }
        for (var i = 0, num = this.s2.length; i < num; i++) {
            var button = this.s2[i];
            cc.eventManager.addListener(listener.clone(), button);
        }
        for (var i = 0, num = this.s3?this.s3.length:0; i < num; i++) {
            var button = this.s3[i];
            cc.eventManager.addListener(listener.clone(), button);
        }
    },

    tabTapped : function(target) {
        var str = "";
        if ( !isLangCN() ) {
            str = "_eng";
        }
        for (var i=0; i<3; i++) {
            var touchedTexture = cc.textureCache.addImage("parent/tab_"+i+"_touched"+str+".png");
            var untouchedTexture = cc.textureCache.addImage("parent/tab_"+i+"_untouched"+str+".png");
            var tab = this.tabs[i];
            if (target === tab) {
                tab.setTexture(touchedTexture);
                this.contents[i].setVisible(true);
                this.isInSettingPage = (i===0);
            } else if (_.contains(this.tabs, target)) {
                tab.setTexture(untouchedTexture);
                this.contents[i].setVisible(false);
            }
        }
    },

    updateSetting : function(group ,target) {
        if (this.isInSettingPage) {
            var key = group.key;
            var index = group.indexOf(target);
            cc.log(key + " " + index);
            cc.sys.localStorage.setItem(key, index);
        }
    },

    refreshSettings : function() {
        var lessonNumKey = "dayLessonNum";
        var remindTimeKey = "remindTime";
        var multiLangKey = "multiLang";

        var lessonNumKeyIndex = parseInt(cc.sys.localStorage.getItem(lessonNumKey)) || 1;
        var remindTimeKeyIndex = parseInt(cc.sys.localStorage.getItem(remindTimeKey)) || 1;
        var multiLangKeyIndex = parseInt(cc.sys.localStorage.getItem(multiLangKey)) || 1;

        if ( parseInt(cc.sys.localStorage.getItem(lessonNumKey))===0 ) {
            lessonNumKeyIndex = 0;
        }
        if ( parseInt(cc.sys.localStorage.getItem(remindTimeKey))===0 ) {
            remindTimeKeyIndex = 0;
        }
        if ( parseInt(cc.sys.localStorage.getItem(multiLangKey))===0 ) {
            multiLangKeyIndex = 0;
        }

        this.turnOnButtonInArrayWithIndex(this.s1, lessonNumKeyIndex);
        this.turnOnButtonInArrayWithIndex(this.s2, remindTimeKeyIndex);
        if ( isLangCN() ) {
            this.turnOnButtonInArrayWithIndex(this.s3, multiLangKeyIndex);
        }
    },

    turnOnButtonInArrayWithIndex : function(buttons, index) {
        for (var i = 0, num = buttons.length; i < num; i++) {
            var node = buttons[i];
            if (i === index) {
                this.turnYellow(node);
            } else {
                this.turnGray(node);
            }
        }
    },
    turnYellow : function(node) {
        var children = node.getChildren();
        for (var i = 0, num = children.length; i < num; i++ ) {
            var sp = children[i];
            if (sp.constructor.name === "Label" || sp.constructor.name === "Sprite") {
                sp.setColor(cc.color(246, 167, 14));
            }
        }
    },
    turnGray : function(node) {

        var children = node.getChildren();
        for (var i = 0, num = children.length; i < num; i++ ) {
            var sp = children[i];
            if (sp.constructor.name === "Label" || sp.constructor.name === "Sprite") {
                sp.setColor(cc.color(110, 110, 110));
            }
        }
    },
    popToRate : function() {
        cc.log("popToRate");
    },
    goPrivateLink : function() {
        cc.log("goPrivateLink");
    },
    setupBackButton : function() {
        var winSize = cc.director.getWinSize();

        var buttonSprite = cc.Scale9Sprite.create("all_Ui/backButton.png");
        this.backButton = cc.ControlButton.create(buttonSprite);
        this.backButton.setPreferredSize(buttonSprite.getOriginalSize());
        this.addChild(this.backButton, ZOrder_UI);
        this.backButton.setPosition(winSize.width*0.08, winSize.height*0.9);
        this.backButton.addTargetWithActionForControlEvents(this, this.backButtonTapped, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
    },
    backButtonTapped : function() {
        EKCoreManager.getInstance().gotoHome();
    }
});

var EKParentMain = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKParentMainLayer();
        this.addChild(layer);
    }
});