/**
 * Created by apple on 14-8-16.
 */

cc.BuilderReader.registerController("EKMapLayer", {
    onDidLoadFromCCB: function() {
        this.setupMapButtons();
        var self = this;
        var winSize = cc.director.getWinSize();
        
        

        this.rootNode.schedule(function () {
            var m = EKCoreManager.getInstance();
            m.currentReminderTickingTime++;
            var remindTimekey = "remindTime";
            var remindTimeNum = parseInt(cc.sys.localStorage.getItem(remindTimekey));
            var remindTime;
            if (remindTimeNum == 0) {
                remindTime = 10 * 60;
            } else if (remindTimeNum == 2) {
                remindTime = 30 * 60;
            } else {
                remindTime = 20 * 60;
            }
            if (m.currentReminderTickingTime == remindTime) {
                m.currentReminderTickingTime = 0;
                m.showGuideWithSoundFiles();
            }
        }, 1);

        var m = EKCoreManager.getInstance();
        if (!m.isFromHome) {
            cc.audioEngine.stopAllEffects();
            cc.audioEngine.stopMusic(true);
            cc.audioEngine.playMusic("sounds/bgm_big_map.mp3", true);
        }

        m.isFromHome = false;
        m.isInMapLayer = true;
        var todayLessonUnlockedKey = "todayLessonUnlockedKey";
        var todayMaxLevelIndexReachKey = "todayMaxLevelIndexReachKey";
        var levelUnlocked = parseInt(cc.sys.localStorage.getItem(todayLessonUnlockedKey));
        if (!levelUnlocked) {
            levelUnlocked = m.currentPlayingLevelIndex;
            cc.sys.localStorage.setItem(todayMaxLevelIndexReachKey, levelUnlocked);
        }
        
        //暂停动画
        this.stopAutoCCBActions(this.mapScrollview);

        ////////////////////
        var isNewDay = this.isNewDay();
        cc.log("isNewDay " + isNewDay);
        if (isNewDay) {
            levelUnlocked = 0;
            cc.sys.localStorage.setItem(todayLessonUnlockedKey, levelUnlocked);

            var today = new Date();
            var localStorageDateYear = today.getFullYear();
            var localStorageDateMonth = today.getMonth();
            var localStorageDateDay = today.getDate();
            cc.sys.localStorage.setItem("localStorageDateYear", localStorageDateYear);
            cc.sys.localStorage.setItem("localStorageDateMonth", localStorageDateMonth);
            cc.sys.localStorage.setItem("localStorageDateDay", localStorageDateDay);
        }
        ///////////////////////////

        this.latestLevelIndex = m.latestUnlockedLevelAndSubLevel()[0];

        cc.log("todayMaxLessonNum " + m.todayMaxLessonNum() + " " + levelUnlocked + " " + m.currentPlayingLevelIndex + " " + m.latestUnlockedLevelAndSubLevel());

        if (levelUnlocked >= m.todayMaxLessonNum() && m.todayMaxLessonNum()!== -1) {
            this.maxLevelIndex = parseInt(cc.sys.localStorage.getItem(todayMaxLevelIndexReachKey));
        } else if (m.todayMaxLessonNum()=== -1) {
            this.maxLevelIndex = 999;
        } else {
            this.maxLevelIndex = 999;
        }

        if (this.latestLevelIndex === 3) {
            var isGetFirstThreeLessonAward = cc.sys.localStorage.getItem("isGetFirstThreeLessonAward");
            if (!isGetFirstThreeLessonAward) {
                var message = "宝宝真棒！已经完成了基础的字母课程，获得了45米粒的奖励！";
                var alert = new EKAlertWindow( message, 18, 1, this, function () {
                    alert.runAction(cc.sequence(
                        cc.scaleTo(0.5, 0).easing(cc.easeBackIn()),
                        cc.callFunc(function() {
                            alert.removeFromParent(true);
                        })
                    ));
                });
                this.rootNode.addChild(alert);
                EKCoreManager.getInstance().addMiCoinToUser(45);
                cc.sys.localStorage.setItem("isGetFirstThreeLessonAward", true);
            }
        }

        this.refreshMapButtonStatus();
        this.hintLatestLevelButton();

        this.setupMiliButton();  			

        if (winSize.width/winSize.height > 1.77) {
            this.mapScrollview.setScaleY(0.84);
        } else if (winSize.width/winSize.height > 1.5) {
            this.mapScrollview.setScaleY(0.86);
        }

        var last = parseInt(cc.sys.localStorage.getItem("LAST_MAP_LETTER_INDEX"))||0;  //最后玩的课程序号
        this.mapScrollToIndex(last, true);
        this.setupMM(this.rootNode.getChildByTag(20).getContainer().getChildByTag(100).getPosition());

        var unlockIndex = parseInt(m.latestUnlockedLevelAndSubLevel()[0]);
        var mask = new cc.LayerColor(cc.color(0,0,0,50), winSize.width.width, winSize.height);
        mask.setPosition(cc.p(0,0));
        if (!cc.sys.localStorage.getItem("mapAnimationDone"))   //UFO飞船
        {
        	this.mapScrollview.setTouchEnabled(false);  //禁用滚动
            this.miliButton.setVisible(false);
            this.rootNode.addChild(mask);
            this.mmMiyaMina.setVisible(false);
            this.buyButton.setScale(0);
            this.backButton.setScale(0);

            var UFO = cc.BuilderReader.load("enter_ani/enter_ani");
            this.rootNode.addChild(UFO, 100);


            if (winSize.width/winSize.height > 1.77) {
                UFO.setPosition( this.rootNode.getChildByTag(20).getContainer().getChildByTag(100).getPosition());
                UFO.y -= 50;
            } else {
                UFO.setPosition( this.rootNode.getChildByTag(20).getContainer().getChildByTag(100).getPosition());
                //UFO.y -= 35;
            }

            UFO.animationManager.runAnimationsForSequenceNamed("Default Timeline");

           if (isLangCN()) {
                cc.audioEngine.playEffect("sounds/progressSounds/app_name_zh_cn.mp3");
            } else {
                cc.audioEngine.playEffect("sounds/progressSounds/app_name_en.mp3");
            }
            cc.sys.localStorage.setItem("mapAnimationDone", true);
            this.rootNode.scheduleOnce(function () {
                self.buyButton.runAction(cc.scaleTo(0.5, 1));  
                self.backButton.runAction(cc.scaleTo(0.5, 1));
                self.miliButton.setVisible(true);
                self.mmMiyaMina.setVisible(true);
                UFO.setVisible(false);
                UFO.removeFromParent(true);
                mask.removeFromParent(true);
                
                self.mapScrollview.setTouchEnabled(true);  //启用滚动
            }, 7.8);
            this.buyButton.setScale(0);
            this.backButton.setScale(0);

            

        } 
        else if (!cc.sys.localStorage.getItem("lessonsEnd") && unlockIndex>=26)   //结束动画
        {
        	cc.sys.localStorage.setItem("lessonsEnd", true);
        	
        	var finishAnimation = cc.BuilderReader.load("story_last/all_boom.ccbi");
        	this.mapScrollview.addChild(finishAnimation, 1001);
        	
        	var node = this.mapScrollview.getContainer().getChildByTag(1000);
        	finishAnimation.setPosition(node.getPosition());
        	
        	finishAnimation.animationManager.runAnimationsForSequenceNamed("Default Timeline");
        	
//        	if(!node)
//        	{
//        		cc.log("node FUCK");
//        	}
//        	
//        	if(!node.animationManager)
//        	{
//        		cc.log("animation FUCK");
//        	}
//        	
//        	this.runAnimations(node);
        	//animationManager.runAnimationsForSequenceNamed("Default Timeline");
        	//this.mapScrollview.getContainer.reorderChilde(node, 100);

        	//node.animationManager.runAnimationsForSequenceNamed("Default Timeline");
        	//node
        	
//            this.rootNode.addChild(mask);
//            this.buyButton.setScale(0);
//            this.backButton.setScale(0);
////            this.mapScrollview.getContainer().animationManager.runAnimationsForSequenceNamed("Default Timeline");
//            if (isLangCN()) {
//                cc.audioEngine.playEffect("sounds/progressSounds/journey_end_cn.mp3");
//            } else {
//                cc.audioEngine.playEffect("sounds/progressSounds/journey_end_en.mp3");
//            }
//            cc.sys.localStorage.setItem("lessonsEnd", true);
//            var panda = cc.BuilderReader.load("all lesson finished/panda");
//            panda.setPosition(winSize.width*0.7, winSize.height*(-0.3));
//            this.rootNode.addChild(panda);
//            panda.runAction(cc.sequence(
//                cc.jumpTo(0.5, cc.p(winSize.width*0.6, winSize.height*0.17), winSize.height*0.3, 1)
//            ));
//            this.rootNode.scheduleOnce(function () {
//                mask.runAction(cc.sequence(
//                    cc.jumpTo(0.5, cc.p(winSize.width*0.7, winSize.height*(-0.3)), winSize.height*-0.3, 1)
//                ));
//                mask.scheduleOnce(function () {
//                    self.buyButton.runAction(cc.scaleTo(0.5, 1));
//                    self.backButton.runAction(cc.scaleTo(0.5, 1));
//                }, 0.5);
//            }, 3.5);
        }
        else {
            cc.audioEngine.playEffect("sounds/progressSounds/enter_big_map_woman_" + Math.floor(Math.random()*2+1) + ".mp3")
        }

        this.arrowState = 0;
        this.rootNode.schedule(function () {
            self.changeArrowButton();
        });

        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event){
                if(keyCode == cc.KEY.back) {
                    EKCoreManager.getInstance().gotoHome();
                }
            }
        }, this.rootNode);
    },
    
    stopAutoCCBActions : function(node) {
    	var children = node.getChildren();
    	for (var i=0; i<children.length; i++) {
    		var child = children[i];
    		child.stopAllActions();
    		this.stopAutoCCBActions(child);
    	}
    },
    
    isNewDay : function () {
        var localStorageDate = new Date();
        var localStorageDateYear = cc.sys.localStorage.getItem("localStorageDateYear");
        var localStorageDateMonth = cc.sys.localStorage.getItem("localStorageDateMonth");
        var localStorageDateDay = cc.sys.localStorage.getItem("localStorageDateDay");
        if (!localStorageDateYear) {
            localStorageDateYear = 2014;
            localStorageDateMonth = 7;
            localStorageDateDay = 6;
            cc.sys.localStorage.setItem("localStorageDateYear", localStorageDateYear);
            cc.sys.localStorage.setItem("localStorageDateMonth", localStorageDateMonth);
            cc.sys.localStorage.setItem("localStorageDateDay", localStorageDateDay);
        }
        localStorageDate.setFullYear(parseInt(localStorageDateYear),parseInt(localStorageDateMonth),parseInt(localStorageDateDay));
        var isANewDay = compareDate(localStorageDate);
        return isANewDay;
    },
    "goBackTapped:" : function(sender,controlEvent) {
        EKCoreManager.getInstance().gotoHome();
    },
    "shopTapped:" : function () {
        EKCoreManager.getInstance().isShowMiCoinLayer = false;
        EKCoreManager.getInstance().gotoShop();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.logEvent("Will enter Shop from Big Map");
        }
    },
    "arrowButtonTap:" : function () {
    	// change by andy
    	var last = parseInt(cc.sys.localStorage.getItem("LAST_MAP_LETTER_INDEX"))||0;  //最后玩的课程序号
    	this.mapScrollToIndex(last, false);
    	//end change
        //this.mapScrollToIndex(this.latestLevelIndex, false);  origin one
    },
    //滚动到第几课去,isInstant表示是否有动画过去
    mapScrollToIndex : function (index, isInstant) {
        if (index >= this.mapButtons.length) 
        	return;
        cc.log("latestLevelIndex :", index);
        //andy solution
        var winSize = cc.director.getWinSize();
        var b = this.mapButtons[index];
        var p = b.getPosition();  
        //var p = b.getParent().convertToWorldSpace(b.getPosition());  
        cc.log("button positon :", b.getPosition().x, b.getPosition().y);
        var scrollContentSize = this.mapScrollview.getContainer().getContentSize();
        
        var DestinationScrollOffset = p;
        //如果p.x靠近边缘（左边缘，右边缘）
        if(p.x <= winSize.width/2) //左边缘（小于等于屏幕中心）
        {
        	DestinationScrollOffset.x = 0;
        }
        else if(p.x >= scrollContentSize.width - winSize.width/2) //右边缘(大于等于contentSize-屏幕的一半)
        {
        	DestinationScrollOffset.x = winSize.width - scrollContentSize.width ; 
        }
        else  //其他情况，移到中心位置
        {
        	DestinationScrollOffset.x = winSize.width/2 - p.x;
        }
        
        //考虑到当前偏移量的情况
        var scrollPos = this.mapScrollview.getContentOffset();  //当前的偏移量
        //DestinationScrollOffset.x -= scrollPos.x;
        DestinationScrollOffset.y = scrollPos.y;
        cc.log("content offset: x = ", DestinationScrollOffset.x, "y =" ,DestinationScrollOffset.y);
        //滚动
        if (isInstant) {
        	this.mapScrollview.getContainer().setPosition(DestinationScrollOffset);
        } else {
        	this.mapScrollview.setContentOffsetInDuration(DestinationScrollOffset, 1);   //从当前位置开始，到DestinationScrollOffset，所以前面的不用考虑当前偏移量
        }

//        //bran solution
//        var winSize = cc.director.getWinSize();
//        var b = this.mapButtons[index];
//        var p = b.getParent().convertToWorldSpace(b.getPosition());
//        var disToCenter = cc.p(winSize.width/2- p.x, winSize.height/2- p.y);
//        var scrollPos = this.mapScrollview.getContentOffset();
//        scrollPos.x += disToCenter.x;
//        if (scrollPos.x>0) {
//            scrollPos.x = 0;
//        } else if (scrollPos.x<-this.mapScrollview.getContainer().getContentSize().width-winSize.width) {
//            scrollPos.x = -this.mapScrollview.getContainer().getContentSize().width-winSize.width;
//        }
//        scrollPos.x = -4375+512;
//        if (isInstant)
//        {
//            this.mapScrollview.getContainer().setPosition(scrollPos);
//        } else 
//        {
//            this.mapScrollview.setContentOffsetInDuration(scrollPos, 0.1);
//        }
    },
    setupMM : function () {
        var winSize = cc.director.getWinSize();
        this.mmMiyaMina = cc.Sprite.create("map/lastPos.png");
        this.mapScrollview.getContainer().addChild(this.mmMiyaMina, ZOrder_UI+4);
        var targetPos = this.mapButtons[this.latestLevelIndex].getPosition();
        //miya和mina的位置
        var tmpLayer = this.mapScrollview.getContainer().getChildByTag(100+this.latestLevelIndex+1);
        targetPos = tmpLayer.getPosition();
        if (winSize.width/winSize.height > 1.774) {
            this.mmMiyaMina.setScaleX(0.85);
        } else {
            this.mmMiyaMina.setScaleX(0.88);
        }

        var key = "MM_IN_MAP_HAS_GOTO:" + this.latestLevelIndex;

        if (!cc.sys.localStorage.getItem(key) && this.latestLevelIndex!==0) {
            cc.sys.localStorage.setItem(key, true);
            var prePos = this.mapButtons[this.latestLevelIndex-1].getPosition();
            var tmpLayer = this.mapScrollview.getContainer().getChildByTag(100+this.latestLevelIndex);
            prePos = tmpLayer.getPosition();
            this.mmMiyaMina.setPosition(prePos);
            targetPos.y += 15;
            this.mmMiyaMina.runAction(
                cc.moveTo(1.3, targetPos)
            )
        } else {
            targetPos.y += 15;
            this.mmMiyaMina.setPosition(targetPos);
            this.mmMiyaMina.setVisible(true);
        }
    },
    
    //设置地图按钮（点击开始一课）
    setupMapButtons : function() {
        this.mapButtons = [];
        this.elements = [];
        var mapScrollview = this.mapScrollview.getChildren()[0]; //滚动的地图视图
        var children = mapScrollview.getChildren();
        for (var i=0; i<children.length; i++) {
            var element = children[i];
            if (element.constructor.name == "ControlButton") {
                element.removeFromParent(true);
//                this.mapButtons.push(element);
            }
            if (element.getTag() === 10) {
//                var button = new ccui.ImageView();
//                mapScrollview.addChild(button);
//                button.setPosition(element.getPosition());
                this.elements.push(element);
            }
        }

        for (var i=0; i<this.elements.length; i++) {
            var self = this;
            var letter = EKLevelsName[i];
//            var button = this.mapButtons[i];
//            button.loadTexture("map/"+letter+".png");
//            button.setTouchEnabled(true);

            var button = cc.Sprite.create("map/"+letter+".png");
            this.mapButtons.push(button);
            button.setPosition(this.elements[i].getPosition());
            button.index = i;
            mapScrollview.addChild(button);

            var listener = cc.EventListener.create({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: false,                       // 设置是否吞没事件，在 onTouchBegan 方法返回 true 时吞掉事件，不再向下传递。
                onTouchBegan: function (touch, event) {     //实现 onTouchBegan 事件处理回调函数
                    var target = event.getCurrentTarget();  // 获取事件所绑定的 target, 通常是cc.Node及其子类

                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width, s.height);

                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        target.setScale(1.1);
                        self.touchBeganPosition = touch.getLocation();
                        self.isMoved = false;
                        return true;
                    }
                    return false;
                },
                onTouchMoved : function (touch, event) {
                    var target = event.getCurrentTarget();
                    var delta = touch.getDelta();
                    self.touchMovedPosition = touch.getLocation();
                    if (cc.pDistance(self.touchMovedPosition, self.touchBeganPosition) > 30) {
                        self.isMoved = true;
                    }
                },
                onTouchCancelled: function (touch, event) {
                    var target = event.getCurrentTarget();
                    target.setScale(1);
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    target.setScale(1);

                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width, s.height);
                    if (cc.rectContainsPoint(rect, locationInNode) && !self.isMoved) {
                        self.mapButtonTapped(target.index);
                    }
                }
            });
            cc.eventManager.addListener(listener, button);

//            button.addTouchEventListener(this.mapButtonTouchEvent, this);
        }


//        var buttonListener = cc.EventListener.create({
//            event: cc.EventListener.TOUCH_ONE_BY_ONE,
//            swallowTouches: false,
//            onTouchBegan: function (touch, event) {
//                var target = event.getCurrentTarget();
//                var locationInNode = target.convertToNodeSpace(touch.getLocation());
//                var s = target.getContentSize();
//                var rect = cc.rect(0, 0, s.width, s.height);
//                if (cc.rectContainsPoint(rect, locationInNode)) {
//                    target.setScale(1.1);
//                    return true;
//                }
//                return false;
//            },
//            onTouchMoved: function (touch, event) {
//
//            },
//            onTouchEnded: function (touch, event) {
//                var target = event.getCurrentTarget();
//                target.setScale(1);
//                var locationInNode = target.convertToNodeSpace(touch.getLocation());
//                var s = target.getContentSize();
//                var rect = cc.rect(0, 0, s.width, s.height);
//                if (cc.rectContainsPoint(rect, locationInNode)) {
//                    self.mapButtonTapped(j);
//                }
//            }
//        });


//        for (var j=0; j<this.mapButtons.length; j++) {
//            var self = this;
//            var button = this.mapButtons[j];
//            button.addTargetWithActionForControlEvents(this, function(j){
//                return function() {
//                    self.mapButtonTapped(j);
//                };
//            }(j), cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
//        }
    },
    mapButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                this.mapButtonTapped(sender.index);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default :
                break;
        }
    },
    
    mapButtonTapped : function(index) {
        var manager = EKCoreManager.getInstance();
        
        //新故事马上就到
//        if (index >= 15) 
//        {
//        	//开启中文提示
//            if (manager.getSettingsMultiLang() === 1 && isLangCN()) {
//                cc.audioEngine.stopAllEffects();
//                cc.audioEngine.stopMusic();
//                cc.audioEngine.playEffect("sounds/progressSounds/click_lesson_new_story_zh_cn.mp3");
//            } else {
//                cc.audioEngine.stopAllEffects();
//                cc.audioEngine.stopMusic();
//                cc.audioEngine.playEffect("sounds/progressSounds/click_lesson_new_story_en.mp3");
//            }
//            return;
//        }

        if (!manager.isLevelPurchasedInSubLevel(index, 0)) 
        {
            this.buyButtonTapped(index);  //购买
        } 
        else
        if (!manager.isLevelUnlockedAndSubLevel(index, 0))
        {
            if (manager.getSettingsMultiLang() === 1 && isLangCN()) {  //解锁
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.stopMusic();
                cc.audioEngine.playEffect("sounds/progressSounds/unlock.mp3");
            } else {
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.stopMusic();
                cc.audioEngine.playEffect("sounds/progressSounds/unlock_eng.mp3");
            }
        } else if (index >= this.maxLevelIndex) //到达今天学习课程的限制 
        {
            if (manager.getSettingsMultiLang() === 1 && isLangCN()) {
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.stopMusic();
                cc.audioEngine.playEffect("sounds/progressSounds/click_lesson_locked_today_zh_cn_" + Math.floor(Math.random()*2+1) + ".mp3");
            } else {
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.stopMusic();
                cc.audioEngine.playEffect("sounds/progressSounds/click_lesson_locked_today_en.mp3");
            }
        } else
        {  // 进入故事
            manager.currentPlayingLevelIndex = index;
            manager.currentPlayingSubLevelIndex = manager.changeModeNameToSubLevelIndexWithMode(index, 0);
            manager.gotoStoryMain();
            cc.sys.localStorage.setItem("LAST_MAP_LETTER_INDEX", manager.currentPlayingLevelIndex);
        }
    },
    refreshMapButtonStatus : function () {
        var m = EKCoreManager.getInstance();
        for (var i=0; i<this.mapButtons.length; i++) {
            var button = this.mapButtons[i];

            cc.log(i + " " + this.maxLevelIndex + " " + m.isLevelPurchasedInSubLevel(i, 0) + " " + m.isLevelUnlockedAndSubLevel(i, 0));

            var sprite1 = cc.Sprite.create("map/" + String.fromCharCode(65+i) + ".png");
            this.changeShader("gray", sprite1);

            if ( !m.isLevelPurchasedInSubLevel(i, 0) ) {
                button.addChild(sprite1);
                sprite1.setPosition(button.getContentSize().width/2, button.getContentSize().height/2);

                var buy = cc.Sprite.create("map/level_buy.png");
                buy.setPosition(cc.p(button.getContentSize().width/2, button.getContentSize().height/2));
                button.addChild(buy);
                // TODO: 适配
            } else if (!m.isLevelUnlockedAndSubLevel(i, 0)) {
                button.addChild(sprite1);
                sprite1.setPosition(button.getContentSize().width/2, button.getContentSize().height/2);

                var lock = cc.Sprite.create("map/level_lock.png");
                lock.setPosition(cc.p(button.getContentSize().width/2, button.getContentSize().height/2));
                button.addChild(lock);
                // TODO: 适配
            } else if (i >= this.maxLevelIndex) {

                button.addChild(sprite1);
                sprite1.setPosition(button.getContentSize().width/2, button.getContentSize().height/2);

                var lock = cc.Sprite.create("map/level_lock.png");
                lock.setPosition(cc.p(button.getContentSize().width/2, button.getContentSize().height/2));
                button.addChild(lock);
            }
        }
    },
    hintLatestLevelButton : function () {
        if (this.latestLevelIndex >= this.mapButtons.length) {
            this.latestLevelIndex = this.mapButtons.length-1;
        }
        var button = this.mapButtons[this.latestLevelIndex];
        var diaMond = cc.Sprite.create("UI_star.png");
        diaMond.setPosition(button.getPosition());
        diaMond.setLocalZOrder(button.getLocalZOrder()-1);
        diaMond.setOpacity(100);
        diaMond.runAction(cc.sequence(
            cc.scaleTo(0.6, 1.3),
            cc.scaleTo(0.6, 1)
        ).repeatForever());
    },
    changeArrowButton : function () {
        var winSize = cc.director.getWinSize();
        //changed by andy
        var last = parseInt(cc.sys.localStorage.getItem("LAST_MAP_LETTER_INDEX"))||0;  //最后玩的课程序号
        var latestButton = this.mapButtons[last];
        
        //var latestButton = this.mapButtons[this.latestLevelIndex]; //origin one
        //end change
        var pos = latestButton.getParent().convertToWorldSpace(latestButton.getPosition());
        pos = this.rootNode.convertToNodeSpace(pos);
        if (pos.x < 0) {
            if (this.arrowState === 0) return;
            this.arrowButton.setScaleX(-1);
            this.arrowButton.runAction(cc.sequence(
                cc.scaleTo(0.8, -1.1, 1.1),
                cc.scaleTo(0.8, -1, 1)
            ).repeatForever());
            this.arrowState = 0;
            this.arrowButton.setVisible(true);
            this.arrowButton.setPosition(this.arrowButton.getContentSize().width/2+25, winSize.height/2);
        } else if (pos.x > this.rootNode.getContentSize().width) {
            if (this.arrowState === 1) return;
            this.arrowButton.setScaleX(1);
            this.arrowButton.runAction(cc.sequence(
                cc.scaleTo(0.8, 1.1, 1.1),
                cc.scaleTo(0.8, 1, 1)
            ));
            this.arrowState = 1;
            this.arrowButton.setVisible(true);
            this.arrowButton.setPosition(cc.p(this.rootNode.getContentSize().width-this.arrowButton.getContentSize().width/2-25, winSize.height*0.5));
        } else {
            if (this.arrowState === 2) return;
            this.arrowButton.stopAllActions();
            this.arrowState = 2;
            this.arrowButton.setVisible(false);
        }
    },
    changeShader : function(shaderName, sprite) {
        var shader = cc.GLProgram.create(shaderName+".vsh", shaderName+".fsh");
        shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
        shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);

        shader.link();
        shader.updateUniforms();
        sprite.setShaderProgram(shader);
    },

    setupMiliButton : function () {
        var winSize = cc.director.getWinSize();
        // Create the button
        this.miliButton = new ccui.Button();
        this.miliButton.setTouchEnabled(true);
        this.miliButton.loadTextures("all_Ui/ui_coin_box.png", "all_Ui/ui_coin_box.png", "");
        this.miliButton.x = winSize.width * 0.3;
        this.miliButton.y = winSize.height * 0.9;
        this.miliButton.addTouchEventListener(this.miCoinButtonTouchEvent, this);
        this.rootNode.addChild( this.miliButton, ZOrder_UI);

        this.refreshMiliButton();
    },
    refreshMiliButton : function() {
        var buttonSize = this.miliButton.getContentSize();
        if (this.coin) {
            this.coin.removeFromParent(true);
        }
        this.coin = new ccui.Text();
        var coinText = cc.sys.localStorage.getItem("MyCoin") || 0;
        this.coin.setString(coinText);
        this.coin.setFontSize(13);
        this.coin.setColor(cc.color.WHITE);
        this.coin.setPosition(cc.p(buttonSize.width/2-2, buttonSize.height*0.52));
        this.miliButton.addChild(this.coin);
    },
    miCoinButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                cc.audioEngine.playEffect("sounds/effect/sounds_of_click_button.mp3");

                EKCoreManager.getInstance().isShowMiCoinLayer = true;

                this.rootNode.scheduleOnce(function () {
                    EKCoreManager.getInstance().gotoShop();
                }, 0.2);
                if(isOpenAnySdk == true){
                var agent = anysdk.AgentManager.getInstance();
                var analytics_plugin = agent.getAnalyticsPlugin();
                analytics_plugin.logEvent("Will enter Shop from Big Map of Mili Button");
                }
                break;
            default:
                break;
        }
    },

    //点击购买按钮
    buyButtonTapped : function (index) {
        var key = "purchased";
        var level = cc.sys.localStorage.getItem(key);
        if (!level || level.indexOf(",") === -1) {
            level = "2,0";
        }
        var lesston = level.split(",");
        var latestPurchasedLesson = parseInt(lesston[0]);
        if ( (latestPurchasedLesson+1) === index ) {
            this.setupBuyBox(index);   //购买对话框
        } else {
            var alert = new EKAlertWindow("请先购买前面的关卡哦！", 20, 1, this, function () {
                alert.removeFromParent(true);
            });
            this.rootNode.addChild(alert, 100);
        }
    },
    //购买对话框
    setupBuyBox : function (index) {
        this.setupMask();
        var winSize = this.maskLayout.getContentSize();

        var bg = new ccui.Layout();
        bg.setBackGroundImage("shop/buyLayer.png");
        bg.setContentSize(winSize.width, winSize.height);
        bg.setScale(0.85);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(winSize.width/2, winSize.height/2);
        this.maskLayout.addChild(bg);

        var closeButton = new ccui.Button();
        closeButton.setTouchEnabled(true);
        closeButton.loadTextures("all_Ui/ui_close.png", "all_Ui/ui_close.png");
        closeButton.x = winSize.width * 0.75;
        closeButton.y = winSize.height * 0.75;
        if (winSize.width/winSize.height < 1.35) {
            closeButton.setPosition(cc.p(winSize.width*0.73, winSize.height*0.73));
        }
        closeButton.addTouchEventListener(this.closeButtonTouchEvent, this);
        this.maskLayout.addChild(closeButton);

        var title = new ccui.Text();
        var m = EKCoreManager.getInstance();
        var currentLetter = EKLevelsName[index];
        var titleText = "字母" + currentLetter;
        title.setString(titleText);
        title.setFontName("FZCuYuan-M03S.ttf");
        title.setFontSize(24);
        title.setColor(cc.color(250, 160, 0));
        title.setPosition(cc.p(winSize.width/2, winSize.height*0.78)); //origin 0.83
        if (winSize.width/winSize.height < 1.35) {
            title.setPosition(cc.p(winSize.width/2, winSize.height*0.69)); //origin 0.74
        }
        this.maskLayout.addChild(title);

        var subtitle = new ccui.Text();
        var subtitleText = m.wordInfoDict[currentLetter]["titleCN"];
        subtitleText = "第" + (index+1) + "课《" + subtitleText + "》";
        subtitle.setString(subtitleText);
        subtitle.setFontName("FZCuYuan-M03S.ttf");
        subtitle.setFontSize(15);
        subtitle.setColor(cc.color(250, 160, 0));
        subtitle.setPosition(cc.p(winSize.width/2, winSize.height*0.71));  //origin 0.73
        if (winSize.width/winSize.height < 1.35) {
            subtitle.setPosition(cc.p(winSize.width/2, winSize.height*0.62));  //origin 0.64
        }
        this.maskLayout.addChild(subtitle);

        var preImage = new ccui.ImageView();
        preImage.loadTexture("preview/" + (index+1) + ".jpg");
        preImage.x = winSize.width/2;
        preImage.y = winSize.height * 0.5;
        this.maskLayout.addChild(preImage);

        var coin = 45;
        var tips = new ccui.Text();
        var tipsText = "需要花费" + coin + "米粒";
        tips.setString(tipsText);
        tips.setFontName("FZCuYuan-M03S.ttf");
        tips.setFontSize(15);
        tips.setColor(cc.color(250, 160, 0));
        tips.setPosition(cc.p(winSize.width * 0.42, winSize.height*0.28)); //origin 0.25
        if (winSize.width/winSize.height < 1.35) {
            tips.setPosition(cc.p(winSize.width * 0.42, winSize.height*0.23)); //origin 0.32
        }
        this.maskLayout.addChild(tips);

        var buyButton = new ccui.Button();
        buyButton.setTouchEnabled(true);
        buyButton.loadTextures("shop/confirm.png", "shop/confirm.png");
        buyButton.x = winSize.width * 0.63;            //orgin 0.63
        buyButton.y = winSize.height * 0.28;			//orgin 0.25
        if (winSize.width/winSize.height < 1.35) {
            buyButton.setPosition(cc.p(winSize.width * 0.63, winSize.height*0.23));
        }
        buyButton.addTouchEventListener(this.confirmButtonTouchEvent, this);
        this.maskLayout.addChild(buyButton);
        buyButton.setScale(0.85);

        this.mapButton = this.mapButtons[index];

        this.purchasedIndex = index;

        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.logEvent("Click the button of lesson in Big Map", {"lesson": currentLetter});
        }
        this.currentLetter = currentLetter;
    },
    setupMask : function () {
        var winSize = cc.director.getWinSize();
        this.maskLayout = new ccui.Layout();
        this.maskLayout.setContentSize(winSize.width, winSize.height);
        this.maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        this.maskLayout.setBackGroundColorOpacity(100);

        this.rootNode.addChild(this.maskLayout, ZOrder_UI+1);
        this.maskLayout.setTouchEnabled(true);
    },

    closeButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                this.maskLayout.removeFromParent(true);
                break;
            default :
                break;
        }
    },
    confirmButtonTouchEvent : function (sender, type) {
        var self = this;
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.05);
                break;
            case ccui.Widget.TOUCH_ENDED:
                cc.audioEngine.playEffect("sounds/effect/sounds_of_click_button.mp3");

                var priceOfLesson = 45;
                var numOfMiCoin = parseInt(cc.sys.localStorage.getItem("MyCoin")) || 0;

                if (priceOfLesson >= numOfMiCoin) {
                    var alert = new EKAlertWindow("哎呀，米粒好像不够了，妈妈我想继续学习！", 20, 1, this, function () {
                        EKCoreManager.getInstance().isFromHomeToShop = false;
                        EKCoreManager.getInstance().gotoShop();
                    });
                    this.rootNode.addChild(alert, 101);
                } else {
                    var key = "purchased";
                    var level = cc.sys.localStorage.getItem(key);
                    if (!level || level.indexOf(",") === -1) {
                        level = "0,0";
                    }
                    level = this.purchasedIndex + ",0";
                    cc.sys.localStorage.setItem(key, level);
                    EKCoreManager.getInstance().addMiCoinToUser(0-priceOfLesson);
                    this.maskLayout.removeFromParent(true);
                    this.refreshMiliButton();

                    var alert1 = new EKAlertWindow("太棒了，已经解锁成功！全新课程、即刻出发！", 20, 1, this, function () {
                        self.mapButton.removeAllChildren();

                        self.refreshMapButtonStatus();
                    });
                    this.rootNode.addChild(alert1, 101);

                    var currentPlayingLevelIndex = EKCoreManager.getInstance().currentPlayingLevelIndex;
                    var currentProgress = EKLevelsName[currentPlayingLevelIndex];
                    if(isOpenAnySdk == true){
                    var agent = anysdk.AgentManager.getInstance();
                    var analytics_plugin = agent.getAnalyticsPlugin();
                    analytics_plugin.logEvent("Buy lesson Successfully", {"lesson": self.currentLetter, "current progress": currentProgress});
                    }
                }

                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default :
                break;
        }
    },
    isNewDate : function () {
        var checkDate = new Date();
        var checkYear = cc.sys.localStorage.getItem("lessonYear");
        var checkMonth = cc.sys.localStorage.getItem("lessonMonth");
        var checkDay = cc.sys.localStorage.getItem("lessonDay");
        if (!checkYear) {
            checkYear = 2014;
            checkMonth = 7;
            checkDay = 6;
            cc.sys.localStorage.setItem("checkYear", checkYear);
            cc.sys.localStorage.setItem("checkMonth", checkMonth);
            cc.sys.localStorage.setItem("checkDay", checkDay);
        }
        checkDate.setFullYear(parseInt(checkYear),parseInt(checkMonth),parseInt(checkDay));

        var isNewDate = compareDate(checkDate);
        return isNewDate;
    }
});