/**
 * Created by bran on 14-9-13.
 */

var EKReadAloudLayer = EKSectionBasicLayer.extend({
    ctor : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
        }
        //随机顺序
        var appearSequence = [0, 1, 2];
        this.appearSequence = _.shuffle(appearSequence);

        this.state = 0;

        this.showdWordCount = 0;  //已经显示的单词数，点击卡片后猫头鹰出来增一
        
        this.readSuccessful = 0;

        this.wordCardArray = [];
        var manager = EKCoreManager.getInstance();
//        var currentWordInfos = manager.currentWordInfos();
        var wordInfos = manager.wordInfos();
        var currentWordInfos = wordInfos[EKLevelsName[parseInt(manager.currentPlayingLevelIndex)]]["words"];
        var preWords;
        var preWord;
        
        if (parseInt(manager.currentPlayingLevelIndex)>0) {
            preWords = wordInfos[EKLevelsName[parseInt(manager.currentPlayingLevelIndex)-1]]["words"];
            cc.log("preWords " + preWords.length);
            cc.log("preWords " + preWords);
            if (preWords.length > 1) {
                preWord = preWords[Math.random()>0.5?0:1];
                cc.log("preWord " + preWord);
            } else {
                preWord = preWords[0];
            }
        } else {
        	preWord = undefined;  //第一课不添加复习单词
        	this.appearSequence.shift();
        	//this.appearSequence.splice(this.appearSequence.indexOf(2), 1);
//            preWords = wordInfos[EKLevelthissName[parseInt(manager.currentPlayingLevelIndex)]]["words"];
//            preWord = preWords[Math.random()>0.5?0:1];
        }

        //添加前一课随机单词一个
        this.wordArray = currentWordInfos;
        if(undefined !== preWord)
        {
        	this.wordArray = this.wordArray.concat(preWord);
        }
        for (var i=0; i<this.wordArray.length; i++) {
            cc.log("i " + i + this.wordArray[i]);
            var w = this.wordArray[i];
            var path = "words_info/" + w.toUpperCase() + ".png";
            this.wordCardArray.push(path);
        }

        this.setupBG();
        this.setupAnimal();
        this.setupHole();
        this.setupTouchEvent();
        this.scheduleOnce(this.startAnimation, 1);
        
        
        cc.audioEngine.stopMusic(true);
        cc.audioEngine.stopAllEffects();
        cc.audioEngine.playMusic("sounds/bgm_dashengdu.mp3", true);

        return true;
    },
    setupBG : function () {
        var winSize = cc.director.getWinSize();

        this.bg = cc.BuilderReader.load("readaloud/readaloud_main");
        this.addChild(this.bg);

        if (winSize.width/winSize.width > 1.4) {
            this.bg.setScaleY(0.9);
        }

        var bg1 = this.bg.getChildByTag(6);
        var bg2 = this.bg.getChildByTag(7);
        bg1.removeFromParent(false);
        bg2.removeFromParent(false);
        this.addChild(bg1, 11);
        this.addChild(bg2, 10);

        this.maskLayout = new ccui.Layout();
        this.maskLayout.setContentSize(winSize.width, winSize.height);
        this.maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        this.maskLayout.setBackGroundColorOpacity(100);
        this.addChild(this.maskLayout, 15);
        this.maskLayout.setVisible(false);
        this.maskLayout.setTouchEnabled(false);
    },
    setupAnimal : function() {
        var winSize = cc.director.getWinSize();

        this.owl = new cc.Node();
        var owl = cc.BuilderReader.load("readaloud/readaloud_Squirrel");
        owl.setPosition(winSize.width/2, -winSize.height*0.52);
        this.owl.addChild(owl);
        this.addChild(this.owl, 20);

        this.cat = cc.BuilderReader.load("readaloud/readaloud_cat");
        this.addChild(this.cat);
        this.cat.setPosition(winSize.width*0.92, winSize.height*0.08);
        this.cat.animationManager.runAnimationsForSequenceNamed("stop");
        this.cat.originalP = this.cat.getPosition();

        this.raccoon = cc.BuilderReader.load("readaloud/readaloud_raccoon");
        this.addChild(this.raccoon);
        this.raccoon.setAnchorPoint(0.5, 0.5);
        this.raccoon.setPosition(winSize.width*0.05, winSize.height*0.08);
        this.raccoon.animationManager.runAnimationsForSequenceNamed("stop");
        this.raccoon.originalP = this.raccoon.getPosition();
    },
    setupHole : function() {
        var winSize = cc.director.getWinSize();
        this.chickenArray = [];
        this.cards = [];

        for (var i=0; i<3; i++) {
            var chickenCCB = cc.BuilderReader.load("readaloud/readaloud_chicken");
            chickenCCB.touchName = "chicken";
            var chicken = new cc.Node();
            chicken.addChild(chickenCCB);
            chicken.setPosition(this.bg.getChildByTag(101+i).getPosition());

            if (winSize.width/winSize.height > 1.77) {
                chicken.y = chicken.y+10;
            }

            this.bg.getChildByTag(101+i).setVisible(false);
            this.chickenArray.push(chicken);
            chickenCCB.animationManager.runAnimationsForSequenceNamed("normal");
            chicken.originalX = chicken.x;
            chicken.originalY = chicken.y;
            chicken.state = 0;

            var card = cc.Sprite.create("readaloud/wordCardBack.png");
            card.touchName = "card";
            card.setPosition(cc.p(0, chickenCCB.getContentSize().height*0.9));
            card.originalX = card.x;
            card.originalY = card.y;
            this.cards.push(card);
            chicken.addChild(card);
            card.setVisible(false);

            var mask = cc.Sprite.create("readaloud/mask.png");

            var pos;
            if (winSize.width/winSize.height >= 1.77) {
                pos = this.bg.getChildByTag(31+i).getPosition();
            } else if (winSize.width/winSize.height < 1.77 && winSize.width/winSize.height >=1.61){
                pos = this.bg.getChildByTag(41+i).getPosition();
            } else if (winSize.width/winSize.height < 1.61 && winSize.width/winSize.height >1.5) {
                pos = this.bg.getChildByTag(21+i).getPosition();
            } else {
                pos = this.bg.getChildByTag(11+i).getPosition();
            }

            mask.setPosition(pos);
            // TODO 适配

            var clipper = new cc.ClippingNode();
            clipper.alphaThreshold = 0.05;
            clipper.setInverted(false);
            this.addChild(clipper);
            clipper.setStencil(mask);

            clipper.addChild(chicken);
        }
    },
    
    //三个或两个小鸡一起出来动画又回去
    startAnimation : function() {
        var winSize = cc.director.getWinSize();
        this.scheduleOnce(function(){
            cc.audioEngine.playEffect("sounds/effect/dashengdu_greeting.mp3");
        }, 1);
        for (var i=0; i<this.wordArray.length; i++) 
        {
        	//随机顺序出来小鸡
        	var chicken =  this.chickenArray[this.appearSequence[i]];
            chicken.runAction(cc.sequence(
                cc.moveTo(1+Math.random()/3, cc.p(chicken.x, chicken.y+winSize.height*0.13)),
                cc.delayTime(0.1),
                cc.sequence(
                    cc.rotateTo(0.07,3),
                    cc.rotateTo(0.14, -3),
                    cc.rotateTo(0.035, 0)
                ).repeat(2),
                cc.moveTo(1+Math.random()/3, cc.p(chicken.originalX, chicken.originalY))
            ));
        }
        this.scheduleOnce(this.startGame, 3.4);
    },
    startGame : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        var appearSeq = this.appearSequence[0];
        var chicken = this.chickenArray[appearSeq];
        chicken.runAction(cc.sequence(
            cc.spawn(
                cc.moveTo(1.3, cc.p(chicken.x, chicken.y+winSize.height*0.2)).easing(cc.easeElasticOut()),
                cc.sequence(
                    cc.delayTime(1),
                    cc.callFunc(function() {
                        chicken.getChildren()[0].animationManager.runAnimationsForSequenceNamed("handsUp");
                        chicken.getChildren()[0].state = 1;
                        chicken.getChildren()[1].setVisible(true);
                        self.cardShake(chicken.getChildren()[1]);
                        self.state = 1;
                    })
                )
            )
        ));
    },
    setupTouchEvent : function() {
        var self = this;
        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode) && self.state === 1 && target.isVisible()) {
                    self.cardTapped(target);
                    cc.eventManager.pauseTarget(target, true);
                    return true;
                }
                return false;
            }
        });
        var listener2 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, s.height*0.3, s.width, s.height*0.7);
                if (cc.rectContainsPoint(rect, locationInNode) && (self.state === 1) && (target.state === 1) ) {
                    self.chickenTapped(target);
                    return true;
                }
                return false;
            }
        });
        var listener3 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    cc.log("cat raccoon");
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.x += delta.x/6;
                target.y += delta.y/8;
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                target.stopAllActions();
                target.runAction(cc.moveTo(0.5, target.originalP));
            }
        });
        for (var i=0; i<3; i++) {
            cc.eventManager.addListener(listener1.clone(), this.chickenArray[i].getChildren()[1]);
            cc.eventManager.addListener(listener2.clone(), this.chickenArray[i].getChildren()[0]);
        }
        cc.eventManager.addListener(listener3.clone(), this.cat);
        cc.eventManager.addListener(listener3.clone(), this.raccoon);
    },
    cardShake :function(card) {
        card.runAction(cc.sequence(
            cc.delayTime(2),
            cc.rotateTo(0.1, 3),
            cc.rotateTo(0.1, -3),
            cc.rotateTo(0.1,3),
            cc.rotateTo(0.1,-3),
            cc.rotateTo(0.1, 0)
        ).repeatForever());
    },
    cardTapped : function(card) {
        var self = this;
        var winSize = cc.director.getWinSize();
        var chickenNode = this.chickenArray[this.appearSequence[0]];
        var chicken = chickenNode.getChildren()[0];
        card.stopAllActions();
        card.retain();
        card.removeFromParent(false);
        this.addChild(card, 19, 99);
        card.setPosition(card.convertToWorldSpace( cc.p(chickenNode.x + chicken.getContentSize().width/2, chickenNode.y+chicken.getContentSize().height/2) ));
        card.originalP = cc.p(card.x, card.y);
        chicken.animationManager.runAnimationsForSequenceNamed("normal");
        card.runAction(cc.sequence(
            cc.scaleTo(0.2, 0, 1),
            cc.callFunc(function() {
            	cc.log("order =" + self.appearSequence[0]%self.wordCardArray.length);
                var test = cc.textureCache.addImage(self.wordCardArray[self.showdWordCount]);  //这儿随机的顺序[0,2]，有可能比A只有两个字母要长（越界）
                card.setTexture(test);
            }),
            cc.scaleTo(0.2, 1, 1),
            cc.scaleTo(0.5, 2, 2),
            cc.moveTo(0.5, cc.p(winSize.width/2, winSize.height/2))
        ));
        this.scheduleOnce(this.showOwl, 1);
        this.maskLayout.setVisible(true);

        var dur = 3;
        this.scheduleOnce(function () {
            self.startRecord(card);
        }, dur);
    },
    startRecord : function (card) {
        var self = this;
        this.state = 2;
        cc.audioEngine.pauseMusic();
        
        //self.readFail();  //for test
        
        if (cc.sys.os === cc.sys.OS_ANDROID) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "startRecord", "()V");

            this.schedule(function () {
                var volume = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getVolume", "()I");
                cc.log(volume);
                if (volume != 0) {
                    self.readingStar(volume, card.getLocalZOrder()-1, card);
                }
            }, 0.1);
        }
    },
    testLog : function() {
        cc.log("Test log");
    },
    readSucceed : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.readSuccessful++;
        this.unscheduleAllCallbacks();
        this.littleAnimationComeOut();
        var sdCardPath = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "filepath", "()Ljava/lang/String;");
        cc.audioEngine.unloadEffect(sdCardPath + "/AudioRecorder/hanziwangguo.wav");
        this.scheduleOnce(function () {
            cc.audioEngine.playEffect(sdCardPath + "/AudioRecorder/hanziwangguo.wav");
        }, 0.5);

        self.owl.getChildren()[0].animationManager.runAnimationsForSequenceNamed("noHandAnimation");
        self.owl.runAction(cc.moveTo(0.8, cc.p(0, -winSize.height*0.52)));
        self.maskLayout.setVisible(false);

        var card = this.getChildByTag(99);
        card.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.scaleTo(0.3, 0.7),
            cc.callFunc(function () {
                self.scheduleOnce(function(){
                    self.littleAnimationGoBack();
                }, 1);
                self.showFruitAnimation();
                card.removeFromParent(true);
            })
        ))
    },
    readFail : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.state = 0;
        var card = this.getChildByTag(99);
        card.runAction(cc.scaleTo(0.3, 0.3));
        var animation = cc.Animation.create();
        for (var i= 9; i>=0; i--) {
            animation.addSpriteFrameWithFile("Smoke_"+i+".png");
        }
        animation.setDelayPerUnit(0.05);
        animation.setRestoreOriginalFrame(true);
        card.runAction(cc.sequence(
            cc.animate(animation),
            cc.callFunc(function(){
                return function(card){
                    card.setVisible(false);
                    self.owl.getChildren()[0].animationManager.runAnimationsForSequenceNamed("noHandAnimation");
                    self.owl.runAction(cc.moveTo(0.8, cc.p(0, -winSize.height*0.52)));
                    self.maskLayout.setVisible(false);
                    card.removeFromParent(true);
                    cc.audioEngine.resumeMusic();
                }
            }(card))
        ));
        this.chickenGoBack("sad");
    },
    littleAnimationComeOut : function () {
        var a = Math.random();
        if (a <= 0.5) {
            this.raccoonComeOut();
        } else {
            this.catComeOut();
        }
    },
    raccoonComeOut : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.raccoon.stopAllActions();
        this.raccoon.runAction(
            cc.sequence(
                cc.moveTo(0.5, cc.p(winSize.width * 0.15, winSize.height * 0.20)).easing(cc.easeElasticOut()),
                cc.callFunc(function(){
                    self.raccoon.state = 1;
                    self.raccoon.animationManager.runAnimationsForSequenceNamed("start");
                })
            )
        );
    },
    catComeOut : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.cat.stopAllActions();
        this.cat.runAction(
            cc.sequence(
                cc.moveTo(0.5, cc.p(winSize.width * 0.82, winSize.height * 0.20)).easing(cc.easeElasticOut()),
                cc.callFunc(function(){
                    self.cat.state = 1;
                    self.cat.animationManager.runAnimationsForSequenceNamed("start");
                })
            )
        );
    },
    littleAnimationGoBack : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        if ( this.raccoon.state === 1) {
            this.raccoon.stopAllActions();
            this.raccoon.runAction(cc.sequence(
                cc.moveTo(0.3, cc.p(winSize.width*0.05, winSize.height*0.08) ).easing(cc.easeElasticOut()),
                cc.callFunc(function () {
                    self.raccoon.state = 0;
                    self.raccoon.animationManager.runAnimationsForSequenceNamed("stop");
                })
            ))
        }
        if ( this.cat.state === 1) {
            this.cat.stopAllActions();
            this.cat.runAction(cc.sequence(
                cc.moveTo(0.3, cc.p(winSize.width*0.92, winSize.height*0.08) ).easing(cc.easeElasticOut()),
                cc.callFunc(function () {
                    self.cat.state = 0;
                    self.cat.animationManager.runAnimationsForSequenceNamed("stop");
                })
            ))
        }
    },
    showFruitAnimation : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var chicken = this.chickenArray[this.appearSequence[0]];
        var card = this.getChildByTag(99);
        var num = Math.floor(Math.random()*9) + 1;
        var fruit = cc.Sprite.create("wordcardMode_gift" + num + ".png");
        this.addChild(fruit, card.getLocalZOrder()-1);
        fruit.setScale(0.6);
        fruit.setPosition(winSize.width/2, winSize.height/2);
        card.setVisible(false);

        var effect = cc.ParticleSystem.create("mode_learningpark_right_effect.plist");
        effect.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(effect);

        fruit.runAction(cc.sequence(
            cc.scaleTo(0.2, 1.6),
            cc.scaleTo(0.2, 0.8),
            cc.scaleTo(0.2, 1.3),
            cc.scaleTo(0.2, 0.9),
            cc.delayTime(0.2),
            cc.spawn(
                cc.moveTo(0.6, cc.p(chicken.x, chicken.y-10)),
                cc.scaleTo(0.6, 0.45)
            ),
            cc.callFunc(function () {
                fruit.removeFromParent(false);
                chicken.addChild(fruit);
                fruit.setPosition(chicken.convertToNodeSpace(fruit.getPosition()));
                self.chickenGoBack("get");

                var leftHand = cc.Sprite.create("readaloud/readaloud_chicken_hand_up_L.png");
                fruit.addChild(leftHand);
                leftHand.setRotation(-105);
                leftHand.setPosition(fruit.getContentSize().width/2, fruit.getContentSize().height/2)
                leftHand.x += 6;
            })
        ))
    },
    chickenGoBack : function(animation) {
        var self = this;
        var chicken = this.chickenArray[this.appearSequence[0]];
        chicken.getChildren()[0].animationManager.runAnimationsForSequenceNamed(animation);
        chicken.runAction(cc.sequence(
                cc.delayTime(1),
                cc.moveTo(1, cc.p(chicken.x, chicken.originalY)),
                cc.delayTime(0.3),
                cc.callFunc(function(){
                    self.appearSequence.shift();
                    self.checkModeEnd();
                })
        ));
    },
    showOwl : function() {
        var self = this;
        var winSize = cc.director.getWinSize();
        var owl = this.owl.getChildren()[0];
        this.owl.runAction(cc.spawn(
            cc.moveTo(0.8, cc.p(0, winSize.height*0.52)).easing(cc.easeBackOut()),
            cc.scaleTo(0.6, 0.9, 1.2),
            cc.sequence(
                cc.delayTime(0.6),
                cc.scaleTo(0.15, 1)
            )
        ));
        owl.animationManager.runAnimationsForSequenceNamed("normal");
        this.scheduleOnce(function() {
        	cc.log(self.wordArray[self.showdWordCount]);
            cc.audioEngine.playEffect("sounds/" + self.wordArray[self.showdWordCount++] + ".mp3")
        }, 0.3);
    },
    chickenTapped : function(chickenCCB) {
        var self = this;
        var winSize = cc.director.getWinSize();
        var chicken = chickenCCB.getParent();
        chicken.getChildren()[1].setVisible(false);
        chicken.getChildren()[0].animationManager.runAnimationsForSequenceNamed("normal");
        chicken.stopAllActions();
        chicken.runAction(cc.sequence(
            cc.moveTo(0.6, cc.p(chicken.x, chicken.originalY)),
            cc.delayTime(0.2),
            cc.moveTo(1.3, cc.p(chicken.x, chicken.originalY+winSize.height*0.2)).easing(cc.easeElasticOut()),
            cc.sequence(
                cc.delayTime(0.2),
                cc.callFunc(function() {
                    chicken.getChildren()[0].animationManager.runAnimationsForSequenceNamed("handsUp");
                    chicken.getChildren()[0].state = 1;
                    chicken.getChildren()[1].setVisible(true);
                    self.cardShake(chicken.getChildren()[1]);
                    self.state = 1;
                })
            )
        ))
    },
    //星星数
    readingStar : function (n, zOrder, card) {
        var winSize = cc.director.getWinSize();
        var readingStar = cc.ParticleSystem.create("yellow_bome_2.plist");
        readingStar.setPosition(winSize.width/2, winSize.height/2);
        readingStar.setStartSize(20);
        readingStar.setSpeed(450);
        var totalParticles = n / 250;
        if (totalParticles > 5 && totalParticles < 30) {
            totalParticles = Math.floor(totalParticles);
        }
        if (totalParticles > 30) {
            totalParticles = 30;
        }
        if (totalParticles < 5) {
            totalParticles = 0;
        }
        readingStar.setTotalParticles(totalParticles);
        this.bg.addChild(readingStar, zOrder);

        card.runAction(
            cc.sequence(
                cc.rotateTo(2/(totalParticles+0.001), -3),
                cc.rotateTo(2/(totalParticles+0.001),  3),
                cc.rotateTo(2/(totalParticles+0.001),  0)
            )
        )
    },
    checkModeEnd : function () {
        cc.audioEngine.resumeMusic();
        if (this.appearSequence.length > 0)
        {
            this.startGame();
        } 
        else 
        {
            if (this.readSuccessful > 3) {
                this.readSuccessful = 3;
            } else if (this.readSuccessful < 1) {
                this.readSuccessful = 1;
            }
            var m = EKCoreManager.getInstance();
            var starNumKey = "starNum:" + m.currentPlayingLevelIndex + "-" + m.currentPlayingSubLevelIndex;
            cc.sys.localStorage.setItem(starNumKey, this.readSuccessful);

            this.finishThisSection(this.readSuccessful)
        }
    },
    finishThisSection : function(starNum) {
    	this._super(starNum);
        this.raccoonComeOut();
        this.catComeOut();
    },
    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});


var EKReadAloud = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKReadAloudLayer();
        this.addChild(layer);
    }
});

cc.BuilderReader.registerController("ModeWordcardMouseSprite", {

});

cc.BuilderReader.registerController("ModeWordcardMySprite", {

});

cc.BuilderReader.registerController("MMGameObject", {

});