/**
 * Created by bran on 14-9-13.
 */

var EKSentencePatternMainLayer = EKSectionBasicLayer.extend({
    ctor:function () {
    	this._super();
    	if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
    	}
        var self = this;
        var winSize = cc.director.getWinSize();

        this.itemHadDragToDragonCount = 0;
        this.currentReactingItem = null;
        this.currentHintWordCardTickCount = 0;
        this.currentActivateWordCardCount = 0;

        this.state = 0;
        this.currentState = 0;
        this.isShowSubtitle = false;

        var bg = cc.Sprite.create("sentence2/bg.png");
        this.addChild(bg);
        bg.setPosition(winSize.width/2, winSize.height/2);
        if (winSize.width/winSize.height >= 1.77) {
            bg.setScaleY(0.85);
        }

        this.character = cc.BuilderReader.load("sentence2/sentence_dinosaur", this);

        this.addChild(this.character, ZOder_GAME_MIDDLE_OBJ);
        this.character.setPosition(winSize.width/2, winSize.height*0.45);
        this.character.setScale(1.2);

        this.dragonTouchObject = cc.Sprite.create("word/empty200X200.png");
        this.dragonTouchObject.setVisible(false);
        this.dragonTouchObject.setScaleY(1.5);
        this.dragonTouchObject.setPosition(winSize.width*0.5, winSize.height*0.4);
        this.addChild(this.dragonTouchObject, 0);

        this.head = this.character.getChildByTag(10);
        this.eyeLeft = this.head.getChildByTag(11);
        this.eyeRight = this.head.getChildByTag(12);

        self.eyeLeft.originalX = self.eyeLeft.x;
        self.eyeLeft.originalY = self.eyeLeft.y;
        self.eyeRight.originalX = self.eyeRight.x;
        self.eyeRight.originalY = self.eyeRight.y;

        this.currentwordInfo = EKCoreManager.getInstance().currentWordInfos();
        var sentencesInfo = this.currentwordInfo["words"];

        this.relatedWords = sentencesInfo;
        this.itemsCanEat = ["APPLE", "caneat", "BIKE", "CAKE", "EGG", "GIFT", "ICECREAM", "JEWELRY", "JAM", "LEAF", "MOON", "NOODLES"];
        this.idleAnimations = ["normal", "sayhi", "think", "laugh", "cry", "laugh1"];
        this.animationSounds = {
            sayno : [""],
            normal : ["gator_well"],
            sayhi : ["gator_hi","gator_hello","gator_how are_u"],
            think : ["gator_mmh","gator_well"],
            laugh : ["gator_haha_1","gator_haha_2"],
            cry : ["gator_cry_1","gator_cry_2","gator_cry_3"],
            dage : ["gator_yummy","gator_tasty","gator_delious"],
            laugh1 : ["gator_excellent","gator_fabulous","gator_great","gator_im happy","gator_so_funny","gator_so_much_fun","gator_wonderful"]
        };

        this.setupWordCards();
        this.setupSubtitles();
        this.setupDropItems();

        if (this.currentwordInfo["sentences"].length >= 3) {
            this.setupUFO();
        }
        this.eatingParticleContainerNode = cc.BuilderReader.load("sentence2/eating_spread");
        this.addChild(this.eatingParticleContainerNode, ZOder_GAME_FRONT_OBJ);
        this.eatingParticleContainerNode.setPosition(winSize.width/2, winSize.height/2);

        var children = this.eatingParticleContainerNode.getChildren();

        var par = children[children.length-1];
        par.setStartSize(par.getStartSize()/2);
        par.setEndSize(par.getEndSize()/2);
        par.setEmissionRate(0);

        this.setupGoNextButton();

        this.onStart();
        this.setupTouchEvent();
        
        cc.audioEngine.stopMusic(true);
        cc.audioEngine.stopAllEffects();
        cc.audioEngine.playMusic("sounds/bgm_pindanci.mp3", true);

        return true;
    },
    onStart : function () {
        var self = this;
        cc.audioEngine.playMusic("sounds/bgm_pindanci.mp3", true);
        this.schedule(this.hintWordCardTick, 6);
        var gatorExpressions = ["sayhi", "laugh"];
        var gatorExpression = gatorExpressions[Math.random()>0.5?0:1];
        this.character.animationManager.runAnimationsForSequenceNamedTweenDuration(gatorExpression, 0.3);
        this.scheduleOnce(function () {
            self.state = 1;
        }, 1);
        cc.audioEngine.stopAllEffects();
        var animationSound = this.animationSounds[gatorExpression];
        cc.audioEngine.playEffect("sounds/" +animationSound[Math.floor(Math.random()*animationSound.length)] + ".mp3")

        this.scheduleOnce(function () {
            self.wordcardArray[0].isTouchEnable = true;
            self.wordcardArray[1].isTouchEnable = true;
            if (!cc.sys.localStorage.getItem("juxing_xinshou") || parseInt(cc.sys.localStorage.getItem("juxing_xinshou")) < 3) {
                self.startHint();
                if (!cc.sys.localStorage.getItem("juxing_xinshou")) {
                    cc.sys.localStorage.setItem("juxing_xinshou", 1);
                } else {
                    var count = parseInt(cc.sys.localStorage.getItem("juxing_xinshou"));
                    cc.sys.localStorage.setItem("juxing_xinshou", count+1);
                }
            }
        }, 5);
    },
    setupGoNextButton : function () {
        var winSize = cc.director.getWinSize();
        var mapSprite = cc.Scale9Sprite.create("all_Ui/nextMode.png");
        var progressButton = cc.ControlButton.create(mapSprite);
        progressButton.setPreferredSize(mapSprite.getOriginalSize());
        this.addChild(progressButton, ZOrder_UI);
        progressButton.setPosition(winSize.width-progressButton.getBoundingBox().width*0.5-4, winSize.height-progressButton.getBoundingBox().height*0.5-4);
        progressButton.addTargetWithActionForControlEvents(this, this.progressJumpButtonTapped, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
        progressButton.setLocalZOrder(ZOrder_UI+1);
        progressButton.setVisible(false);
        this.progressButton = progressButton;
    },
    setupWordCards : function () {
        var winSize = cc.director.getWinSize();

        var m = EKCoreManager.getInstance();
        var currentWordInfos = m.wordInfos()[EKLevelsName[parseInt(m.currentPlayingLevelIndex)]];

        var w1 = this.relatedWords[0];
        var w2 = this.relatedWords[1];
        var ws = currentWordInfos["words"];

        cc.log(ws);
        cc.log(ws[0]);
        cc.log(ws[1]);

        var c1 = new EKSentenceGameItem("words_info/" + ws[0].toUpperCase() + ".png", true); //cc.Sprite.create("words_info/" + ws[0].toUpperCase() + ".png");
        var c2 = new EKSentenceGameItem("words_info/" + ws[1].toUpperCase() + ".png", true);//cc.Sprite.create("words_info/" + ws[1].toUpperCase() + ".png");

        c1.isWordCard = true;
        c2.isWordCard = true;
        this.addChild(c1, ZOder_GAME_FRONT_OBJ+20);
        this.addChild(c2, ZOder_GAME_FRONT_OBJ+20);
        c1.m_originalZOrder  = ZOder_GAME_FRONT_OBJ+20;
        c2.m_originalZOrder = ZOder_GAME_FRONT_OBJ+20;
        this.wordCards = [c1,c2];
        c1.setPosition(winSize.width*0.76, winSize.height*1.2);
        c2.setPosition(winSize.width*0.91, winSize.height*1.2);

        c1.isTouchEnable = false;
        c2.isTouchEnable = false;

        c1.pName =w1;
        c2.pName = w2;
        c1.m_originalPos = cc.p(winSize.width*0.76, winSize.height*0.14);
        c2.m_originalPos = cc.p(winSize.width*0.91, winSize.height*0.14);

        var eatInfo = this.currentwordInfo["eat"];
        var breakArray = eatInfo[0].split("_");
        c1.info = breakArray[1];

        var breakArray2 = eatInfo[1].split("_");
        c2.info = breakArray2[1];

        c1.scale = 0.3;
        c2.scale = 0.3;
        c1.m_originalScale = 0.3;
        c2.m_originalScale = 0.3;

        c1.index = 0;
        c2.index = 1;

        this.wordcardArray = [];
        this.wordcardArray.push(c1);
        this.wordcardArray.push(c2);

        c1.runAction(cc.sequence(
            cc.delayTime(2.5),
            cc.moveTo(2, c1.m_originalPos.x, c1.m_originalPos.y).easing(cc.easeBounceOut()),
            cc.callFunc(function () {
                c1.isTouchEnable = true;
            })
        ));
        c2.runAction(cc.sequence(
            cc.delayTime(2.8),
            cc.moveTo(2, c2.m_originalPos.x, c2.m_originalPos.y).easing(cc.easeBounceOut()),
            cc.callFunc(function () {
                c2.isTouchEnable = true;
            })
        ));
    },
    setupTouchEvent : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                if (!self.hadGivenItemToGator) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(s.width*0.25, s.height*0.2, s.width*0.5, s.height*0.7);
                    if (cc.rectContainsPoint(rect, locationInNode) && self.state === 1) {
                        target.animationManager.runAnimationsForSequenceNamedTweenDuration("normal", 0.3);
                        return true;
                    }
                }
                return false;
            }
        });
        var listener2 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {

                var target = event.getCurrentTarget();

                var locationInWorld = touch.getLocation();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode) && target.isTouchEnable ) {

                    cc.log("getPosition " + target.getPosition().x);
                    cc.log("getPosition " + target.m_originalPos.x);

                    if (!self.hadGivenItemToGator && Math.floor(target.getPosition().x) === Math.floor(target.m_originalPos.x) ) {
                        if (target.isWordCard) {
                            target.setScale(0.4);
                        }

                        self.character.animationManager.runAnimationsForSequenceNamed("beginToEat");
                        self.eyeLeft.setPosition(
                                self.eyeLeft.originalX + (locationInWorld.x-winSize.width*0.5)/(winSize.width*0.5)*12,
                                self.eyeLeft.originalY + (locationInWorld.y-winSize.height*0.5)/(winSize.height*0.5)*12 + 2.5
                        );
                        self.eyeRight.setPosition(
                                self.eyeRight.originalX + (locationInWorld.x-winSize.width*0.5)/(winSize.width*0.5)*12,
                                self.eyeRight.originalY + (locationInWorld.y-winSize.height*0.5)/(winSize.height*0.5)*12 + 2.5
                        );
                        self.head.setRotation( - (locationInWorld.x-winSize.width*0.5)/winSize.width*0.5*40 );

                        if (target.index == 0) {
                            cc.eventManager.pauseTarget(self.wordcardArray[1]);
                            cc.eventManager.pauseTarget(self.dropItems[0]);
                            cc.eventManager.pauseTarget(self.dropItems[1]);
                        }
                        if (target.index == 1) {
                            cc.eventManager.pauseTarget(self.wordcardArray[0]);
                            cc.eventManager.pauseTarget(self.dropItems[0]);
                            cc.eventManager.pauseTarget(self.dropItems[1]);
                        }
                        if (target.index == 3) {
                            cc.eventManager.pauseTarget(self.dropItems[1]);
                            cc.eventManager.pauseTarget(self.wordcardArray[0]);
                            cc.eventManager.pauseTarget(self.wordcardArray[1]);
                        }
                        if (target.index == 4) {
                            cc.eventManager.pauseTarget(self.dropItems[0]);
                            cc.eventManager.pauseTarget(self.wordcardArray[0]);
                            cc.eventManager.pauseTarget(self.wordcardArray[1]);
                        }

                        return true;
                    }
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var locationInWorld = touch.getLocation();
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.x += delta.x;
                target.y += delta.y;
                if (!self.hadGivenItemToGator) {
                    self.eyeLeft.setPosition(
                            self.eyeLeft.originalX + (locationInWorld.x-winSize.width*0.5)/(winSize.width*0.5)*12,
                            self.eyeLeft.originalY + (locationInWorld.y-winSize.height*0.5)/(winSize.height*0.5)*12 + 2.5
                    );
                    self.eyeRight.setPosition(
                            self.eyeRight.originalX + (locationInWorld.x-winSize.width*0.5)/(winSize.width*0.5)*12,
                            self.eyeRight.originalY + (locationInWorld.y-winSize.height*0.5)/(winSize.height*0.5)*12 + 2.5
                    );
                    self.head.setRotation( - (locationInWorld.x-winSize.width*0.5)/winSize.width*0.5*40 );
                }
            },
            onTouchEnded: function (touch, event) {
                var locationInWorld = touch.getLocation();
                var target = event.getCurrentTarget();

                cc.eventManager.resumeTarget(self.dropItems[0]);
                cc.eventManager.resumeTarget(self.dropItems[1]);
                
                if (!self.hadGivenItemToGator) {
                    if (cc.rectContainsPoint( self.dragonTouchObject.getBoundingBox(), locationInWorld)) {
                        cc.eventManager.pauseTarget(target, true);
                        self.hadGivenItemToGator = true;
                        self.character.animationManager.runAnimationsForSequenceNamed("default");
                        self.giveItemToGator(target);
                        cc.eventManager.pauseTarget(target);
                        self.itemHadDragToDragonCount++;
                    } else {
                        self.character.animationManager.runAnimationsForSequenceNamed("shouwei");
                        self.sendItemBack(target);
                    }
                } else {
                    self.sendItemBack(target);
                }

            }
        });
        var listener3 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode) && target.pName !== "" && self.isShowSubtitle === false) {
                    self.UFO.pName = "busy";
                    if (self.subtitleLayers.length === 3) {
                        self.startDogSpeech();
                    } else {
                        self.UFO.pName = "";
                    }
                }
                return false;
            }
        });
        cc.eventManager.addListener(listener1, this.character);
        for (var i=0; i<2; i++) {
            cc.eventManager.addListener(listener2.clone(), this.wordcardArray[i]);
        }
        for (var i=0; i<2; i++) {
            cc.eventManager.addListener(listener2.clone(), this.dropItems[i]);
        }
        if (this.currentwordInfo["sentences"].length >= 3) {
            cc.eventManager.addListener(listener3, this.UFO.getChildByTag(4).getChildByTag(3));
        }
    },
    sendItemBack : function (obj) {
        var self = this;

        if (obj.currentEatenPercentage !== 0) {
            obj.setScale(0);
            obj.setPosition(obj.m_originalPos);
            obj.eatToPercentage(0, true);
            obj.runAction(cc.sequence(
                cc.scaleTo(0.3, obj.m_originalScale).easing(cc.easeBackOut()),
                cc.callFunc(function () {
                    cc.eventManager.resumeTarget(self.wordcardArray[1]);
                    cc.eventManager.resumeTarget(self.wordcardArray[0]);
                })
            ));
        } else {
            obj.stopAllActions();
            obj.runAction(cc.spawn(
                cc.moveTo(0.3, obj.m_originalPos),
                cc.scaleTo(0.3, obj.m_originalScale),
                cc.callFunc(function () {
                    cc.eventManager.resumeTarget(self.wordcardArray[1]);
                    cc.eventManager.resumeTarget(self.wordcardArray[0]);
                })
            ));
        }

        obj.eatToPercentage(0, true);
    },
    giveItemToGator : function (obj) {
        var self = this;
        var winSize = cc.director.getWinSize();

        var dur = 0;
        if (obj.isWordCard) {
            this.currentActivateWordCardCount++;
            dur = this.showSubtitleLayerAndGetDuration(this.wordCards.indexOf(obj));
        }
        this.currentReactingItem = obj;
        var scaleRatio = 95/obj.getContentSize().height;

        this.scheduleOnce(function () {
            if (obj.index == 0) {
                cc.eventManager.resumeTarget(self.wordcardArray[1]);
            }
            if (obj.index == 1) {
                cc.eventManager.resumeTarget(self.wordcardArray[0]);
            }
        }, 0.5);

        if (_.contains(this.itemsCanEat, obj.pName)) {
            obj.runAction(cc.sequence(
                cc.spawn(
                    cc.moveTo(0.2, winSize.width/2, winSize.height*0.25),
                    cc.scaleTo(0.3, obj.m_originalScale)
                ),
                cc.delayTime(dur),
                cc.callFunc(function () {
                    self.character.animationManager.runAnimationsForSequenceNamed("eat");
                }),
                cc.delayTime(5),
                cc.callFunc(function () {
                    obj.eatToPercentage(1, true);
                    var breakArray = self.currentReactingItem.info.split("+");
                    var seq;
                    if (breakArray.length > 1) {
                        seq = breakArray[Math.floor(Math.random() * breakArray.length)];
                    } else {
                        seq = self.currentReactingItem.info;
                    }
                    self.character.animationManager.runAnimationsForSequenceNamedTweenDuration(seq, 0.4);

                    self.checkStateIfNecessary();

                    self.scheduleOnce(function () {
                        var sound = self.animationSounds[seq][Math.floor(Math.random()*self.animationSounds[seq].length)];
                        if (sound !== "") {
                            cc.audioEngine.playEffect("sounds/" + sound + ".mp3");
                        }
                        self.hadGivenItemToGator = false;

                    }, 0.1);

                    self.scheduleOnce(function () {
                        if (this.isTicking) {
                            self.sendItemBack(obj);
                        }
                    }, 2);
                })
            ));
        } else {
            obj.runAction(cc.sequence(
                cc.spawn(
                    cc.moveTo(0.2, cc.p(winSize.width/2, winSize.height*0.25)),
                    cc.scaleTo(0.3, obj.m_originalScale)
                ),
                cc.delayTime(dur),
                cc.callFunc(function () {
                    var breakArray = obj.info.split("+");
                    var seq;
                    if (breakArray.length > 1) {
                        seq = breakArray[Math.floor(Math.random()*breakArray.length)];
                    } else {
                        seq = obj.info;
                    }
                    self.character.animationManager.runAnimationsForSequenceNamed(seq);
                    self.scheduleOnce(function () {
                        var sound = self.animationSounds[seq][Math.floor(Math.random()*self.animationSounds[seq].length)];
                        if (sound !== "") {
                            cc.audioEngine.playEffect("sounds/" + sound + ".mp3");
                        }
                    }, 0.1);
                }),
                cc.delayTime(2),
                cc.callFunc(function () {
                    self.hadGivenItemToGator = false;
                    self.sendItemBack(obj);
                    self.checkStateIfNecessary();
                    self.currentReactingItem = null;
                    cc.eventManager.resumeTarget(obj, true);
                })
            ))
        }
    },
    setupSubtitles : function () {
        var sentencesInfo = this.currentwordInfo["sentences"];
        var sentences = [];

        for (var i=0; i<sentencesInfo.length; i++) {
            var array = sentencesInfo[i];
            var a = [];
            var arr = [];
            a.push(array[0], array[1], array[2]);
            arr.push(a);
            sentences.push(arr);
        }

        var subtitleLayer1 = new EKSubtitleLayer(sentences[0]);
        var subtitleLayer2 = new EKSubtitleLayer(sentences[1]);
        this.addChild(subtitleLayer1, ZOder_GAME_FRONT_OBJ);
        this.addChild(subtitleLayer2, ZOder_GAME_FRONT_OBJ);

        if (sentences.length === 3) {
            var subtitleLayer3 = new EKSubtitleLayer(sentences[2]);
            this.addChild(subtitleLayer3, ZOder_GAME_FRONT_OBJ);
            this.subtitleLayers = [subtitleLayer1,subtitleLayer2,subtitleLayer3];
        } else {
            this.subtitleLayers = [subtitleLayer1, subtitleLayer2];
        }
    },
    showSubtitleLayerAndGetDuration : function (index) {
        var self = this;
        var layer = this.subtitleLayers[index];
        layer.setLocalZOrder(ZOder_GAME_FRONT_OBJ+8);
        var dur = layer.showAndStartAutoReading();
        this.isShowSubtitle = true;
        this.scheduleOnce(function () {
            self.isShowSubtitle = false;
        }, dur);
        for (var i=0; i<this.subtitleLayers.length; i++) {
            var s = this.subtitleLayers[i];
            if (s !== layer) {
                s.setLocalZOrder(ZOder_GAME_BACKGROUND_OBJ);
                s.hide();
            }
        }
        return dur;
    },
    setupUFO : function () {
        var winSize = cc.director.getWinSize();
        this.UFO = cc.BuilderReader.load("sentence2/sentence_Ufo");
        this.addChild(this.UFO, ZOder_GAME_MIDDLE_OBJ);
        this.UFO.setPosition(cc.p(winSize.width*0.89, winSize.height*0.75));
        this.UFO.getChildByTag(4).getChildByTag(3).setVisible(false);
        this.UFO.pName = "";
    },
    progressJumpButtonTapped : function () {
        this.unscheduleAllCallbacks();
        this.finishThisSection();
    },
    hintWordCardTick : function () {
        if (this.currentReactingItem) return;
        var n = this.wordCards[Math.floor(Math.random()*this.wordCards.length)];
        n.runAction(cc.sequence(
            cc.rotateTo(0.05, -10),
            cc.rotateTo(0.1, 10),
            cc.rotateTo(0.1, -10),
            cc.rotateTo(0.1, 10),
            cc.rotateTo(0.1, -10),
            cc.rotateTo(0.1, 10),
            cc.rotateTo(0.05, 0)
        ))
    },
    startHint : function () {
        var winSize = cc.director.getWinSize();
        var pos1 = this.wordcardArray[Math.random()>0.5?0:1].getPosition();
        startHintingWithHand(pos1, cc.p(winSize.width/2, winSize.height/2), this, 1);
    },
    checkStateIfNecessary : function () {
        cc.log("checkStateIfNecessary " + this.currentState + " " + this.itemHadDragToDragonCount);
        var self = this;
        if (this.currentState === 0) {
            if (this.itemHadDragToDragonCount < 2) {
                var otherCard = this.wordCards[0]===this.currentReactingItem?this.wordCards[1]:this.wordCards[0];
                otherCard.runAction( cc.jumpBy(0.7, cc.p(0, 0), 15, 3 ) );
            } else {
                cc.eventManager.pauseTarget(self.wordcardArray[0]);
                cc.eventManager.pauseTarget(self.wordcardArray[1]);

                this.currentState = 1;
                this.restoreCardStatesIfNecessary();

                this.wordcardArray[0].eatToPercentage(0);
                this.wordcardArray[1].eatToPercentage(0);
                this.sendItemBack(this.wordcardArray[0]);
                this.sendItemBack(this.wordcardArray[1]);
                this.character.animationManager.runAnimationsForSequenceNamedTweenDuration("think", 1.5);
                cc.audioEngine.stopAllEffects();
                var sound = this.animationSounds["think"][Math.random()<0.5?0:1];
                cc.audioEngine.playEffect("sounds/" + sound + ".mp3");
                this.scheduleOnce(function () {
                    self.startDropItems();
                }, 3);
                this.timing = 0;
                this.schedule(function () {
                    self.endingTick();
                }, 1);
            }
        }
    },
    restoreCardStatesIfNecessary : function () {

    },
    setupDropItems : function () {
        var winSize = cc.director.getWinSize();

        var itemNames = [];
        var itemNames1 = [];
        var itemNames2 = [];
        var itemNames3 = [];
        for (var i= 0; i<5; i++) {
            itemNames1.push("sentence2/item_1_" + (i+1) + ".png");
            if (i<3) {
                itemNames2.push("sentence2/item_2_" + (i+1) + ".png");
                itemNames3.push("sentence2/item_3_" + (i+1) + ".png");
            }
        }
        itemNames.push(itemNames1[Math.floor(Math.random()*5)]);
        itemNames.push(itemNames2[Math.floor(Math.random()*3)]);
        itemNames.push(itemNames3[Math.floor(Math.random()*3)]);
        itemNames = _.shuffle(itemNames);
        this.dropItems = [];
        for (var i=0; i<2; i++) {
            var name = itemNames[i];
            cc.log(itemNames.length + " " + name);
            var item = new EKSentenceGameItem(name);
            var breakArray = name.split("_");
            if (breakArray[1] === "1") {
                item.pName = "caneat";
                item.info = "dage+laugh1";
            } else if (breakArray[1] === "2") {
                item.pName = "cannoteat";
                item.info = "cry";
            } else {
                item.pName = "cannoteat";
                item.info = "sayno";
            }

            this.dropItems.push(item);
        }

        this.dropItems = _.shuffle(this.dropItems);

        for (var i=0; i<2; i++) {
            var item = this.dropItems[i];
            item.setPosition(cc.p(winSize.width*0.3 + i*winSize.width*0.2, winSize.height + item.getContentSize().height));
            item.m_originalScale = 1;
            item.m_originalZOrder = ZOder_GAME_FRONT_OBJ;
            item.setScale(1);
            item.m_originalPos = cc.p(winSize.width*0.3 + i*winSize.width*0.2, item.getContentSize().height/2);
            this.addChild(item, ZOder_GAME_FRONT_OBJ);
        }
    },
    startDropItems : function () {
        cc.log("startDropItems ");
        var winSize = cc.director.getWinSize();
        var self = this;

        cc.eventManager.resumeTarget(self.wordcardArray[0]);
        cc.eventManager.resumeTarget(self.wordcardArray[1]);
        cc.eventManager.resumeTarget(self.dropItems[0]);
        cc.eventManager.resumeTarget(self.dropItems[1]);

        var item1 = this.dropItems[0];
        item1.isTouchEnable = true;
        item1.runAction(cc.sequence(
            cc.delayTime(0*0.2),
            cc.moveTo(2, cc.p(winSize.width*0.3 + 0*winSize.width*0.2, item1.getContentSize().height/2)).easing(cc.easeBounceOut())
        ));

        var item2 = this.dropItems[1];
        item2.isTouchEnable = true;
        item2.runAction(cc.sequence(
            cc.delayTime(1*0.2),
            cc.moveTo(2, cc.p(winSize.width*0.3 + 1*winSize.width*0.2, item2.getContentSize().height/2)).easing(cc.easeBounceOut())
        ));

        item1.index = 3;
        item2.index = 4;

        this.progressButton.setScale(0.1);
        this.progressButton.setVisible(true);
        this.progressButton.runAction(cc.sequence(
            cc.scaleTo(0.5, 1.2),
            cc.scaleTo(0.2, 0.8),
            cc.scaleTo(0.2, 1.1),
            cc.scaleTo(0.1, 0.9),
            cc.scaleTo(0.1, 1)
        ))
    },
    startDogSpeech : function () {
        var self = this;
        if (this.subtitleLayers.length === 3) {
            var layer3 = _.last(this.subtitleLayers);
            layer3.setLocalZOrder(ZOder_GAME_FRONT_OBJ+10);
            var dur = parseInt(layer3.showAndStartAutoReading());
            var dog = this.UFO.getChildByTag(4).getChildByTag(3);
            dog.setVisible(true);
            cc.log("dur " + dur);
            this.scheduleOnce(function () {
                self.UFO.pName = "";
                dog.setVisible(false);
            }, dur);
        } else {
            this.UFO.runAction(cc.sequence(
                cc.callFunc(function () {
                    self.UFO.pName = "";
                    this.getChildByTag(4).getChildByTag(3).setVisible(false);
                })
            ))
        }
    },
    "characterEats" : function () {
        var self = this;
        if (this.currentReactingItem && _.contains(this.itemsCanEat, this.currentReactingItem.pName)) {
            this.eatingParticleContainerNode.setVisible(true);
            this.currentReactingItem.progressEating();
            this.eatingParticleContainerNode.setPosition(this.currentReactingItem.getPosition());
            this.eatingParticleContainerNode.setLocalZOrder(this.currentReactingItem.getLocalZOrder()-1);
            var par = _.last(this.eatingParticleContainerNode.getChildren());
            par.setEmissionRate(50);
            this.scheduleOnce(function () {
                self.stopEatingParticleEmit();
            }, 0.05);
        }
    },
    stopEatingParticleEmit : function () {
        var par = _.last( this.eatingParticleContainerNode.getChildren() );
        par.setEmissionRate(0);
    },
    endingTick : function () {
        var self = this;
        this.timing++;
        cc.log(this.timing );

        this.isTicking = true;

        if (this.timing > 30) {
            this.unscheduleAllCallbacks();
            this.character.animationManager.runAnimationsForSequenceNamed("default");

            cc.audioEngine.stopMusic();
            var rainingNode = cc.BuilderReader.load("change scene/raining");
            rainingNode.animationManager.runAnimationsForSequenceNamed("Default Timeline");
            this.addChild(rainingNode, ZOder_GAME_FRONT_OBJ);
            rainingNode.setPosition(0, 0);

            this.scheduleOnce(function () {
                rainingNode.removeFromParent(true);
            }, 14);

            var dur = 0;
            for (var i=0; i<this.wordCards.length; i++) {
                var card = this.wordCards[i];
                card.isTouchEnable = false;
                var layer = this.subtitleLayers[i];
                layer.setLocalZOrder(ZOder_GAME_FRONT_OBJ+10);
                card.runAction(cc.sequence(
                    cc.delayTime(dur),
                    cc.jumpBy(layer.getDur(), cc.p(0,0), 15, layer.getDur()+4)
                ));

                if (i === 0) {
                    this.scheduleOnce(function () {
                        self.subtitleLayers[0].showAndStartAutoReading();
                    }, dur+0.2);
                }
                if (i === 1) {
                    this.scheduleOnce(function () {
                        self.subtitleLayers[1].showAndStartAutoReading();
                    }, dur+0.2);
                }
                dur += (parseInt(layer.getDur()) + 2);
            }

            if (this.subtitleLayers.length === 3) {
                layer = this.subtitleLayers[2];
                this.scheduleOnce(function () {
                    self.startDogSpeech();
                }, dur);
                layer.setLocalZOrder(ZOder_GAME_FRONT_OBJ+12);
                dur += (parseInt(layer.getDur()) + 2);
            }

            cc.log("dur " + dur);
            this.scheduleOnce(function () {
                self.finishThisSection()
            }, dur);
        }
    },
    finishThisSection : function() {
        this._super();
    },
    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});

var EKSentencePatternMain = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKSentencePatternMainLayer();
        this.addChild(layer);
    }
});

var EKSentenceGameItem = cc.Sprite.extend({
    ctor : function(file, isCard) {
        this._super();

        this.leftOrRight = false;

        this.innerSprite = cc.Sprite.create(file);
        this.setContentSize(this.innerSprite.getContentSize());
        this.maskContent = new cc.Node();
        this.maskContent.setPosition(cc.p(this.getContentSize().width*0.7, this.getContentSize().height*0.195));

        var breakArray = file.split("_");

        this.mask1 = cc.Sprite.create("sentence2/eating_mask.png");
        this.mask2 = cc.Sprite.create("sentence2/eating_mask.png");
        this.mask1.setScale(1.3);
        this.mask2.setScale(1.3);
        this.mask1.setRotation(20);
        this.mask2.setRotation(-20);
        this.maskContent.addChild(this.mask1);
        this.maskContent.addChild(this.mask2);

        var clip = new cc.ClippingNode();
        clip.setContentSize(this.innerSprite.getContentSize());
        clip.setInverted(false);
        clip.setStencil(this.maskContent);
        clip.addChild(this.innerSprite);
        clip.setAlphaThreshold(0.05);

        this.innerSprite.setPosition(cc.p(clip.getContentSize().width/2, clip.getContentSize().height/2));

        this.mask1.setPosition(cc.p(30, 20));
        this.mask2.setPosition(cc.p(-10, 20));
        if (isCard) {
            this.mask1.setScale( this.mask1.getScale()/0.19 );
            this.mask2.setScale( this.mask2.getScale()/0.19);
            this.mask1.setPosition( cc.p(35, 0) );
            this.mask2.setPosition( cc.p(-85, 0) );
        }
        this.addChild(clip);
        this.setAnchorPoint(0.5, 0.5);
        this.currentEatenPercentage = 0;

        return true;
    },

    progressEating : function () {
        this.eatToPercentage( this.currentEatenPercentage+0.17, false);
    },

    eatToPercentage : function (per, replace) {
        this.currentEatenPercentage = per;
        this.leftOrRight = !this.leftOrRight;
        if ( replace==true ) {
            this.mask1.setPosition( this.mask1.x, -this.innerSprite.getContentSize().height*1.4*per );
            this.mask2.setPosition( this.mask2.x, -this.innerSprite.getContentSize().height*1.4*per );
            return;
        }
        if (this.leftOrRight) {
            this.mask1.setPosition(this.mask1.x, -this.innerSprite.getContentSize().height*1.35*per);
        } else {
            this.mask2.setPosition(this.mask2.x, -this.innerSprite.getContentSize().height*1.35*per);
        }
    }
});