/**
 * Created by bran on 14-9-13.
 */

var EKSubtitleLayer = cc.Layer.extend({
    ctor : function (infos) {
        this._super();
        this.labels = null;
        this.initWithSubstringInfos(infos);

        return true;
    },
    initWithSubstringInfos : function (infos) {
        var self = this;
        var winSize = cc.director.getWinSize();
        this.stringInfos = infos;
        this.setContentSize(cc.size(winSize.width, 50));

        var bg = cc.Sprite.create("sentence2/subtitles.png");
        bg.setAnchorPoint(cc.p(0.5, 0));
        bg.setPosition(cc.p(winSize.width*0.5, 0));
        var contentSize = bg.getContentSize();
        //bg.setContentSize(contentSize.width*1.2, contentSize.height);
        this.addChild(bg,ZOder_GAME_BACKGROUND_OBJ);
        this.bg = bg;

        if ( EKCoreManager.getInstance().getSettingsMultiLang()===1 && isLangCN ) {
            var multiLangLabel = new cc.LabelTTF("还没有翻译", "Helvetica", 15);
            this.addChild(multiLangLabel);
            multiLangLabel.setPosition(this.getContentSize().width/2, this.getContentSize().height*(2.2/3));
            cc.loader.loadTxt("res/translations_sam.json", function(err, data){
                if(err) return console.log("load failed");
                var localizingLangDict  = JSON.parse(data);
                var counter = localizingLangDict[self.getAllString()];
                multiLangLabel.setString(counter);
                multiLangLabel.setColor(cc.color(87, 118, 82));
            });
        }
        this.setupWords();
        this.setPosition(winSize.width/2, winSize.height+this.getContentSize.height);
        this.setAnchorPoint(cc.p(0.5, 1));
    },
    getCounterString : function () {
        cc.loader.loadTxt("res/translations_sam.plist", function(err, data){
            if(err) return console.log("load failed");
            var localizingLangDict  = JSON.parse(data);
            var counter = localizingLangDict[s];
        });
    },
    showAndStartAutoReading : function () {
        var self = this;

        this.show();
        var dur = parseInt(_.last(this.stringInfos)[1].split("-")[1]);
        var all = this.getAllString();
//        var playFileName = all;
//        playFileName = playFileName.replace(",", "");
//        playFileName = playFileName.replace(".", "");
//        playFileName = playFileName.replace("!", "");
//        playFileName = playFileName.replace("?", "");
//        playFileName = playFileName.toUpperCase();
        cc.audioEngine.playEffect(_.last(this.stringInfos)[2]);
        var startI = 0;
        for (var i=0; i<all.length; i++) {
            var l = this.labels[i];
            l.runAction(cc.sequence(
                cc.delayTime(startI*0.1),
                cc.spawn(
                    cc.tintTo(0.2, 175, 75, 9),
                    cc.scaleTo(0.2, 1.1).easing(cc.easeBackOut())
                ),
                cc.delayTime(dur - startI*0.1 + 0.5),
                cc.tintTo(0.5, 255, 255, 255),
                cc.scaleTo(0.1, 1)
            ));
            startI++;
        }
        this.scheduleOnce(function () {
            self.hide();
        }, dur+1);
        return dur;
    },
    show : function () {
        var winSize = cc.director.getWinSize();
        this.setPosition(cc.p(0, winSize.height+this.getContentSize().height));
        this.stopAllActions();
        this.runAction(
            cc.moveTo(0.3, cc.p(0, winSize.height-this.bg.getContentSize().height)).easing(cc.easeBackOut())
        )
    },
    hide : function () {
        cc.log("hide");
        var winSize = cc.director.getWinSize();
        this.stopAllActions();
        this.runAction(
            cc.moveTo(0.3, cc.p(0, winSize.height+this.getContentSize().height)).easing(cc.easeBackIn())
        );
    },
    setupWords : function () {
        this.labels = [];
        var length = this.getAllString().length;
        var labelSize = 16;
        var labelInterval = -5;
        while( (labelSize+labelInterval)*length>this.bg.getContentSize().width-30 ) {
            labelSize--;
        }
        var test = new cc.LabelTTF("W", "ArialHebrew", labelSize);
        for (var i=0; i<length; i++) {
            var s = this.getAllString()[i];
            var l = new cc.LabelTTF(s, "ArialHebrew", labelSize);
            this.bg.addChild(l);
            l.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
            l.setAnchorPoint(cc.p(0.5, 0.5));
            var mid = cc.p(this.bg.getContentSize().width/2, this.bg.getContentSize().height/2);
            l.setPosition(cc.p( mid.x+(i-length/2)*(labelSize+labelInterval)+16/2, mid.y+10));
            this.labels.push(l);
        }
    },
    startPlaying : function (s, index) {
        var showingString = this.getAllString();
        var range = showingString.indexOf(s);
        if (range !== -1) {
            var ss = this.getTimeInfoWithString(s);
            var dur = ss[1] - ss[0];
            for (var i=0; i<this.labels.length; i++) {
                var l = this.labels[i];
                l.setColor(cc.WHITE);
                l.setScale(1);
            }
            var startI = 0;
            for (var i=range; i< range+s.length; i++) {
                var l = this.labels[i];
                l.runAction(cc.sequence(
                    cc.delayTime(startI*0.1),
                    cc.spawn(
                        cc.tintTo(0.2, 200, 200, 100),
                        cc.scaleTo(0.2, 1.2).easing(cc.easeBackOut())
                    ),
                    cc.delayTime(dur-startI*0.1),
                    cc.tintTo(0.1, 255, 255, 255),
                    cc.scaleTo(0.1, 1)
                ));
                startI++;
            }
        }
    },
    getDur : function() {
        var dur = (_.last(this.stringInfos)[1]).split("-")[1];
        return parseInt(dur);
    },
    getAllString : function () {
        var s = "";
        for (var i= 0; i<this.stringInfos.length; i++) {
            var a = this.stringInfos[i];
            s += a[0];
        }
        return s;
    },
    getTimeInfoWithString : function (s) {
        for (var i=0; i<this.stringInfos.length; i++) {
            var a = this.stringInfos[i];
            if (s.toUpperCase() === a[0].toUpperCase()) {
                return a[1].split("-");
            }
        }
        return null;
    }
});