/**
 * Created by bran on 14/10/29.
 */

var EKMiCoinLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        var maskLayout = this.createMask();
        this.addChild(maskLayout);

        this.bg = this.createLayout();
        this.addChild(this.bg);

        this.setupSubtitle();

        this.setupCloseButton();
        this.setupTasks();

        return true;
    },

    createMask : function () {
        var winSize = cc.director.getWinSize();
        var maskLayout = new ccui.Layout();
        maskLayout.setContentSize(winSize.width, winSize.height);
        maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        maskLayout.setBackGroundColorOpacity(100);
        maskLayout.setTouchEnabled(true);
        return maskLayout;
    },

    createLayout : function () {
        var winSize = cc.director.getWinSize();
        var layout = new ccui.Layout();
        layout.setClippingEnabled(true);
        layout.setBackGroundImage("all_Ui/ui_coin_bg.png");
        var size =  layout.getBackGroundImageTextureSize();
        layout.setContentSize(cc.size(size.width, size.height));
        layout.setAnchorPoint(0.5, 0.5);
        layout.x = winSize.width/2;
        layout.y = winSize.height/2;

        return layout;
    },

    setupCloseButton : function() {
        var winSize = cc.director.getWinSize();
        var closeButton = new ccui.Button();
        this.addChild(closeButton);
        closeButton.setTouchEnabled(true);
        closeButton.loadTextures("all_Ui/ui_close.png", "all_Ui/ui_close.png");
        closeButton.x = winSize.width * 0.75;
        closeButton.y = winSize.height * 0.78;

        if (winSize.width/winSize.height > 1.77) {
            closeButton.x = winSize.width * 0.75;
            closeButton.y = winSize.height * 0.78;
        } else {
            closeButton.x = winSize.width * 0.73;
            closeButton.y = winSize.height * 0.74;
        }

        closeButton.addTouchEventListener(this.closeButtonTouchEvent, this);
    },

    closeButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                this.removeFromParent(true);
                break;
            default :
                break;
        }
    },
    setupSubtitle : function () {
        var layoutSize = this.bg.getBackGroundImageTextureSize();
        var currentMiCoinText = new ccui.Text();
        currentMiCoinText.attr({
            string: "当前米粒",
            x: layoutSize.width * 0.38,
            y: layoutSize.height * 0.85
        });
        currentMiCoinText.setFontSize(20);
        currentMiCoinText.setFontName("FZCuYuan-M03S.ttf");
        currentMiCoinText.setColor(cc.color(250, 160, 0));
        currentMiCoinText.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        this.bg.addChild(currentMiCoinText);

        var currentMiCoinBg = new ccui.ImageView();
        currentMiCoinBg.loadTexture("all_Ui/ui_box_bg_coin.png");
        currentMiCoinBg.x = layoutSize.width * 0.62;
        currentMiCoinBg.y = layoutSize.height * 0.85;
        this.bg.addChild(currentMiCoinBg);

        this.refreshMili();

        var tips = new ccui.Text();
        tips.attr({
            string: "米粒可用来购买英语王国课程，\n您可以通过完成任务或者使用兑换码来获取米粒",
            x: layoutSize.width * 0.47,
            y: layoutSize.height * 0.73
        });
        tips.setFontName("FZCuYuan-M03S.ttf");
        tips.setFontSize(10);
        tips.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        this.bg.addChild(tips);
    },
    refreshMili : function () {
        if (this.currentMiCoinNumText) {
            this.currentMiCoinNumText.removeFromParent();
            this.currentMiCoinNumText = null;
        }
        var layoutSize = this.bg.getBackGroundImageTextureSize();
        this.currentMiCoinNumText = new ccui.Text();
        this.currentMiCoinNumText.attr({
            x: layoutSize.width * 0.6,
            y: layoutSize.height * 0.85
        });

        this.currentMiCoinNumText.setFontSize(15);
        var miCoinNum = cc.sys.localStorage.getItem("MyCoin") || 0;
        this.currentMiCoinNumText.setString(miCoinNum);
        this.currentMiCoinNumText.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        this.bg.addChild(this.currentMiCoinNumText);

    },
    setupTasks : function() {
        var layoutSize = this.bg.getBackGroundImageTextureSize();

        var listView = new ccui.ListView();
        listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        listView.setTouchEnabled(true);
        listView.setBounceEnabled(true);
        listView.setContentSize(cc.size(layoutSize.width*0.74, layoutSize.height * 0.5));
        listView.x = layoutSize.width*0.5;
        listView.y = layoutSize.height * 0.4;
        this.bg.addChild(listView);
//        listView.setBackGroundImage("assembleWord/bg.png");
        listView.setAnchorPoint(0.5, 0.5);
        var listViewSize = listView.getContentSize();

        this.rewardNum = ["",10,45,30,30,30];
        var taskTexts = [];
        taskTexts.push("签到领米粒");
        taskTexts.push("首次打开英语王国+" + this.rewardNum[1]);
        taskTexts.push("完成ABC课程+" + this.rewardNum[2]);
        taskTexts.push("分享到微信朋友圈+" + this.rewardNum[3]);
        taskTexts.push("评价英语王国+" + this.rewardNum[4]);
        taskTexts.push("分享到新浪微博+" + this.rewardNum[5]);

        this.taskButtons = [];
        var taskItems = [];
        for (var i=0; i<taskTexts.length; i++) {
            var dailyCheckButton = new ccui.Button();
            dailyCheckButton.setTouchEnabled(true);
            dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck.png","all_Ui/ui_button_dailyCheck.png","all_Ui/ui_button_dailyCheck_done.png");

            this.taskButtons.push(dailyCheckButton);

            var taskItem = new ccui.Layout();
            taskItem.setTouchEnabled(true);
            taskItem.setContentSize(cc.size(listViewSize.width*0.95, listViewSize.height*0.21));
            taskItems.push(taskItem);
            var taskItemSize = taskItem.getContentSize();
            taskItem.addChild(dailyCheckButton);

            dailyCheckButton.x = taskItemSize.width * 0.85;
            dailyCheckButton.y = taskItemSize.height / 2;

            var text = new ccui.Text();
            text.attr({
                string: "1当前米粒2当前米粒",
                x: taskItemSize.width * 0.01,
                y: taskItemSize.height * 0.5
            });
            text.setAnchorPoint(0,0.5);
            text.setFontSize(14);
            text.setFontName("FZCuYuan-M03S.ttf");
            text.setColor(cc.color(250, 160, 0));
            text.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
            text.setString(taskTexts[i]);

            taskItem.addChild(text);
            switch (i) {
                case 0:
                    dailyCheckButton.addTouchEventListener(this.taskButtonTouchEvent1, this);
                    if ( cc.sys.localStorage.getItem("dailyMili") ) {
                        dailyCheckButton.setTouchEnabled(false);
                        dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                    break;
                case 1:
                    dailyCheckButton.addTouchEventListener(this.taskButtonTouchEvent2, this);
                    dailyCheckButton.setTouchEnabled(false);
                    dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    break;
                case 2:
                    dailyCheckButton.setTouchEnabled(false);
                    if (cc.sys.localStorage.getItem("isGetFirstThreeLessonAward")) {
                        dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                    break;
                case 3:
                    dailyCheckButton.addTouchEventListener(this.taskButtonTouchEvent4, this);
                    if (cc.sys.localStorage.getItem("weixinAward")) {
                        dailyCheckButton.setTouchEnabled(false);
                        dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                    break;
                case 4:
                    dailyCheckButton.addTouchEventListener(this.taskButtonTouchEvent5, this);
                    if ( sys.localStorage.getItem("evaluateUs") ) {
                        dailyCheckButton.setTouchEnabled(false);
                        dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                    break;
                case 5:
                    dailyCheckButton.addTouchEventListener(this.taskButtonTouchEvent6, this);
                    if ( sys.localStorage.getItem("weiboAward") ) {
                        dailyCheckButton.setTouchEnabled(false);
                        dailyCheckButton.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                    break;
            }
        }

        for (var i=0; i<taskItems.length; i++) {
            var item = taskItems[i];
            listView.insertCustomItem(item, i);
        }
    },
    taskButtonTouchEvent1 : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                this.showDailyCheck();
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default:
                break;
        }
    },
    taskButtonTouchEvent2 : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default:
                break;
        }
    },
    taskButtonTouchEvent3 : function (sender, type) {

    },
    taskButtonTouchEvent4 : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "shareToWechat", "()V");
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default:
                break;
        }
    },
    onShareResult: function (code, msg) {
        cc.log("share result, resultcode:"+code+", msg: "+msg);
    },
    taskButtonTouchEvent5 : function (sender, type) {
        var self = this;
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpToAppMarket", "()V");
                var levingTime = new Date();
                this.scheduleOnce(function () {
                    var returnTime = new Date();
                    var evaluateTime = returnTime - levingTime;
                    if (evaluateTime > 15000) {
                        sys.localStorage.setItem("evaluateUs", true);
                        var rewardNum = self.rewardNum[4];
                        EKCoreManager.getInstance().addMiCoinToUser(rewardNum);
                        var alert = new EKAlertWindow("恭喜你，获得" + rewardNum + "米粒", 18, 1, this, function () {
                            alert.runAction(cc.sequence(
                                cc.scaleTo(0.5, 0).easing(cc.easeBackIn()),
                                cc.callFunc(function() {
                                    alert.removeFromParent(true);
                                })
                            ));
                        });
                        this.addChild(alert);
                        sender.setTouchEnabled(false);
                        sender.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
                    }
                }, 0.5);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default:
                break;
        }
    },
    taskButtonTouchEvent6 : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "shareToSinaWeibo", "()V");
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default:
                break;
        }
    },
    taskButtonComplete : function (buttonIndex) {
        var button = this.taskButtons[buttonIndex];
        button.setTouchEnabled(false);
        button.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");
        var miliNum = this.rewardNum[buttonIndex];
       
     
        
        
        
        
        EKCoreManager.getInstance().addMiCoinToUser(miliNum);

        cc.log(buttonIndex);
        if ( buttonIndex == 3 ) {
            cc.sys.localStorage.setItem("weixinAward", true);
        }
        if ( buttonIndex == 5 ) {
            cc.sys.localStorage.setItem("weiboAward", true);
        }

        var currentMili = cc.sys.localStorage.getItem("MyCoin");
        this.currentMiCoinNumText.setString(currentMili);

        var that = this;
        this.scheduleOnce(function () {
        	that.getParent().refreshMiCoinButton();
        	that.refreshMili();
        	
        	
        	var alert = new EKAlertWindow("恭喜你，获得" + miliNum + "米粒", 18, 1, this, function () {
        		alert.runAction(cc.sequence(
        				cc.scaleTo(0.5, 0).easing(cc.easeBackIn()),
        				cc.callFunc(function() {
        					alert.removeFromParent(true);
        				})
        		));
        	});
        	that.addChild(alert);
        }, 0.7);
//        this.refreshMili();
//        this.getParent().refreshMiCoinButton();


    },
    showDailyCheck : function () {
        var winSize = cc.director.getWinSize();
        var self = this;

        var dayNum = 7;
        this.dailyMiCoinNums = [
            10,
            20,
            15,
            15,
            15,
            15,
            45
        ];

        this.dailyCheckMaskLayer = this.createMask();
        this.addChild(this.dailyCheckMaskLayer, 10);

        var dailyCheckLayout = new ccui.Layout();
        dailyCheckLayout.setClippingEnabled(true);
        dailyCheckLayout.setBackGroundImage("all_Ui/ui_box_dailyCheck.png");
        var size =  dailyCheckLayout.getBackGroundImageTextureSize();
        dailyCheckLayout.setContentSize(cc.size(size.width, size.height));
        dailyCheckLayout.setAnchorPoint(0.5, 0.5);
        dailyCheckLayout.x = winSize.width/2;
        dailyCheckLayout.y = winSize.height/2;
        this.dailyCheckMaskLayer.addChild(dailyCheckLayout);

        var dailyCheckLayoutSize = dailyCheckLayout.getBackGroundImageTextureSize();
        var closeButton = new ccui.Button();
        this.dailyCheckMaskLayer.addChild(closeButton);
        closeButton.setTouchEnabled(true);
        closeButton.loadTextures("all_Ui/ui_close.png", "all_Ui/ui_close.png");
        closeButton.x = dailyCheckLayoutSize.width/2 + winSize.width/2;
        closeButton.y = dailyCheckLayoutSize.height/2 + winSize.height/2;
        closeButton.addTouchEventListener(this.dailyCheckCloseButtonTouchEvent, this);

        var checkDate = new Date();
        var dayNumber = cc.sys.localStorage.getItem("dayNumber");
        var checkYear = cc.sys.localStorage.getItem("checkYear");
        var checkMonth = cc.sys.localStorage.getItem("checkMonth");
        var checkDay = cc.sys.localStorage.getItem("checkDay");
        if (!dayNumber || !checkYear) {
            dayNumber = 0;
            checkYear = 2014;
            checkMonth = 7;
            checkDay = 6;
            cc.sys.localStorage.setItem("dayNumber", dayNumber);
            cc.sys.localStorage.setItem("checkYear", checkYear);
            cc.sys.localStorage.setItem("checkMonth", checkMonth);
            cc.sys.localStorage.setItem("checkDay", checkDay);
        }
        dayNumber = parseInt(dayNumber);
        checkDate.setFullYear(parseInt(checkYear),parseInt(checkMonth),parseInt(checkDay));

        var dailyNums = [
            "第一天",
            "第二天",
            "第三天",
            "第四天",
            "第五天",
            "第六天",
            "第七天"
        ];
        for (var i=0; i<7; i++) {
            var checkButton = new ccui.Button();
            checkButton.loadTextures("all_Ui/ui_daily_checking.png", "all_Ui/ui_daily_checking.png", "all_Ui/ui_daily_checking.png");
            checkButton.addTouchEventListener(this.checkButtonTouchEvent, this);
            checkButton.dayNumber = dayNumber;

            var column = i%4;
            var x, y;
            if (i<4) {
                x = dailyCheckLayoutSize.width*0.2*(column+1) + (winSize.width-dailyCheckLayoutSize.width)/2;
                y = dailyCheckLayoutSize.height*0.7 + (winSize.height-dailyCheckLayoutSize.height)/2;
                checkButton.setPosition(x, y);
            } else {
                x = dailyCheckLayoutSize.width*0.2*(column+1) + (winSize.width-dailyCheckLayoutSize.width)/2;
                y = dailyCheckLayoutSize.height*0.3 + (winSize.height-dailyCheckLayoutSize.height)/2;
                checkButton.setPosition(x, y);
            }

            this.dailyCheckMaskLayer.addChild(checkButton);

            var dailyNum = ccui.Text();
            dailyNum.setString(dailyNums[i]);
            checkButton.addChild(dailyNum);
            var buttonSize = checkButton.getContentSize();
            dailyNum.setPosition(buttonSize.width/2, buttonSize.height * 0.87);
            dailyNum.setColor(cc.color.WHITE);

            var miliNum = ccui.Text();
            miliNum.setString("+"+self.dailyMiCoinNums[i]);
            checkButton.addChild(miliNum);
            miliNum.setPosition(buttonSize.width/4, buttonSize.height * 0.68);
            miliNum.setColor(cc.color(255,102,51));

            var isNewDate =  this.isNewDate();
            if (i == dayNumber && isNewDate) {
                checkButton.setTouchEnabled(true);
            } else {
                checkButton.setTouchEnabled(false);
                if (i<dayNumber) {
                    var sprite = cc.Sprite.create("all_Ui/ui_daily_checking.png");
                    this.changeShader("gray", sprite);
                    checkButton.addChild(sprite);
                    var checkButtonSize = checkButton.getContentSize();
                    sprite.x = checkButtonSize.width/2;
                    sprite.y = checkButtonSize.height/2;
                    sprite.setOpacity(160);

                    var checkDone = new ccui.Button();
                    checkDone.loadTextures("all_Ui/ui_daily_checkDone.png", "all_Ui/ui_daily_checkDone.png", "all_Ui/ui_daily_checkDone.png");
                    checkDone.setTouchEnabled(false);
                    checkDone.setScale(0.5);
                    checkDone.x = checkButtonSize.width/2;
                    checkDone.y = checkButtonSize.height/2;
                    checkButton.addChild(checkDone);
                }
            }
        }

        var checkButtonSize = checkButton.getContentSize();
        if (checkDone) {
            checkDone.setPosition(checkButtonSize.width/2, checkButtonSize.height/2);
        }

    },
    dailyCheckCloseButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                this.dailyCheckMaskLayer.removeFromParent(true);
                break;
            default:
                break;
        }
    },
    isNewDate : function () {
        var checkDate = new Date();
        var dayNumber = cc.sys.localStorage.getItem("dayNumber");
        var checkYear = cc.sys.localStorage.getItem("checkYear");
        var checkMonth = cc.sys.localStorage.getItem("checkMonth");
        var checkDay = cc.sys.localStorage.getItem("checkDay");
        if (!dayNumber || !checkYear) {
            dayNumber = 0;
            checkYear = 2014;
            checkMonth = 7;
            checkDay = 6;
            cc.sys.localStorage.setItem("dayNumber", dayNumber);
            cc.sys.localStorage.setItem("checkYear", checkYear);
            cc.sys.localStorage.setItem("checkMonth", checkMonth);
            cc.sys.localStorage.setItem("checkDay", checkDay);
        }
        dayNumber = parseInt(dayNumber);
        checkDate.setFullYear(parseInt(checkYear),parseInt(checkMonth),parseInt(checkDay));

        var isNewDate = compareDate(checkDate);
        return isNewDate;
    },
    checkButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                var message;
                var miNumber = this.dailyMiCoinNums[sender.dayNumber];
                var messages = [
                    "恭喜获得10米粒！只要45米粒就可以轻松解锁一个课程哦！",
                    "恭喜获得20米粒！一天学习一个字母，快乐完成英语启蒙。",
                    "恭喜获得15米粒！宝宝好开心，又可以探索新的知识啦！",
                    "恭喜获得15米粒！您也可以通过购买米粒来解锁更多课程哦！",
                    "恭喜获得15米粒！我们微信公众号也会经常有送米粒的活动哦！",
                    "恭喜获得15米粒！宝宝每天最佳学习时间是20分钟哦！",
                    "恭喜获得45米粒！签到任务已经全部完成啦，快去兑换课程吧！"
                ];

                EKCoreManager.getInstance().addMiCoinToUser(miNumber);
                this.refreshMili();
                this.getParent().refreshMiCoinButton();
//                var that = this;
//                self.scheduleOnce(function () {
//                	that.refreshMili();
//                	that.getParent().refreshMiCoinButton();
//                }, 0.7);
                
                
                var alertWindow = new EKAlertWindow(messages[sender.dayNumber], 15, 1, this, function(){
                    alertWindow.runAction(cc.sequence(
                        cc.scaleTo(0.5, 0).easing(cc.easeBackIn()),
                        cc.callFunc(function() {
                            alertWindow.removeFromParent(true);
                        })
                    ));
                });
                this.addChild(alertWindow, 20);
                sender.setTouchEnabled(false);
                sender.loadTextures("all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png", "all_Ui/ui_button_dailyCheck_done.png");

                var dayNumber = sender.dayNumber + 1;
                var today = new Date();
                var checkYear = today.getFullYear();
                var checkMonth = today.getMonth();
                var checkDay = today.getDate();
                cc.sys.localStorage.setItem("dayNumber", dayNumber);
                cc.sys.localStorage.setItem("checkYear", checkYear);
                cc.sys.localStorage.setItem("checkMonth", checkMonth);
                cc.sys.localStorage.setItem("checkDay", checkDay);

                if (sender.dayNumber === 6) {
                    cc.sys.localStorage.setItem("dailyMili", true);
                }

                this.dailyCheckMaskLayer.removeFromParent(true);
                this.showDailyCheck();

                break;
            default:
                break;
        }
    },
    changeShader : function(shaderName, sprite) {
        cc.log("changeShader");
        var shader = cc.GLProgram.create(shaderName+".vsh", shaderName+".fsh");
        shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
        shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);

        shader.link();
        shader.updateUniforms();
        sprite.setShaderProgram(shader);
    }
});