/**
 * Created by bran on 14-9-4.
 */

var shopManifest = "Manifest/shop/shop_project.manifest";
//var storagePaths = "shop/";
var bannerPaths = ["banner_0.png", "banner_1.png"];

var EKShopMainLayer = cc.Layer.extend({
    ctor: function (isShowMiCoin) {
        this._super();

        this.schedule(function () {
            var m = EKCoreManager.getInstance();
            m.currentReminderTickingTime++;
            var remindTimekey = "remindTime";
            var remindTimeNum = parseInt(cc.sys.localStorage.getItem(remindTimekey));
            var remindTime;
            if (remindTimeNum == 0) {
                remindTime = 10 * 60;
            } else if (remindTimeNum == 2) {
                remindTime = 30 * 60;
            } else {
                remindTime = 20 * 60;
            }
            if (m.currentReminderTickingTime == remindTime) {
                m.showGuideWithSoundFiles();
            }
        }, 1);

        if ( isLangCN() ) {
            var currentDisplayStr = "displayTitle";
            var currentOringinalPrice = "originalPrice";
            var currentDiscountedPrice = "discountedPrice";
        } else {
            var currentOringinalPrice = "originalPrice_eng";
            var currentDiscountedPrice = "discountedPrice_eng";
            var currentDisplayStr = "displayTitle_eng";
        }

//        EKCoreManager.getInstance().refreshOnlineProducts();

        var winSize = cc.director.getWinSize();
        var bg = cc.Sprite.create("shop/bg.png");
        this.addChild(bg);
        bg.setPosition(winSize.width/2, winSize.height/2);

        this.onStart();

        if (EKCoreManager.getInstance().isShowMiCoinLayer) {
            this.showMiCoinLayer();
        }

        if (EKCoreManager.getInstance().isFromHomeToShop) {
            cc.eventManager.addListener({
                event: cc.EventListener.KEYBOARD,
                onKeyReleased: function(keyCode, event){
                    if(keyCode == cc.KEY.back) {
                        EKCoreManager.getInstance().gotoHome();
                    }
                }
            }, this);
        } else {
            cc.eventManager.addListener({
                event: cc.EventListener.KEYBOARD,
                onKeyReleased: function(keyCode, event){
                    if(keyCode == cc.KEY.back) {
                        EKCoreManager.getInstance().gotoMap();
                    }
                }
            }, this);
        }

        return true;
    },

    onStart : function () {
        var latestUnlockedLevelAndSubLevel = EKCoreManager.getInstance().latestUnlockedLevelAndSubLevel();
        var latestLevelIndex = latestUnlockedLevelAndSubLevel[0];
        if (latestLevelIndex === 26)
        {
            latestLevelIndex = 25;
        }
        var key = "LAST_MAP_LETTER_INDEX";
        cc.sys.localStorage.setItem(key, latestLevelIndex);
        this.startSetupAll();
    },
    waitAndLoadResources : function () {
        //TODO : startSetupAll
    },
    startSetupAll : function () {
        cc.log("startSetupAll");
        this.setupUi();
        this.setUpMainScroller();
        this.setupMainPage();
        this.setupTopScroller();
        this.setupBoxes();
        this.setupMiCoinButton();
        this.setupExchangeBox();
        this.setupExchangeButton();
//        this.setupDownBanner();
    },
    setupUi : function () {
        cc.log("setupUi");
        var winSize = cc.director.getWinSize();

        var bg = cc.Sprite.create("shop/bg.png");
        this.addChild(bg);
        bg.setPosition(winSize.width/2, winSize.height/2);

        var topStr;
        if ( isLangCN() ) {
            topStr = "shop/top.png";
        } else {
            topStr = "shop/top_eng.png";
        }
        var top = cc.Sprite.create(topStr);
        top.setAnchorPoint(0.5, 1);
        top.setPosition(winSize.width/2, winSize.height);
        this.addChild(top, 11);
        this.setupBackButton();
    },
    setUpMainScroller : function() {
        cc.log("setUpMainScroller");
        var winSize = cc.director.getWinSize();
        this.scrollView = new ccui.ScrollView();
        this.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.scrollView.setTouchEnabled(true);
        this.scrollView.setSwallowTouches(false);
        this.scrollView.setContentSize(cc.size(winSize.width, winSize.height*0.7));
        this.scrollView.setAnchorPoint(0.5, 1);
        this.scrollView.setPosition(winSize.width/2, winSize.height*0.75);

        var numOfBox;// = EKCoreManager.getInstance().offeringSingleProducts().length;
        numOfBox = 3;
        var numOfBoxRow = Math.ceil(numOfBox/3);
        this.scrollView.setInnerContainerSize(cc.size(winSize.width, winSize.height*(0.9+0.5*numOfBoxRow)));
        this.addChild(this.scrollView, 10);
    },
    setupTopScroller : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        cc.log("setupTopScroller");

        var scrollViewInnerSize = this.scrollView.getInnerContainerSize();
        var pageView = new ccui.PageView();
        pageView.setTouchEnabled(true);
        pageView.setSwallowTouches(false);
        pageView.setContentSize(cc.size(238, 96.5));
        pageView.setPosition(scrollViewInnerSize.width/2, scrollViewInnerSize.height*0.96);
        pageView.setAnchorPoint(0.5, 1);
        pageView.setClippingEnabled(false);
        this.scrollView.addChild(pageView, 10);
        if (winSize.width/winSize.height > 1.77) {
            pageView.y -= 20;
        }

        this.imageViews = [];
        var numOfBanners = 3;
        var banners = ["shop/banner_0.png", "shop/banner_1.png", "shop/banner_2.png"];
        for (var i = 0; i < numOfBanners; i++) {
            var layout = new ccui.Layout();
            layout.setContentSize(cc.size(238, 96.5));
            var layoutRect = layout.getContentSize();

            var imageView = new ccui.ImageView();
            imageView.setTouchEnabled(true);
            imageView.setScale9Enabled(true);
            imageView.setRotation(180);

            if (isLangCN()) {
                imageView.loadTexture("shop/loading.png");
            } else {
                imageView.loadTexture("shop/loading_eng.png");
            }

            imageView.loadTexture(banners[i]);
            imageView.index = i;
            imageView.addTouchEventListener(this.bannerTouchEvent, this);


//            var ShopItem = AV.Object.extend("ShopItem");
//            var query = new AV.Query(ShopItem);
//            query.equalTo("type", "banner_top");
//            query.find({
//                success: _.bind(function(results) {
//                    cc.log("Successfully retrieved " + results.length + " scores." + " j " + " i " + this.index);
//                    for (var j = 0; j < results.length; j++) {
//                        if (this.index === j) {
//                            var object = results[j];
//                            cc.log(object.id + ' - ' + object.get('index'));
//                            var bannerImage = object.get('banner');
//                            cc.log(bannerImage.url());
//
//                            var xhr = cc.loader.getXMLHttpRequest();
//                            xhr.open("GET", bannerImage.url(), true);
//                            xhr.onreadystatechange = function () {
//                                if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
//                                    var httpStatus = xhr.statusText;
//                                    var response = xhr.responseText.substring(0, 100) + "...";
//                                    cc.log(response);
//                                    cc.log("Status: Got GET response! " + httpStatus);
//                                }
//                            };
//                            xhr.send();
//                        }
//                    }
//                }, {index:i} ),
//                error: function(error) {
//                    alert("Error: " + error.code + " " + error.message);
//                }
//            });

            imageView.setContentSize(cc.size(238*0.9, 96.5*0.9));
            imageView.x = layoutRect.width / 2;
            imageView.y = layoutRect.height / 2;
            layout.addChild(imageView);
            pageView.addPage(layout);

            this.imageViews.push(imageView);

//            var obj = EKCoreManager.getInstance().offeringShopBanners()[i];
        }

//        var sdCardPath = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "filepath", "()Ljava/lang/String;");

//        var storagePath = jsb.fileUtils.getWritablePath();
//        cc.log("Storage path for this test : " + storagePath);
//        this._am = new jsb.AssetsManager(shopManifest, storagePath);
//        this._am.retain();
//        if (!this._am.getLocalManifest().isLoaded())
//        {
//            cc.log("Fail to update assets, step skipped.");
//        } else {
//            var listener = new jsb.EventListenerAssetsManager(this._am, function(event) {
//                switch (event.getEventCode()) {
//                    case jsb.EventAssetsManager.UPDATE_FINISHED:
//                        cc.log("12344444444444444444");
//                        for (var nn=0; nn<self.imageViews.length; nn++) {
//
//                            var sprite = cc.Sprite.create("banner_0.png");
//                            var imageView = self.imageViews[nn];
//
//                            imageView.addChild(sprite);
//                            sprite.x = sprite.getContentSize().width/2;
//                            sprite.y = sprite.getContentSize().height/2;
//                        }
//                        break;
//                }
//            });
//            cc.eventManager.addListener(listener, 1);
//            this._am.update();
//        }

        var middleNumber = Math.floor(numOfBanners/2);
        pageView.scrollToPage(middleNumber);

    },
    bannerTouchEvent : function (sender, type) {
        var self = this;
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.05);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                var index = sender.index;
                switch (index) {
                    case 0:
                        break;
                    case 1:
                    	if(this.firstBox){
                    		var isFirstBuyItem = cc.sys.localStorage.getItem("isFirstBuyItem");
                    		if (!isFirstBuyItem) {
                    			this.boxTouchEvent(this.firstBox,ccui.Widget.TOUCH_ENDED);
                    		}
                    		
                    	}
                    	
                    	
//                        var GameScore = AV.Object.extend("Switch");
//                        var query = new AV.Query(GameScore);
//                        query.equalTo("name", "bannerURL");
//                        query.find({
//                            success: function(results) {
//                                cc.log("Successfully retrieved " + results.length + " scores.");
//                                // Do something with the returned AV.Object values
//                                var object = results[0];
//                                var isOn = object.get('isOn');
//                                if (isOn) {
//                                    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpToURL", "(Ljava/lang/String;)V", "http://jq.qq.com/?_wv=1027&k=QGZrv5");
//                                }
//                            },
//                            error: function(error) {
//                                cc.log("Error: " + error.code + " " + error.message);
//                            }
//                        });
                        break;
                    case 2:
//                        var GameScore = AV.Object.extend("Switch");
//                        var query = new AV.Query(GameScore);
//                        query.equalTo("name", "bannerURL");
//                        query.find({
//                            success: function(results) {
//                                cc.log("Successfully retrieved " + results.length + " scores.");
//                                // Do something with the returned AV.Object values
//                                var object = results[0];
//                                var isOn = object.get('isOn');
//                                if (isOn) {
//                                    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpToURL", "(Ljava/lang/String;)V", "http://m.wsq.qq.com/263465075");
//                                }
//                            },
//                            error: function(error) {
//                                cc.log("Error: " + error.code + " " + error.message);
//                            }
//                        });
                        break;
                    default :
                        break;
                }
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            default :
                break;
        }
    },
    setupBoxes : function () {
        cc.log("setupBoxes");
    },
    setupMainPage : function () {
        cc.log("setupMainPage");
        var self = this;
        this.boxes = [];
        var numOfBox = 3;//EKCoreManager.getInstance().offeringSingleProducts().length;
        var scrollViewInnerSize = this.scrollView.getInnerContainerSize();
        var winSize = cc.director.getWinSize();
        var numPerRow = 3;

        numOfBox = 3;
        var intervalCol = winSize.width*0.01;
        var intervalOfRow = winSize.width*0.01
        
  
        var coinsImage = ["all_Ui/ui_coin_180.png", "all_Ui/ui_coin_360.png", "all_Ui/ui_coin_540.png"];
        var isFirstBuyItem = cc.sys.localStorage.getItem("isFirstBuyItem");
        if (!isFirstBuyItem) {
        	coinsImage = ["all_Ui/ui_coin_1.png", "all_Ui/ui_coin_360.png", "all_Ui/ui_coin_540.png"];
        }
        
        
        for (var i=0; i< numOfBox; i++) {
//            var box = cc.BuilderReader.load("shop_box");
//            box.setAnchorPoint(0,1);
//            var boxContentSize = box.getContentSize();
//            this.scrollView.addChild(box);
//            box.setPosition(winSize.width*0.03+boxContentSize.width*(i%numPerRow)+intervalCol*(i%numPerRow),
//                    scrollViewInnerSize.height - 120 - boxContentSize.height*Math.floor(i/numPerRow) - intervalOfRow*Math.floor(i/numPerRow));
//            box.controller.buyButton.addTargetWithActionForControlEvents(this, function(j){
//                return function() {
//                    self.mainScrollerInsideButtonTapped(j);
//                };
//            }(i), cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
//            this.boxes.push(box);
            var box = new ccui.ImageView();
            box.index = i;
            box.loadTexture(coinsImage[i]);
            box.setAnchorPoint(0, 1);
            var boxContentSize = box.getContentSize();
            box.setPosition(winSize.width*0.03+boxContentSize.width*(i%numPerRow)+intervalCol*(i%numPerRow),
                    scrollViewInnerSize.height - 140 - boxContentSize.height*Math.floor(i/numPerRow) - intervalOfRow*Math.floor(i/numPerRow));
            this.scrollView.addChild(box);
            box.addTouchEventListener(this.boxTouchEvent, this);
            box.setTouchEnabled(true);
            if(i==0){
            	this.firstBox = box;
            }
            
        }
    },
    boxTouchEvent : function (sender, type) {
        var self = this;
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.05);
                break;
            case ccui.Widget.TOUCH_ENDED:
                sender.setScale(1);
                var index = sender.index;

                var messages = [
                    "180米粒：您可以购买4个课程哦！",
                    "320米粒：您可以购买8个课程哦！",
                    "540米粒：您可以购买12个课程哦！"
                ];
                var Product_Prices = ["18", "32", "48"];

                // 测试模式
//                Product_Prices = ["0.01", "1", "2"];

                var miliNums = [180, 360, 540];
                if(isOpenAnySdk == false){
                	return;
                }
                var agent = anysdk.AgentManager.getInstance();

                var analytics_plugin = agent.getAnalyticsPlugin();
                var item_ID = miliNums[index]+"米粒";

                
                
                var isFirstBuyItem = cc.sys.localStorage.getItem("isFirstBuyItem");
              
                if (!isFirstBuyItem&&index==0) {
                	Product_Prices = ["1", "32", "48"];
                }
                
                var productInfos = [
                    {
                        Product_Price:Product_Prices[0],
                        Product_Id:messages[0],
                        Product_Name:"180米粒",
                        Server_Id:"13",
                        Product_Count:"1",
                        Role_Id:"180",
                        Role_Name:"360用户"
                    },
                    {
                        Product_Price:Product_Prices[1],
                        Product_Id:messages[1],
                        Product_Name:"360米粒",
                        Server_Id:"13",
                        Product_Count:"1",
                        Role_Id:"360",
                        Role_Name:"360用户"
                    },
                    {
                        Product_Price:Product_Prices[2],
                        Product_Id:messages[2],
                        Product_Name:"540米粒",
                        Server_Id:"13",
                        Product_Count:"1",
                        Role_Id:"540",
                        Role_Name:"360用户"
                    }
                ];

                var message = messages[index];
                this.productInfo = productInfos[index];
                this.miliNum = miliNums[index];

                cc.log("1.miliNum " + this.miliNum);

                var alertView = new EKAlertWindow(message, 15, 1, this, function () {
                	
                    var agent = anysdk.AgentManager.getInstance();
                    var iap_plugins = agent.getIAPPlugin();
                    for(var key in iap_plugins){
                        cc.log("key " + key);

                        if ( key == "000724"||key == "69" ) {
                        	cc.log("key uuuu" + key);
                            var iap_plugin = iap_plugins[key];

                            cc.log("productInfo " + self.productInfo);

                            iap_plugin.payForProduct(self.productInfo);
                            iap_plugin.setResultListener(function(ret, msg, info){
                                cc.log("pay result, resultcode:"+ret+", msg: "+msg+", info:"+info);
                                if( ret == PayResultCode.kPaySuccess ) {
                                	cc.sys.localStorage.setItem("isFirstBuyItem", true);
                                    EKCoreManager.getInstance().addMiCoinToUser(self.miliNum);
                                    cc.log("2.miliNum " + self.miliNum);
                                    analytics_plugin.logEvent("Buy Mili Successfully", {"item ID": item_ID});
                                 
                                 
                                    
                                	
                                	
                                    self.scheduleOnce(function () {
                                        self.refreshMiCoinButton();
                                        self.firstBox.loadTexture("all_Ui/ui_coin_180.png");
                                        if (alertView) {
                                            alertView.removeFromParent(true);
                                        }
                                    }, 1);
                                  
                                   
                                } else {
                                	
                                    cc.log("kPayFail");
                                }
                            }, this);
                        }

                        else  if (key == "000023"  ) {
                        	cc.log("key uuuu" + key);
                            var iap_plugin = iap_plugins[key];

                            cc.log("productInfo " + self.productInfo);

                            iap_plugin.payForProduct(self.productInfo);
                            iap_plugin.setResultListener(function(ret, msg, info){
                                cc.log("pay result, resultcode:"+ret+", msg: "+msg+", info:"+info);
                                if( ret == PayResultCode.kPaySuccess ) {
                                	cc.sys.localStorage.setItem("isFirstBuyItem", true);
                                    EKCoreManager.getInstance().addMiCoinToUser(self.miliNum);
                                    cc.log("2.miliNum " + self.miliNum);
                                    analytics_plugin.logEvent("Buy Mili Successfully", {"item ID": item_ID});
                    
                                    

                                    //var box = new ccui.ImageView();
                                    //box.index = i;
                                    //box.loadTexture("all_Ui/ui_coin_180.png");
                                    //box.setAnchorPoint(0, 1);
                                    //var boxContentSize = box.getContentSize();
                                    //box.setPosition(self.firstBox.x,self.firstBox.y);
                                    //this.scrollView.addChild(box);
                                    //box.addTouchEventListener(this.boxTouchEvent, this);
                                    //box.setTouchEnabled(true);
                                    //
                                    
                                    
                                    
                                    
                                    self.scheduleOnce(function () {
                                        self.refreshMiCoinButton();
                                      
                                        self.firstBox.loadTexture("all_Ui/ui_coin_180.png");
                                        
                                        
                                        if (alertView) {
                                            alertView.removeFromParent(true);
                                        }
                                    }, 1);
                                    

                                } else {
                                	
                              
                                    cc.log("kPayFail");
                                }
                            }, this);
                        }

                    }

                    alertView.retain();

                    analytics_plugin.logEvent("Click the goods of OK", {"item ID": item_ID});
                });
                this.addChild(alertView, 100);

                analytics_plugin.logEvent("Click the goods", {"item ID": item_ID});

                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
            default :
                break;
        }
    },
    setupDownBanner : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var scrollViewInnerSize = this.scrollView.getInnerContainerSize();

        var bannerDown = new ccui.ImageView();
        bannerDown.loadTexture("shop/banner_down.png");
        bannerDown.setAnchorPoint(0, 1);
        var boxContentSize = bannerDown.getContentSize();
        bannerDown.setPosition(boxContentSize.width*0.02, scrollViewInnerSize.height * 0.35);
        this.scrollView.addChild(bannerDown);

        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,                       // 设置是否吞没事件，在 onTouchBegan 方法返回 true 时吞掉事件，不再向下传递。
            onTouchBegan: function (touch, event) {     //实现 onTouchBegan 事件处理回调函数
                var target = event.getCurrentTarget();  // 获取事件所绑定的 target, 通常是cc.Node及其子类

                // 获取当前触摸点相对于按钮所在的坐标
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();

                var rect1 = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect1, locationInNode)) {
                    target.setScale(1.05);
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                // 移动当前按钮精灵的坐标位置
                var target = event.getCurrentTarget();
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();

                target.setScale(1);
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();

                var rect1 = cc.rect(0, 0, s.width/4, s.height);
                var rect2 = cc.rect(s.width/4, 0, s.width/2, s.height);
                var rect3 = cc.rect(s.width/2, 0, s.width*3/4, s.height);

                if (cc.rectContainsPoint(rect1, locationInNode)) {
                    self.mainScrollerInsideButtonTapped(0);
                }
                if (cc.rectContainsPoint(rect2, locationInNode)) {
                    self.mainScrollerInsideButtonTapped(1);
                }
                if (cc.rectContainsPoint(rect3, locationInNode)) {
                    self.mainScrollerInsideButtonTapped(2);
                }
            }
        });
        cc.eventManager.addListener(listener, bannerDown);
    },
    mainScrollerInsideButtonTapped : function(index) {
        cc.log("mainScrollerInsideButtonTapped");
        this.createShopDetailWithindex(index);
    },
    createMask : function () {
        var winSize = cc.director.getWinSize();
        this.maskLayout = new ccui.Layout();
        this.maskLayout.setContentSize(winSize.width, winSize.height);
        this.maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        this.maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        this.maskLayout.setBackGroundColorOpacity(100);

        this.addChild(this.maskLayout, ZOrder_UI+1);
        this.maskLayout.setTouchEnabled(true);
    },
    createShopDetailWithindex : function(index) {
        cc.log("createShopDetailWithindex");
        var self = this;
        var winSize = cc.director.getWinSize();
        this.createMask();

        this.detailBox = cc.BuilderReader.load("shopDetail.ccbi", this);
        this.maskLayout.addChild(this.detailBox);
        this.detailBox.setPosition(winSize.width/2, winSize.height/2);
        if (isLangCN()) {
            this.specialBuyButton_eng.setVisible(false);
        }

        if (index === 0) {
            this.titleLabel.setString("快乐字母DEFG");
            this.descriptionLabel.setString("米亚米娜没有停下冒险的脚步，他们来到农场，又有新鲜事发生哦！");
            var content = "故事：\n《小狗在哪里？》\n《这是谁的蛋？》\n《青蛙先生怎么啦？》\n《惊喜的礼物》\n单词：\n * Dog Duck Egg Eagle \n * Frog Fish Goat Gift\n句型：\n * I see... I find...\n * Hello...  I like...";
            this.descriptionLabel2.setString(content);
            this.normalDiscountPriceLabel.setVisible(false);
            this.line.setVisible(false);
            this.specialBuyButton_eng.setVisible(false);
            this.specialBuyButton.setVisible(false);
            this.normalBuyButton.setVisible(false);
        }
        if (index === 1) {
            this.titleLabel.setString("快乐字母HIJK");
            this.descriptionLabel.setString("米亚米娜来到海洋，无论在海底还是在海面航行，充满无穷趣味！");
            var content = "故事：\n《戴帽子的鱼先生》\n《海里的冰激凌》\n《爱吃果酱的鲸鱼》\n《糖果国王》\n单词：\n * Hat Hole Icecream Iron\n* Jam Jewelry Key King\n句型：\n * I can hide...\n * Icecream is cold.\n* Iron is hot.\n * The Jam is sweet.\n* The jewelry is shiny.";
            this.descriptionLabel2.setString(content);
            this.normalDiscountPriceLabel.setVisible(false);
            this.line.setVisible(false);
            this.specialBuyButton_eng.setVisible(false);
            this.specialBuyButton.setVisible(false);
            this.normalBuyButton.setVisible(false);
        }
        if (index === 2) {
            this.titleLabel.setString("快乐字母LMNO");
            this.descriptionLabel.setString("米亚米娜来到神秘的怪物森林玩，到底会发生些什么呢？");
            var content = "故事：\n《怪物的家》\n《怪物们的舞会》\n《和怪物一起晚餐》\n《猫头鹰先生的蛋糕店》\n单词：\n * Leaf Leg Moon Mask\n* Nest Noodles Owl Oven \n句型：\n* I have...\n* I can draw... \n* The nest is in the tree.\n* The noodles are in the bowl.\n* The owl is flying.\n* The oven is working. ";
            this.descriptionLabel2.setString(content);
            this.normalDiscountPriceLabel.setVisible(false);
            this.line.setVisible(false);
            this.specialBuyButton_eng.setVisible(false);
            this.specialBuyButton.setVisible(false);
            this.normalBuyButton.setVisible(false);
        }

        var boxContentSize = this.detailBox.getContentSize();
        var pageView = new ccui.PageView();
        pageView.setTouchEnabled(true);
        pageView.setContentSize(cc.size(120, 90));
        pageView.setPosition(boxContentSize.width*0.33, boxContentSize.height*0.55);
        pageView.setAnchorPoint(0.5, 0.5);
        this.detailBox.addChild(pageView);
        for (var i = 0; i < 4; i++) {
            var layout = new ccui.Layout();
            layout.setContentSize(cc.size(120, 90));
            var layoutRect = layout.getContentSize();
            var imageView = new ccui.ImageView();
            imageView.setTouchEnabled(true);
            imageView.setScale9Enabled(true);

            var imageName = "preview/Preview_1_" + ((index+1)*4+i) + ".jpg";
            imageView.loadTexture(imageName);

            imageView.setContentSize(cc.size(120, 90));
            imageView.x = layoutRect.width / 2;
            imageView.y = layoutRect.height / 2;
            layout.addChild(imageView);
            pageView.addPage(layout);
        }
        pageView.addEventListener(this.previewPageViewEvent, this);

        this.detailBoxPack = cc.BuilderReader.load("shopDetailPack.ccbi", this);
        this.maskLayout.addChild(this.detailBoxPack);
        this.detailBoxPack.setPosition(winSize.width*1.5, winSize.height/2);
    },
    previewPageViewEvent : function() {

    },
    "cancelButtonTapped:" : function() {
        this.maskLayout.removeFromParent(true);
    },
    "buyWithNormalOffer:" : function() {
        cc.log("buyWithNormalOffer");
    },
    "specialPackButtonTapped:" : function() {
        var winSize = cc.director.getWinSize();
        this.detailBox.runAction(cc.sequence(
            cc.moveTo(0.6, cc.p(-winSize.width/2, winSize.height/2)).easing(cc.easeBackOut())
        ));
        this.detailBoxPack.runAction(cc.sequence(
            cc.moveTo(0.6, cc.p(winSize.width/2, winSize.height/2)).easing(cc.easeBackOut())
        ));
    },
    "backButtonTapped:" : function() {
        var winSize = cc.director.getWinSize();
        this.detailBox.runAction(cc.sequence(
            cc.moveTo(1, cc.p(winSize.width/2, winSize.height/2)).easing(cc.easeBackOut())
        ));
        this.detailBoxPack.runAction(cc.sequence(
            cc.moveTo(0.6, cc.p(winSize.width*1.5, winSize.height/2)).easing(cc.easeBackOut())
        ));
    },
    setupBackButton : function() {
        cc.log("setupBackButton");
        var winSize = cc.director.getWinSize();
        var buttonSprite = cc.Scale9Sprite.create("all_Ui/backButton.png");
        this.backButton = cc.ControlButton.create(buttonSprite);
        this.backButton.setPreferredSize(buttonSprite.getOriginalSize());
        this.addChild(this.backButton, ZOrder_UI);
        this.backButton.setPosition(winSize.width*0.08, winSize.height*0.9);
        this.backButton.addTargetWithActionForControlEvents(this, this.backButtonTapped, cc.CONTROL_EVENT_TOUCH_UP_INSIDE);
    },
    backButtonTapped : function() {
        EKCoreManager.getInstance().gotoMap();
    },
    pageViewEvent : function(sender, type) {
        cc.log("pageViewEvent");
        switch (type) {
            case ccui.PageView.EVENT_TURNING:
                var pageView = sender;
                cc.log("getCurPageIndex:" + pageView.getCurPageIndex());
                break;
            default:
                break;
        }
    },
    setupMiCoinButton : function () {
        cc.log("setupMiCoinButton");
        var winSize = cc.director.getWinSize();
        // Create the button
        var button = new ccui.Button();
        button.setTouchEnabled(true);
        button.loadTextures("all_Ui/ui_coin_box.png", "all_Ui/ui_coin_box.png", "");
        button.x = winSize.width * 0.28;
        button.y = winSize.height * 0.9;
        button.addTouchEventListener(this.miCoinButtonTouchEvent, this);
        this.addChild(button, ZOrder_UI);
        this.miCoinButton = button;

        this.refreshMiCoinButton();

    },
    refreshMiCoinButton : function() {
        var buttonSize = this.miCoinButton.getContentSize();
        if (this.coin) {
            this.coin.removeFromParent(true);
        }
        this.coin = new ccui.Text();
        var coinText = cc.sys.localStorage.getItem("MyCoin") || 0;
        this.coin.setString(coinText);
        this.coin.setFontSize(13);
        this.coin.setColor(cc.color.WHITE);
        this.coin.setPosition(cc.p(buttonSize.width/2-2, buttonSize.height*0.52));
        this.miCoinButton.addChild(this.coin);
    },
    miCoinButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                this.showMiCoinLayer();
                break;
            default:
                break;
        }
    },
    showMiCoinLayer : function () {
        var miCoinLayer = new EKMiCoinLayer();
        miCoinLayer.setTag(100);
        miCoinLayer.setScale(0);
        this.addChild(miCoinLayer, ZOrder_UI);
        miCoinLayer.runAction(
            cc.scaleTo(0.5, 1).easing(cc.easeBackOut())
        )
    },

    setupExchangeBox : function () {
        var winSize = cc.director.getWinSize();
        var boxBg = cc.Sprite.create("all_Ui/ui_box.png");
        boxBg.setAnchorPoint(1, 0.5);
        boxBg.setPosition(winSize.width*0.85, winSize.height*0.9);
        var boxBgSize = boxBg.getContentSize();
        this.addChild(boxBg, ZOrder_UI);

        var textField = new ccui.TextField();
        textField.setTouchEnabled(true);
        textField.setMaxLengthEnabled(true);
        textField.setMaxLength(10);
        textField.setPlaceHolder("请输入兑换码");
//        textField.setPlaceholderFontSize(15);
        textField.fontName = "Marker Felt";
        textField.fontSize = 20;
        textField.x = boxBgSize.width / 2.0;
        textField.y = boxBgSize.height / 2.0;
        textField.addEventListener(this.textFieldEvent, this);
        boxBg.addChild(textField, ZOrder_UI);
        this.exchangeTextField = textField;
    },
    textFieldEvent: function (sender, type) {

    },
    setupExchangeButton : function () {
        var winSize = cc.director.getWinSize();
        var button = new ccui.Button();
        button.setTouchEnabled(true);
        button.loadTextures("all_Ui/ui_exchange.png", "all_Ui/ui_exchange.png", "");
        button.setAnchorPoint(0, 0.5);
        button.x = winSize.width*0.85;
        button.y = winSize.height*0.9;
        button.addTouchEventListener(this.exchangeButtonTouchEvent ,this);
        this.addChild(button, ZOrder_UI);
    },
    exchangeButtonTouchEvent : function (sender, type) {
        var isNetworkConnected = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "isNetworkConnected", "()Z");

        if (isNetworkConnected) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    sender.setScale(1.1);
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    sender.setScale(1);
                    var exchangeCode = this.exchangeTextField.getString();
                    exchangeCode.toLowerCase();
                    if (exchangeCode) {
                        var self = this;
                        var ExchangeCode = AV.Object.extend("ExchangeCode");
                        var query = new AV.Query(ExchangeCode);
                        query.equalTo("code", exchangeCode);
                        query.find({
                            success: function (results) {
                                cc.log("Successfully retrieved " + results.length + " scores.");
                                if (results.length !== 0) {
                                    var object = results[0];
                                    var code = object.get("code");
                                    var hasUsed = object.get('hasBeenUsed');
                                    var isSingleTime = object.get("isSingleTime");
                                    var validTime = object.get("validTime");
                                    var today = new Date();
                                    var theUserHasUsed = cc.sys.localStorage.getItem(exchangeCode);
                                    if (theUserHasUsed) {
                                        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "这个兑换码已经使用过了，换个试试吧");
                                        cc.log("用过了(自己)")
                                    } else if (validTime < today) {
                                        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "这个兑换码已经过期了，换个试试吧");
                                        cc.log("过期");
                                        cc.log("isSingleTime" + isSingleTime);
                                        cc.log("hasUsed" + hasUsed);
                                    } else if (isSingleTime && hasUsed) {
                                        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "这个兑换码已经使用过了，换个试试吧");
                                        cc.log("用过了(被别人)");
                                    } else {
                                        var coin = parseInt(object.get('coin'));
                                        var myCoin = parseInt(cc.sys.localStorage.getItem("MyCoin")) || 0;
                                        myCoin += coin;
                                        cc.log(myCoin);
                                        cc.sys.localStorage.setItem("MyCoin", myCoin);
                                        cc.sys.localStorage.setItem(exchangeCode, true);
                                        object.save(null, {
                                            success: function (object) {
                                                object.set("hasBeenUsed", true);
                                                object.save();
                                            }
                                        });

//                                    self.createMask();
                                        var message = "哇这个兑换码有足足" + coin + "米粒！快去兑换课程吧！";
                                        var alertWindow = new EKAlertWindow(message, 20, 1, this, function () {
                                            alertWindow.runAction(cc.sequence(
                                                cc.scaleTo(0.2, 0).easing(cc.easeBackIn()),
                                                cc.callFunc(function () {
//                                                self.maskLayout.removeFromParent(true);
                                                    alertWindow.removeFromParent(true);
                                                })
                                            ));
                                        });
                                        self.addChild(alertWindow, 101);//self.maskLayout.getLocalZOrder()+1);

                                        self.miCoinButton.runAction(cc.sequence(
                                            cc.scaleTo(0.2, 1.05),
                                            cc.scaleTo(0.2, 1).easing(cc.easeBackOut())
                                        ));
                                        self.refreshMiCoinButton();
                                    }
                                } else {
                                    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "您输入的兑换码有误，请重新试试吧");
                                    cc.log("错误")
                                }
                                self.hasMoreApps = true;
                            },
                            error: function (error) {
                                cc.log("Error: " + error.code + " " + error.message);
                            }
                        })
                    }

                    if(isOpenAnySdk == true){
                    var agent = anysdk.AgentManager.getInstance();
                    var analytics_plugin = agent.getAnalyticsPlugin();
                    analytics_plugin.logEvent("Click the exchange button");
                    }
                    break;
                default:
                    break;
            }
        } else {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "请先连接网络");
        }
    }
});

var EKShopMain = cc.Scene.extend({
    onEnter:function (isShowMiCoin) {
        this._super();
        var layer = new EKShopMainLayer(isShowMiCoin);
        this.addChild(layer);
    }
});