/**
 * Created by apple on 14-8-16.
 */

GRAY_CANNOT_TOUCH = 522;
GRAY_CANMOVE = 544;
AUTOMOVE = 566;
OT_GRAY_AUTOMOVE = 503;
SPRITE_AUTO = 588;

var EKStoryMainLayer = EKSectionBasicLayer.extend({
    runningAnimations : null,
    storyState : null,
    tracer : null,
    story : null,
    ctor:function () {
        this._super();
        var self = this;
        var winSize = cc.director.getWinSize();

        cc.audioEngine.stopMusic(true);
        cc.audioEngine.playMusic("sounds/bgm_xiezimu.mp3", true);
        
        
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.startSession();
        }
//        if (winSize.width/winSize.height>1.77) {
//            var designHeigh = 568/(winSize.width/winSize.height);
//            cc.view.setDesignResolutionSize(568, designHeigh, cc.ResolutionPolicy.EXACT_FIT);
//            cc.director.setContentScaleFactor(2);
//        }

        var currentPlayingLevelIndex = EKCoreManager.getInstance().currentPlayingLevelIndex;
        this.runningAnimations = [];

        var currentWordString = EKLevelsName[currentPlayingLevelIndex];
        var storyNameOfCCB = "story1-" + parseInt(currentPlayingLevelIndex+1) + "/story1-" + parseInt(currentPlayingLevelIndex+1);

        if (winSize.width/winSize.height >= 1.77) {
            storyNameOfCCB = storyNameOfCCB + "_iphone5";
        }

        this.story = cc.BuilderReader.load(storyNameOfCCB, this);

        if (winSize.width/winSize.height >= 1.77) {
            this.story.setScale(512/568);
            this.story.setAnchorPoint(cc.p(0,0));
            this.story.setPosition(cc.p(0,0));
        }

        this.addChild(this.story, ZOder_GAME_MIDDLE_OBJ);
       // this.grayBackgroundPath = this.screenshot("story" + currentPlayingLevelIndex + ".png");
        this.stopAutoCCBActions(this.story);

        this.wordsToAssemble = EKCoreManager.getInstance().currentWordInfos()["words"];
        var latestLevelIndex = EKCoreManager.getInstance().latestUnlockedLevelAndSubLevel()[0];

        var currentPlayingLetter = EKLevelsName[currentPlayingLevelIndex];

        // Debug :
//        latestLevelIndex = 0;
        if ( latestLevelIndex > currentPlayingLevelIndex ) 
        {
            var key = "levelStoryPainted-" + latestLevelIndex;
            if (!cc.sys.localStorage.getItem(key)) 
            {
                this.storyState = 1;
                this.mapButton.setVisible(false);
                this.backButton.setVisible(false);
                this.startDrawing();
                cc.sys.localStorage.setItem(key, true);
            } 
            else
            {
                this.storyState = 2;
                if (EKCoreManager.getInstance().isFromFeiye) {
                	if(isOpenAnySdk == true){
                    analytics_plugin.logEvent("enter story: colorful", {"lesson" : currentPlayingLetter});
                	}
                    EKCoreManager.getInstance().isFromFeiye = false;
                    
                    this.setupAnimationTouchEvent();  //触控有小动画
                }
            }
        }
        else //最新课程
        {
            if (EKCoreManager.getInstance().isFromFeiye) {
            	if(isOpenAnySdk == true){
                analytics_plugin.logEvent("enter story: black and white", {"lesson" : currentPlayingLetter});
            	}
            }

            this.storyState = 0;
            this.findWhichNeedToTurnGray(this.story);
            this.story.getChildByTag(500).animationManager.runAnimationsForSequenceNamed("Default Timeline");

            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: false,
                onTouchBegan : function() {
                    return true;
                },
                onTouchMoved : function() {
                    return true;
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width, s.height);
                    if (cc.rectContainsPoint(rect, locationInNode)) {

                        var toPos;
                        if (winSize.width/winSize.height>1.77) {
                            toPos = cc.p(target.x-target.getContentSize().width/2 * (target.x/winSize.width), target.y-target.getContentSize().height/2 * (target.y/winSize.height));
                        } else {
                            toPos = cc.p(target.x, target.y);
                        }

                        var clip = maskWithCircle(ZOrder_UI+3, true, cc.p(winSize.width/2, winSize.height/2), toPos, function () {
                            self.shouldJumpToWordWritting();
                        });
                        self.addChild(clip, ZOrder_UI+3);
                    }
                }
            }, this.story.getChildByTag(500));

            this.mapButton.setVisible(false);
            
            //this.setupAnimationTouchEvent();
        }
        
        return true;
    },
    stopAutoCCBActions : function(node) {
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            child.stopAllActions();
            this.stopAutoCCBActions(child);
        }
    },
    findWhichNeedToTurnGray : function(node) {
        cc.log("findWhichNeedToTurnGray");
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            if (child.getTag() == GRAY_CANNOT_TOUCH || child.getTag() == GRAY_CANMOVE || child.getTag() == AUTOMOVE || child.getTag() == AUTOMOVE) {
                this.spriteTurnGray(child);
            }
            if (child.getChildren().length > 0) {
                this.findWhichNeedToTurnGray(child);
            }
        }
    },
    spriteTurnGray : function(node) {
        this.changeShader("gray", node);
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            if( child.constructor.name == "Sprite" || child.constructor.name == "EKBasicNode" ) {
                this.changeShader("gray", child);
            }
            if (child.getChildren().length > 0) {
                this.spriteTurnGray(child);
            }
        }
    },
    changeShader : function(shaderName, sprite) {
        cc.log("changeShader");
        var shader = cc.GLProgram.create(shaderName+".vsh", shaderName+".fsh");
        shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
        shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);

        shader.link();
        shader.updateUniforms();
        sprite.setShaderProgram(shader);
    },
    startDrawing : function() {
        var winSize = cc.director.getWinSize();

        this.tracer = cc.Sprite.create("magical_sticker.png");
        this.addChild(this.tracer, ZOder_GAME_FRONT_OBJ);
        this.tracer.setPosition(winSize.width/2, winSize.height/2);

        //var grayBackgroundPath = this.screenshot("story.png");
        
        
        var render = new cc.RenderTexture(winSize.width, winSize.height, cc.Texture2D.PIXEL_FORMAT_RGBA8888);
        render.begin();
        this.story.visit();
        render.end();

        this.grayBackground = render.getSprite();
        this.changeShader("gray", this.grayBackground);
        this.grayBackground.setPosition(winSize.width/2, winSize.height/2);
        this.grayBackground.retain();

        this.drawingCanvas = cc.RenderTexture.create(winSize.width, winSize.height);
        this.drawingCanvas.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(this.drawingCanvas, this.story.getLocalZOrder()+1);

        this.eraser = cc.DrawNode.create();
        this.eraser.drawDot(cc.p(0, 0), 17, cc.color(100, 100, 100, 255));
        this.eraser.retain();
        this.eraser1 = cc.DrawNode.create();
        this.eraser1.drawDot(cc.p(0, 0), 17, cc.color(100, 100, 100, 255));
        this.eraser1.setRotation(45);
        this.eraser1.retain();

        this.drawingCanvas.begin();
        this.grayBackground.visit();
        this.drawingCanvas.end();

        this.brushParticle = cc.ParticleSystem.create("par_trace01.plist");
        this.addChild(this.brushParticle, ZOder_GAME_FRONT_OBJ+5);
        this.brushParticle.setPosition(winSize.width/2, winSize.height/2);
        this.brushParticle.setTotalParticles(0);

        this.rectArray = [];
        var posCount = 100;
        var ct = Math.sqrt(posCount);
        var w = winSize.width/ct;
        var h = winSize.height/ct;
        for (var r=0; r<ct; r++) {
            for (var c=0; c<ct; c++) {
                var rect = cc.rect(r*w, c*h, w, h);
                rect.hasBeenTouched = false;
                this.rectArray.push(rect);
            }
        }
        this.rectHasBeenTouchedNumber = 0;

        this.setupTouchEvent();
    },
    screenshot : function (fileName) {

        var winSize = cc.director.getWinSize();
        var render = new cc.RenderTexture(winSize.width, winSize.height, cc.Texture2D.PIXEL_FORMAT_RGBA8888);
        render.begin();
        this.story.visit();
        render.end();

        var imgPath = jsb.fileUtils.getWritablePath();
        var result = render.saveToFile(fileName, cc.IMAGE_FORMAT_PNG);
        if (result) {
            imgPath += fileName;
            return imgPath;
        }
        return "";
    },
    shouldJumpToWordWritting : function() {
        cc.log("shouldJumpToWordWritting");
        EKCoreManager.getInstance().isInNormalProcess = true;
        EKCoreManager.getInstance().gotoNextSectionAuto();
    },
    
    //涂抹事件
    setupTouchEvent : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var location = touch.getLocation();
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, winSize.width, winSize.height);

                cc.log(location.x + " " + location.y + " " + s.width + " " + s.height);

                if (cc.rectContainsPoint(rect, location)) {
                    self.brushParticle.setTotalParticles(50);
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var location = touch.getLocation();
                self.tracer.setPosition(location);
                self.eraser.setPosition(location);
                self.eraser.setBlendFunc(cc.ZERO, cc.ZERO);
                self.eraser1.setPosition(location);
                self.eraser1.setBlendFunc(cc.ZERO, cc.ZERO);
                self.drawingCanvas.begin();
                self.eraser.visit();
                self.eraser1.visit();
                self.drawingCanvas.end();

                self.brushParticle.setPosition(self.tracer.getPosition());

                for (var i=0; i<self.rectArray.length; i++) {
                    var rect = self.rectArray[i];
                    if (cc.rectContainsPoint(rect, location) && !rect.hasBeenTouched) {
                        rect.hasBeenTouched = true;
                        self.rectHasBeenTouchedNumber += 1;
                        cc.log("rectHasBeenTouchedNumber " + self.rectHasBeenTouchedNumber);
                    }
                }
            },
            onTouchEnded: function (touch, event) {
                self.brushParticle.setTotalParticles(0);
                self.tracer.runAction(
                    cc.moveTo(0.4, cc.p(winSize.width/2, winSize.height/2)).easing(cc.easeBackOut())
                );
                if (self.rectHasBeenTouchedNumber > 60) {
//                    cc.audioEngine.playEffect("sounds/effect/show_color.mp3");
                    self.drawingEnds();
                    cc.eventManager.removeListener(listener);
                }
            }
        });
        cc.eventManager.addListener(listener.clone(), this.drawingCanvas);
    },
    
    //结束涂抹
    drawingEnds : function() {
        var self = this;
        var latestLevelIndex = EKCoreManager.getInstance().latestUnlockedLevelAndSubLevel()[0];
        var key = "levelStoryPainted-" + latestLevelIndex;
        cc.sys.localStorage.setItem(key, true);

        this.brushParticle.removeFromParent(true);
        this.tracer.runAction(cc.spawn(
            cc.fadeOut(0.4),
            cc.scaleTo(0.4, 1.3).easing(cc.easeBackOut())
        ));
        this.scheduleOnce(function(){
            self.restoreStory();  //恢复场景动画
        }, 0.6)
    },
    restoreStory : function () {
        var self = this;
        this.grayBackground.removeFromParent(true);
        this.tracer.removeFromParent(true);
        this.drawingCanvas.removeFromParent(true);

        this.mapButton.setScale(0);
        this.mapButton.setVisible(true);
        this.backButton.setScale(0);
        this.backButton.setVisible(true);
        this.backButton.runAction(
            cc.scaleTo(0.5, 1)
        );
        this.mapButton.runAction(
            cc.scaleTo(0.5, 1)
        );
        this.schedule(function(){
            self.animationAuto();
        }, 12);

        this.activeAllAnimationsForOnceInNode(this.story);
        this.setupAnimationTouchEvent();
    },
    activeAllAnimationsForOnceInNode : function (node) {
        var children = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            if (child.animationManager && child.controllerName !== "EKSwitchNode" && child.getTag() !== 500 && child.getTag() !== 522)
            {
                child.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                var sunChildren = child.getChildren();
                for (var j=0; j<sunChildren.length; j++)
                {
                    var subChild = sunChildren[j];
                    if (subChild.animationManager) 
                    {
                        subChild.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    }
                }
            }
        }
    },
    animationAuto : function () {
        var children = this.story.getChildren();
        var childrenCanMove = [];
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            cc.log(i + " " + child.animationManager);
            if (child.animationManager) {
                childrenCanMove.push(child);
            }
        }
        cc.log("childrenCanMove " + childrenCanMove.length + " " + Math.random()*childrenCanMove.length);
        var n = Math.floor(Math.random()*childrenCanMove.length);
        cc.log("n " + n);
        var childCanMove = childrenCanMove[n];
        cc.log("controllerName " + childCanMove.controllerName);
        if (childCanMove.controllerName === "EKSwitchNode") {
            if (childCanMove.state === "off") {
                childCanMove.animationManager.runAnimationsForSequenceNamed("on");
                childCanMove.state = "on";
            } else {
                childCanMove.animationManager.runAnimationsForSequenceNamed("off");
                childCanMove.state = "off";
            }
        } else {
            if (childCanMove.getTag() !== 500) {
                childCanMove.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                var sunChildren = childCanMove.getChildren();
                for (var i=0; i<sunChildren.length; i++) {
                    var subChild = sunChildren[i];
                    if (subChild.animationManager) {
                        subChild.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    }
                }
            } else {
                this.animationAuto();
            }
        }
    },
    getRect : function (object) {
        var s = object.getContentSize();
        var rect;
        if ( s.width !==0 ) {
            rect = cc.rect(0, 0, s.width, s.height);
        } else {
            var children = target.getChildren();
            rect = cc.rect(-20, -20, 40, 40);
        }
        return rect;
    },
    //播放动画
    playCCBAnimation : function (target) {
        if (target.controllerName === "EKSwitchNode") 
        {
            cc.log("target.condition " + target.condition);
            if (target.condition === "off") {
                target.animationManager.runAnimationsForSequenceNamed("on");
                target.condition = "on";
            } else {
                target.animationManager.runAnimationsForSequenceNamed("off");
                target.condition = "off";
            }
        } 
        else
        {
            target.animationManager.runAnimationsForSequenceNamed("Default Timeline");
            var children = target.getChildren();

            for (var i=0; i<children.length; i++) {
                var child = children[i];
                if (child.animationManager) 
                {
                    if (child.getTag() !== 531) 
                    {
                        child.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        this.runAnimations(child);
                    }
                    else
                    {
                        child.getChildByTag(530).animationManager.runAnimationsForSequenceNamed("Default Timeline");
                    }
                } 
                else if (child.getChildren().length > 0) 
                {
                    var subChild = child.getChildren()[0];
                    if (subChild.animationManager) {
                        subChild.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        if (subChild.getTag() === 529) 
                        {
                            this.scheduleOnce(function () {
                                subChild.animationManager.runAnimationsForSequenceNamed("stop");
                            }, 5.6);
                        }
                        this.runAnimations(subChild);

                        if (subChild.getChildren) {
                            var subsubChildren = subChild.getChildren();
                            cc.log("subsubChildren " + subsubChildren.length);
                            for (var j=0; j<subsubChildren.length; j++) {
                                var subsubChild = subsubChildren[j];
                                if (subsubChild.animationManager) {
                                    subsubChild.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                                } else {
                                    if (subsubChildren.getChildren) {
                                        var subsubsubChildren = subsubChildren.getChildren();
                                        cc.log("subsubsubChildren " + subsubsubChildren.length);
                                        for (var jj=0; jj<subsubsubChildren.length; jj++) {
                                            var subsubsubChild = subsubsubChildren[jj];
                                            if (subsubsubChild.animationManager) {
                                                subsubsubChild.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            if (target.getTag() === 500) {
                this.scheduleOnce(function(){
                    target.stopAllActions();
                    this.stopAutoCCBActions(target);
                }, 1);
            }

        }
    },
    isObjectRectContainsPoint : function (object, point) {
        var locationInNode = object.convertToNodeSpace(point);
        var s = object.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        cc.log("rect width= " + rect.width + " height = " + rect.height + "point x = " + locationInNode.x + " y = " + locationInNode.y);
        return cc.rectContainsPoint(rect, locationInNode);
    },
    
    
    shoudPlayAnimation : function(target, position)
    {
    	if(target)
    	{
    		if(this.isObjectRectContainsPoint(target, position))
    		{
    			return true;
    		}
    		else
    		{
    			var result = false;
    			var children = target.getChildren();
    			for(var i=0; i<children.length; i++)
    			{
    				if(this.shoudPlayAnimation(children[i], position))	
    				{
    					return true;
    				}
    			}
    			return result;
    		}
    	}
    	else
    	{
    		return false;
    	}
    },
    
    setupAnimationTouchEvent : function () {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {

                var target = event.getCurrentTarget();
                
                if(self.shoudPlayAnimation(target, touch.getLocation()))
                {
                	self.playCCBAnimation(target);
                }
                
//                if ( self.isObjectRectContainsPoint(target, touch.getLocation()) ) 
//                {
//                    self.playCCBAnimation(target);  //播放动画
//                    return true;
//                } 
//                else 
//                {
//                    var children = target.getChildren();  //一层子节点
//                    for (var i=0; i<children.length; i++) {
//                        var child = children[i];
//                        if ( self.isObjectRectContainsPoint(child, touch.getLocation()) ) 
//                        {
//                            self.playCCBAnimation(target);
//                            return true;
//                        } 
//                        else 
//                        {
//                            var subChildren = child.getChildren();  //二层子节点
//                            for (var i=0; i<subChildren.length; i++) {
//                                var subChild = subChildren[i];
//                                if ( self.isObjectRectContainsPoint(subChild, touch.getLocation()) ) 
//                                {
//                                    self.playCCBAnimation(target);
//                                    return true;
//                                } 
//                                else 
//                                {
//                                    var subSubChildren = subChild.getChildren();  //三层子节点
//                                    for (var ii=0; ii<subSubChildren.length; ii++) {
//                                        var subSubChild = subSubChildren[ii];
//                                        if ( self.isObjectRectContainsPoint(subSubChild, touch.getLocation()) ) 
//                                        {
//                                            self.playCCBAnimation(target);
//                                            return true;
//                                        } 
//                                        else 
//                                        {
////                                            var subSubSubChildren = subSubChild.getChildren();
////                                            for (var iii=0; iii<subSubSubChildren.length; iii++) {
////                                                var subSubSubChild = subSubSubChildren[ii];
////                                                if ( self.isObjectRectContainsPoint(subSubSubChild, touch.getLocation()) ) {
////                                                    self.playCCBAnimation(target);
////                                                    return true;
////                                                }
////                                            }
//                                        }
//                                    }
//                                }
//                            }
//                        }
//                    }
//                }
                return false;
            }
        });

        var currentPlayingLevelIndex = EKCoreManager.getInstance().currentPlayingLevelIndex;
        var latestLevelIndex = EKCoreManager.getInstance().latestUnlockedLevelAndSubLevel()[0];

        var children = this.story.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            if (child.animationManager)
            {
                if (latestLevelIndex > currentPlayingLevelIndex)  //玩重复的课程
                {
                    if (child.getTag() === 566) 
                    {
                        child.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                        this.runAnimations(child);
                    } 
                    else 
                    {
                        cc.eventManager.addListener(listener.clone(), child);
                    }
                } 
                else  //玩新的课程
                {
                    if (child.getTag() === 501 || child.getTag() === 502 || child.getTag() === 503) 
                    {
                        cc.log("child " + child.getTag());
                        cc.eventManager.addListener(listener.clone(), child);
                    }
                }
            }
        }
    },
    runAnimations : function (node) {
        var children  = node.getChildren();
        for (var i=0; i<children.length; i++) {
            var child = children[i];
            if (child.animationManager) {
                child.animationManager.runAnimationsForSequenceNamed("Default Timeline");
                this.runAnimations(child);
            } else {
                this.runAnimations(child);
            }
        }
    },

    "miyaTag530StopAndWaveHand" : function () {
        var node = this.story.getChildByTag(531);
        var miya = node.getChildren()[0].getChildren()[0];
        miya.animationManager.runAnimationsForSequenceNamed("stop");
    },

    onExit : function () {
        this._super();
        if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var analytics_plugin = agent.getAnalyticsPlugin();
        analytics_plugin.stopSession();
        }
    }
});

var EKStoryMain = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new EKStoryMainLayer();
        this.addChild(layer);
    }
});